<?php

namespace Util;

interface Query
{

  // ----------------------- VERIFICATIONS
  const GET_USER = "
      SELECT 
        CDOPERADOR,
        NMOPERADOR,
        CDSENHAOPERWEB
      FROM 
        OPERADOR
      WHERE
        CDOPERADOR = :CDOPERADOR OR
        DSEMAILOPER = :DSEMAILOPER
    ";

  const GET_FILIAL = "
    	SELECT CDFILIAL
    	  FROM FILIAL
    	 WHERE CDFILIAL = :CDFILIAL
    ";

  const GET_FILIAIS = "
    	SELECT CDFILIAL
    	  FROM FILIAL
    ";

  const GET_LOJA = "
    	SELECT CDLOJA
    	  FROM LOJA
    	 WHERE CDFILIAL = :CDFILIAL
    	   AND CDLOJA   = :CDLOJA
    ";

  const GET_CAIXA = "
    	SELECT CDCAIXA
    	  FROM CAIXA
    	 WHERE CDFILIAL = :CDFILIAL
    	   AND CDLOJA   = :CDLOJA
    	   AND CDCAIXA  = :CDCAIXA
    ";

  const GET_CONSUMER = "
    	SELECT CDCONSUMIDOR
    	  FROM CONSUMIDOR
    	 WHERE CDCLIENTE    = :CDCLIENTE
    	   AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

  const GET_CITY_CODE = "
        SELECT CDMUNICIPIO 
          FROM MUNICIPIO
         WHERE CDMUNICIBGE = :CDMUNICIBGE
           AND SGESTADO    = :SGESTADO  
    ";

  const GET_IDCONTROPROD = "
        SELECT IDCONTROPROD
          FROM LOJA
         WHERE CDFILIAL = :CDFILIAL
           AND CDLOJA = :CDLOJA
    ";

  const GET_MONEY = "
        SELECT MIN(CDTIPORECE) AS CDTIPORECE
          FROM TIPORECE
         WHERE IDTIPORECE = '4'
    ";

  const GET_THE_THING = "
      SELECT CDSETOR
        FROM PRODLOJA
       WHERE CDFILIAL  = :CDFILIAL
         AND CDLOJA    = :CDLOJA
         AND CDPRODUTO = :CDPRODUTO
    ";

  const GET_OBSERVATION_AS_PRODUCT = "
      SELECT CDPRODUTO
        FROM OCORRENCIA
       WHERE CDGRPOCOR = :CDGRPOCOR
         AND CDOCORR   = :CDOCORR 
    ";

  const GET_OBSERVATION_INFO = "
      SELECT IDCONTROLAOBS, CDPRODUTO
        FROM OCORRENCIA
       WHERE CDGRPOCOR = :CDGRPOCOR
         AND CDOCORR   = :CDOCORR 
         AND IDCONTROLAOBS = 'A'
    ";

  const GET_BILL_EXT_ID = "
      SELECT NRCOMANDAEXT
        FROM COMANDAVEN
       WHERE NRVENDAREST = :NRVENDAREST
         AND NRCOMANDA   = :NRCOMANDA
         AND CDFILIAL    = :CDFILIAL
    ";

  const GET_PRODUCT_IS_AVAILABLE = "
      SELECT CDPRODUTO
        FROM PRODBLOQVND
       WHERE CDFILIAL  = :CDFILIAL
         AND CDPRODUTO = :CDPRODUTO
         AND CDLOJA    = :CDLOJA
    ";

  const GET_SUBSIDIARY_ADDRESS = "
      SELECT CDPAIS, SGESTADO, CDMUNICIPIO
        FROM ENDEFILI
       WHERE CDFILIAL     = :CDFILIAL
         AND IDTPENDEFILI = :IDTPENDEFILI 
    ";

  const GET_TABLE_STATUS = "
  SELECT TOP 1 IDSTMESAAUX 
          FROM MESA
         WHERE CDFILIAL    = :CDFILIAL
           AND CDLOJA      = :CDLOJA
           AND NRMESA IN (SELECT DISTINCT NRMESA
                             FROM MESA
                            WHERE CDFILIAL = :CDFILIAL
                              AND CDLOJA   = :CDLOJA
                              AND NRMESA   = :NRMESA
                            UNION
                           SELECT NRMESA
                             FROM JUNCAOMESA JM, MESAJUNCAO MJ
                            WHERE JM.CDFILIAL  = :CDFILIAL
                              AND JM.CDFILIAL  = MJ.CDFILIAL
                              AND JM.CDLOJA    = :CDLOJA
                              AND JM.NRJUNMESA = MJ.NRJUNMESA
                              AND JM.CDLOJA    = MJ.CDLOJA
                              AND JM.NRJUNMESA = (SELECT NRJUNMESA
                                                    FROM MESAJUNCAO
                                                   WHERE CDFILIAL = :CDFILIAL
                                                     AND CDLOJA   = :CDLOJA
                                                     AND NRMESA   = :NRMESA))
    ";

  const GET_POSITION_STATUS = "
     SELECT TOP 1 IDSTLUGARMESA
             FROM ITCOMANDAVEN
            WHERE CDFILIAL    = :CDFILIAL
              AND NRVENDAREST = :NRVENDAREST
              AND NRCOMANDA   = :NRCOMANDA
              AND NRLUGARMESA = :NRLUGARMESA  

    ";

  const GET_STORE_TAX = "
      SELECT IDCOMISVENDA,IDTRATTAXASERV, VRCOMISVENDA, 
             CDPRODTAXASERV,CDPRODCOUVER, IDCOUVERART 
        FROM LOJA
       WHERE CDFILIAL = :CDFILIAL  
         AND CDLOJA   = :CDLOJA 
    ";

  const GET_BILL_LAST_ITEM = "
      SELECT *
        FROM ITCOMANDAVEN
       WHERE NRVENDAREST = :NRVENDAREST
         AND NRCOMANDA   = :NRCOMANDA
         AND CDFILIAL    = :CDFILIAL
    ORDER BY NRPRODCOMVEN DESC      
    ";

  const UPDATE_BILL_SERVICE_TAX = "
      UPDATE COMANDAVEN
         SET IDUTILTXSERV = :IDUTILTXSERV,
             VRCOMISVENDE = :VRCOMISVENDE
       WHERE CDFILIAL     = :CDFILIAL
         AND NRVENDAREST  = :NRVENDAREST
         AND NRCOMANDA    = :NRCOMANDA
    ";

  const GET_OPEN_POSITIONS = "
      SELECT NRLUGARMESA
        FROM ITCOMANDAVEN
       WHERE CDFILIAL    = :CDFILIAL
         AND NRVENDAREST = :NRVENDAREST
         AND NRCOMANDA   = :NRCOMANDA
         AND IDSTLUGARMESA <> 'P' 
    ";

  const GET_DELIVERY_TIME = "
      SELECT (NVL(HRTEMPOENTREGA,0) + NVL(HRTEMPOATRASO,0)) VRTEMPOENTREGA
        FROM LOJA
       WHERE CDLOJA   = :CDLOJA
         AND CDFILIAL = :CDFILIAL  
    ";

  const GET_MIN_TIME = "
      SELECT (NVL(HRTEMPOENTREGA,0) + NVL(HRTEMPOATRASO,0) + NVL(HRTEMPOPREPARO,0)) VRTEMPOMIN
        FROM LOJA
       WHERE CDLOJA   = :CDLOJA
         AND CDFILIAL = :CDFILIAL  
    ";

  const GET_DELIVERY_FEE = "
      SELECT NVL(VRTXENTRFILIAR,0) VRTXENTRFILIAR
        FROM FILIALAREA
       WHERE CDFILIAL = :CDFILIAL
         AND CDAREA   = :CDAREA  
    ";

  const GET_STORE_DETAILS = "
      SELECT L.CDLOJA, L.NRMESAPADRAO AS NRMESA, L.IDPOSOBSPED, L.IDLUGARMESA
        FROM LOJA L
       WHERE CDFILIAL = :CDFILIAL
         AND CDLOJA   = :CDLOJA  
    ";

  const GET_BALANCE_VALUE = "
      SELECT VRSALDCONFAM 
        FROM SALDOCONS
       WHERE CDCLIENTE   = :CDCLIENTE
        AND CDCONSUMIDOR = :CDCONSUMIDOR
        AND CDFAMILISALD = :CDFAMILISALD
    ";

  const GET_POSITION_ITEMS = "
      SELECT CDPRODUTO, VRDESCCOMVEN
        FROM ITCOMANDAVEN
       WHERE CDFILIAL    = :CDFILIAL
         AND NRVENDAREST = :NRVENDAREST
         AND NRCOMANDA   = :NRCOMANDA
         AND NRLUGARMESA = :NRLUGARMESA
         AND IDSTPRCOMVEN <> '6'
    ";

  const GET_DEFAULT_CONSUMER = "
      SELECT CDCLIENTE 
        FROM PARAVEND
       WHERE CDFILIAL = :CDFILIAL 
    ";

  const GET_TOTRAVEL_OBSERVATION = "
      SELECT CDGRPOCOR, CDOCORR, DSOCORR
  	  	FROM OCORRENCIA
		   WHERE DSOCORR LIKE '%VIAGEM'
    ";
  const GET_DRIVETHRU_OBSERVATION = "
      SELECT CDGRPOCOR, CDOCORR, DSOCORR
  	  	FROM OCORRENCIA
		   WHERE DSOCORR LIKE '%DRIVE THRU%'
    ";

  const GET_TABLE_POSITIONS = "
      SELECT NRLUGARMESA
        FROM ITCOMANDAVEN
       WHERE CDFILIAL    = :CDFILIAL
         AND NRVENDAREST = :NRVENDAREST 
    ";

  const UPDATE_VENDAREST_CONSUMER = "
      UPDATE VENDAREST 
         SET CDCLIENTE    = :CDCLIENTE,
             CDCONSUMIDOR = :CDCONSUMIDOR
       WHERE CDFILIAL    = :CDFILIAL
         AND NRVENDAREST = :NRVENDAREST
    ";

  const GET_PAYMENT_ID = "
      SELECT IDTIPORECE 
        FROM TIPORECE
       WHERE CDTIPORECE = :CDTIPORECE
    ";

  const GET_TOTRAVELOBS_ORDER = "
      SELECT CDGRPOCOR, CDOCORR
        FROM OBSITCOMANDAVEN
       WHERE CDGRPOCOR   = :CDGRPOCOR
         AND CDOCORR     = :CDOCORR
         AND NRVENDAREST = :NRVENDAREST
         AND NRCOMANDA   = :NRCOMANDA
         AND CDFILIAL    = :CDFILIAL
    ";

  const GET_DTABERCAIX = "
        SELECT MAX(DTABERCAIX)AS DTABERCAIX
          FROM TURCAIXA
         WHERE CDFILIAL = :CDFILIAL
           AND CDCAIXA = :CDCAIXA
           AND DTFECHCAIX IS NULL
    ";

  const GET_PAYMENT_VALUE = "
      SELECT SUM(VRMOVIVENDDLV) VRMOVIVENDDLV
        FROM MOVCAIXADLV
       WHERE CDFILIAL = :CDFILIAL
         AND NRVENDAREST = :NRVENDAREST
         AND IDTIPOMOVIVEDLV = 'E'
    ";

  const GET_TOTRAVELOBS_SALE = "
      SELECT CDGRPOCOR, CDOCORR
        FROM OBSITEMVENDA
       WHERE CDGRPOCOR   = :CDGRPOCOR
         AND CDOCORR     = :CDOCORR
         AND NRSEQVENDA  = :NRSEQVENDA
         AND CDFILIAL    = :CDFILIAL
    ";

  const GET_CONSUMER_LIMIT = "
      SELECT IDVERSALDCON, VRLIMCREDCONS
        FROM CONSUMIDOR
       WHERE CDCLIENTE    = :CDCLIENTE
         AND CDCONSUMIDOR = :CDCONSUMIDOR 
    ";

  const GET_ORDER_STATUS = "
      SELECT V.IDSINCMSDE, C.IDSTCOMANDA, C.DTSAIDACMD, C.DTCHEGACMD
        FROM COMANDAVEN C
        JOIN VENDAREST V
          ON C.CDFILIAL = V.CDFILIAL
         AND C.NRVENDAREST = V.NRVENDAREST
         AND C.CDFILIAL     = :CDFILIAL
         AND C.NRCOMANDA    = :NRCOMANDA
         AND C.NRCOMANDAEXT = :NRCOMANDAEXT
    ORDER BY V.DTHRABERMESA DESC
    ";

  const SET_ORDER_ARRIVAL = "
      UPDATE COMANDAVEN
         SET DTCHEGACMD = TO_DATE(:DTCHEGACMD, 'DD/MM/YYYY HH24:MI:SS')
       WHERE NRCOMANDA = :NRCOMANDA
         AND NRCOMANDAEXT = :NRCOMANDAEXT
         AND CDFILIAL = :CDFILIAL
    ";

  const GET_NRVENDAREST = "
      SELECT CV.NRVENDAREST, VE.CDCLIENTE, VE.CDCONSUMIDOR, CV.VRACRCOMANDA, VRDESCFID, CV.CDLOJA
        FROM COMANDAVEN CV
        JOIN VENDAREST VE
          ON CV.CDFILIAL = VE.CDFILIAL
         AND CV.NRVENDAREST = VE.NRVENDAREST
       WHERE CV.CDFILIAL = :CDFILIAL
         AND NRCOMANDA = :NRCOMANDA
    ";

  const CANCEL_PRODUCTS = "
      UPDATE ITCOMANDAVEN
         SET IDSTPRCOMVEN = '6'
       WHERE CDFILIAL = :CDFILIAL
         AND NRVENDAREST =:NRVENDAREST
         AND NRCOMANDA =:NRCOMANDA
    ";

  const INSERT_OBSITCOMANDAVEN = " 
    	INSERT INTO	OBSITCOMANDAVEN	(
    	    CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, CDOCORR, CDGRPOCOR
        )
		VALUES (
		 	:CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :CDOCORR, :CDGRPOCOR
		)
	";

  const VALIDATE_PAYMENT = "
	  SELECT CDTIPORECE 
	    FROM TIPORECE 
     WHERE CDTIPORECE = :CDTIPORECE
    ";

  const INSERT_KDSOPERACAOTEMP = "
    INSERT INTO KDSOPERACAOTEMP(NRSEQOPERACAO, DSOPERACAO)
      VALUES(:NRSEQOPERACAO, :DSOPERACAO)
    ";

  const UPDATE_CONSUMER_PHONE = "
    UPDATE CONSUMIDOR 
       SET NRTELECONS = :NRTELECONS
     WHERE CDCLIENTE = :CDCLIENTE
       AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

  const GET_BASEURL = "
    SELECT CDURLWSEXTCONS
      FROM PARAVEND
     WHERE (CDFILIAL = :CDFILIAL OR NVL(:CDFILIAL,'T') = 'T')
       AND CDURLWSEXTCONS IS NOT NULL
    ";

  const SQL_GET_BASEURL = "
    SELECT CDURLWSEXTCONS
      FROM PARAVEND
     WHERE (CDFILIAL = :CDFILIAL OR ISNULL(:CDFILIAL,'T') = 'T')
       AND CDURLWSEXTCONS IS NOT NULL
    ";

  const GET_CONSUMERTYPE = "
    SELECT CDTIPOCONS 
      FROM CONSUMIDOR
     WHERE CDCLIENTE = :CDCLIENTE
       AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

  const GET_CREDITPAYMENT = "
    SELECT CDTIPORECE 
      FROM TIPORECE 
     WHERE (IDMOSTRARECE = 'S' OR IDMOSTRARECE IS NULL) 
       AND IDTIPORECE = '9'
    ";

  const DELETE_ITCOMANDAVEN = "
    DELETE FROM ITCOMANDAVEN
     WHERE CDFILIAL = :CDFILIAL
       AND NRCOMANDA = :NRCOMANDA
       AND NRVENDAREST = :NRVENDAREST
    ";

  const DELETE_COMANDAVEN = "
    DELETE FROM COMANDAVEN
     WHERE CDFILIAL = :CDFILIAL
       AND NRCOMANDA = :NRCOMANDA
       AND NRVENDAREST = :NRVENDAREST
    ";

  const DELETE_VENDAREST = "
    DELETE FROM VENDAREST
     WHERE CDFILIAL = :CDFILIAL
       AND NRVENDAREST = :NRVENDAREST
    ";

  const GET_PAYMENTS = "
    SELECT NRSEQMOVDLV
      FROM MOVCAIXADLV 
     WHERE NRVENDAREST = :NRVENDAREST
       AND CDFILIAL = :CDFILIAL 
    ";

  const GET_CONSUMER_FIDEL_INFO = '
    SELECT CASE TP.IDPERALTDESCFID 
      WHEN \'S\' THEN \'true\'
      ELSE \'false\' 
       END AS "usesPartialValue", SD.CDFAMILISALD AS "cdfamilisald"
      FROM SALDOCONS SD
      LEFT JOIN CONSUMIDOR CO
        ON CO.CDCLIENTE = SD.CDCLIENTE
       AND CO.CDCONSUMIDOR = SD.CDCONSUMIDOR
      LEFT JOIN TIPOCONS TP
        ON TP.CDTIPOCONS = CO.CDTIPOCONS
     WHERE SD.CDCLIENTE = :P_CDCLIENTE
       AND SD.CDCONSUMIDOR = :P_CDCONSUMIDOR
       AND SD.CDFAMILISALD = :P_CDFAMILISALD
    ';

  const GET_SALES_INFO = "
      SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.CDLOJA, TO_CHAR(V.DTVENDA, 'DD/MM/YYYY HH24:MI:SS') DTVENDA, CV.NRCOMANDA, V.IDORIGEMVENDA, CV.VRACRCOMANDA, V.VRDESCVENDA,
            V.DSOBSCOMANDA, V.NRACESSONFCE, V.NRNOTAFISCALCE, V.NRINSCRCONS,
            CASE 
            WHEN V.DTHRAGENDADA IS NULL THEN 'N'
            ELSE 'S' END AS ISSCHEDULED, V.DTHRAGENDADA, V.DSENDECONSVENDA, V.DSBAIRRO, V.NRENDECONSVENDA, V.DSCOMPLENDCOVEN,
            V.DSREFENDCONSVEN, V.SGESTADO,  V.NRCEPCONSVENDA, V.NRFONECLIE, MU.NMMUNICIPIO
       FROM VENDA V
       JOIN VENDAREST VE
         ON VE.NRVENDARESTAUX = V.NRVENDAREST
        AND VE.CDFILIAL = V.CDFILIAL
        AND VE.NRVENDAREST = V.NRVENDARESTORA
       JOIN COMANDAVEN CV
         ON CV.NRVENDAREST = VE.NRVENDAREST
        AND CV.CDFILIAL = VE.CDFILIAL
  LEFT JOIN MUNICIPIO MU
         ON MU.CDMUNICIPIO = V.CDMUNICIPIO
      WHERE V.DTVENDA BETWEEN TO_DATE(:INITIALDATE, 'DD/MM/YYYY HH24:MI:SS') AND TO_DATE(:FINALDATE, 'DD/MM/YYYY HH24:MI:SS')
        AND (V.NRINSCRCONS = :CPF OR NVL(:CPF,'T') = 'T')
        AND V.NRVENDARESTORA IS NOT NULL
    UNION
     SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.CDLOJA, TO_CHAR(V.DTVENDA, 'DD/MM/YYYY HH24:MI:SS') DTVENDA, '' AS NRCOMANDA, V.IDORIGEMVENDA, 0 AS VRACRCOMANDA, V.VRDESCVENDA,
            V.DSOBSCOMANDA, V.NRACESSONFCE, V.NRNOTAFISCALCE, V.NRINSCRCONS,
            CASE 
            WHEN V.DTHRAGENDADA IS NULL THEN 'N'
            ELSE 'S' END AS ISSCHEDULED, V.DTHRAGENDADA, V.DSENDECONSVENDA, V.DSBAIRRO, V.NRENDECONSVENDA, V.DSCOMPLENDCOVEN,
            V.DSREFENDCONSVEN, V.SGESTADO,  V.NRCEPCONSVENDA, V.NRFONECLIE, MU.NMMUNICIPIO
       FROM VENDA V
       LEFT JOIN MUNICIPIO MU
         ON MU.CDMUNICIPIO = V.CDMUNICIPIO
      WHERE V.DTVENDA BETWEEN TO_DATE(:INITIALDATE, 'DD/MM/YYYY HH24:MI:SS') AND TO_DATE(:FINALDATE, 'DD/MM/YYYY HH24:MI:SS')
        AND (V.NRINSCRCONS = :CPF OR NVL(:CPF,'T') = 'T')
        AND V.NRVENDARESTORA IS NULL
   ORDER BY DTVENDA DESC
    ";

  const GET_VALUES_INFO = "
    SELECT SUM(VRUNITVEND * QTPRODVEND + VRACRITVEND - VRDESITVEND) TOTAL,
           SUM(VRUNITVEND * QTPRODVEND) VALORITEMS, SUM(VRACRITVEND) ACRESCIMO,
           SUM(VRDESITVEND) DESCONTO
    FROM ITEMVENDA
   WHERE CDFILIAL = :CDFILIAL
     AND CDCAIXA = :CDCAIXA
     AND NRSEQVENDA = :NRSEQVENDA
    ";

  const GET_VALUE_FIDELITY_ORDERS = "
    SELECT SUM(CV.VRDESCFID) VRDESCFID
      FROM COMANDAVEN CV
      JOIN VENDAREST VE
        ON VE.NRVENDAREST = CV.NRVENDAREST
       AND VE.CDFILIAL = CV.CDFILIAL
     WHERE VE.CDCLIENTE = :CDCLIENTE
       AND VE.CDCONSUMIDOR = :CDCONSUMIDOR
       AND CV.VRDESCFID IS NOT NULL
       AND CV.IDSTCOMANDA <> '4'
       AND CV.IDSTCOMANDA <> 'X'
    ";

  const ORACLE_GET_CONSUMERS_BY_PERIOD = "
        SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.CDTIPOCONS, CO.CDCCUSCLIE, CO.NRCPFRESPCON, 
               CO.NMCONSUMIDOR, CO.DSEMAILCONS, TO_CHAR(CO.DTNASCCONS, 'DD/MM/YYYY') AS DTNASCCONS, 
               CO.IDSEXOCONS, CO.IDSITCONSUMI AS IDATIVO, CO.NRCEPCONS, CO.DSENDECONS, CO.NRENDECONS, 
               MU.CDMUNICIBGE, CO.SGESTADO, PA.NMPAIS, CO.DSCOMPLENDECONS, 
               BA.NMBAIRRO, CO.NRTELECONS, CO.NRCELULARCONS, 1 AS ISPRINCIPAL, TO_CHAR(CO.DTULTATUCSUM,'DD/MM/YYYY HH24:MI:SS') AS DTULTATUCSUM 
          FROM CONSUMIDOR CO
          LEFT JOIN PAIS PA
            ON CO.CDPAIS      = PA.CDPAIS
     LEFT JOIN BAIRRO BA
            ON CO.CDPAIS      = BA.CDPAIS
           AND CO.SGESTADO    = BA.SGESTADO
           AND CO.CDMUNICIPIO = BA.CDMUNICIPIO
           AND CO.CDBAIRRO    = BA.CDBAIRRO
     LEFT JOIN MUNICIPIO MU
            ON CO.CDPAIS      = MU.CDPAIS
           AND CO.SGESTADO    = MU.SGESTADO
           AND CO.CDMUNICIPIO = MU.CDMUNICIPIO
         WHERE CO.DTULTATU     BETWEEN  TO_DATE(:DTINIPERIODO, 'DD/MM/YYYY HH24:MI:SS') AND TO_DATE(:DTFIMPERIODO, 'DD/MM/YYYY HH24:MI:SS')
            OR CO.DTINCLUSAO   BETWEEN  TO_DATE(:DTINIPERIODO, 'DD/MM/YYYY HH24:MI:SS') AND TO_DATE(:DTFIMPERIODO, 'DD/MM/YYYY HH24:MI:SS')
            OR CO.DTULTATUCSUM BETWEEN  TO_DATE(:DTINIPERIODO, 'DD/MM/YYYY HH24:MI:SS') AND TO_DATE(:DTFIMPERIODO, 'DD/MM/YYYY HH24:MI:SS')
	";

  const SQL_GET_CONSUMERS_BY_PERIOD = "
       SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.CDTIPOCONS, CO.CDCCUSCLIE, CO.NRCPFRESPCON, 
              CO.NMCONSUMIDOR, CO.DSEMAILCONS, CONVERT(VARCHAR(10), CO.DTNASCCONS, 103) AS DTNASCCONS, 
              CO.IDSEXOCONS, CO.IDSITCONSUMI AS IDATIVO, CO.NRCEPCONS, CO.DSENDECONS, CO.NRENDECONS, 
              MU.CDMUNICIBGE, CO.SGESTADO, PA.NMPAIS, CO.DSCOMPLENDECONS, 
              ISNULL(CO.DSBAIRRO,BA.NMBAIRRO) NMBAIRRO, CO.NRTELECONS, CO.NRCELULARCONS, 1 AS ISPRINCIPAL
         FROM CONSUMIDOR CO
    LEFT JOIN PAIS PA
           ON CO.CDPAIS      = PA.CDPAIS
    LEFT JOIN BAIRRO BA
           ON CO.CDPAIS      = BA.CDPAIS
          AND CO.SGESTADO    = BA.SGESTADO
          AND CO.CDMUNICIPIO = BA.CDMUNICIPIO
          AND CO.CDBAIRRO    = BA.CDBAIRRO
    LEFT JOIN MUNICIPIO MU
           ON CO.CDPAIS      = MU.CDPAIS
          AND CO.SGESTADO    = MU.SGESTADO
          AND CO.CDMUNICIPIO = MU.CDMUNICIPIO
        WHERE CAST(CO.DTULTATU AS DATE)   BETWEEN CONVERT(DATE, :DTINIPERIODO, 120) AND CONVERT(DATE, :DTFIMPERIODO, 120)
           OR CAST(CO.DTINCLUSAO AS DATE) BETWEEN CONVERT(DATE, :DTINIPERIODO, 120) AND CONVERT(DATE, :DTFIMPERIODO, 120)
    ";

  const GET_CONSUMERS_ADITIONAL_ADDRESSES = "
		SELECT EN.CDENDECONS, EN.NOMEENDE, CO.NRCEPCONS, CO.DSENDECONS, 
			   CO.NRENDECONS, MU.CDMUNICIBGE , EN.SGESTADO, PA.NMPAIS, 
			   CO.DSCOMPLENDECONS, NVL(EN.DSBAIRRO,BA.NMBAIRRO) NMBAIRRO, 0 AS ISPRINCIPAL

		  FROM ENDERECOCONS EN
		  JOIN PAIS PA
		    ON EN.CDPAIS      = PA.CDPAIS
		  
		 LEFT JOIN BAIRRO BA
		    ON EN.CDPAIS      = BA.CDPAIS
		   AND EN.SGESTADO    = BA.SGESTADO
		   AND EN.CDMUNICIPIO = BA.CDMUNICIPIO
		   AND EN.CDBAIRRO    = BA.CDBAIRRO
		   
		  JOIN MUNICIPIO MU
		    ON EN.CDPAIS      = MU.CDPAIS
		   AND EN.SGESTADO    = MU.SGESTADO
		   AND EN.CDMUNICIPIO = MU.CDMUNICIPIO

	 	 WHERE EN.CDCLIENTE    = :CDCLIENTE
	 	   AND EN.CDCONSUMIDOR = :CDCONSUMIDOR
	";

  const ORACLE_INSERT_CONSUMER = "
    	INSERT INTO CONSUMIDOR (
    		CDCLIENTE, CDCONSUMIDOR, NMCONSUMIDOR, CDCCUSCLIE, CDPAIS, SGESTADO, 
    		CDMUNICIPIO, CDTIPOCONS, DSENDECONS, NRCEPCONS, NRTELECONS, 
    		DSEMAILCONS, NRCPFRESPCON, IDSEXOCONS, DTNASCCONS, 
    		DSCOMPLENDECONS, NRCELULARCONS, DSBAIRRO, NRENDECONS, IDSITCONSUMI, IDATUCONSUMI
		)
        VALUES (
        	:CDCLIENTE, :CDCONSUMIDOR, :NMCONSUMIDOR, :CDCCUSCLIE, :CDPAIS, :SGESTADO,
    		:CDMUNICIPIO, :CDTIPOCONS, :DSENDECONS, :NRCEPCONS, :NRTELECONS,
    		:DSEMAILCONS, :NRCPFRESPCON, :IDSEXOCONS, TO_DATE(:DTNASCCONS, 'DD/MM/YYYY'), 
    		:DSCOMPLENDECONS, :NRCELULARCONS, :DSBAIRRO, :NRENDECONS, :IDATIVO, :IDATUCONSUMI
		)
    ";

  const SQL_INSERT_CONSUMER = "
    	INSERT INTO CONSUMIDOR (
    		CDCLIENTE, CDCONSUMIDOR, NMCONSUMIDOR, CDCCUSCLIE, CDPAIS, SGESTADO, 
    		CDMUNICIPIO, CDTIPOCONS, DSENDECONS, NRCEPCONS, NRTELECONS, 
    		DSEMAILCONS, NRCPFRESPCON, IDSEXOCONS, DTNASCCONS,
    		DSCOMPLENDECONS, NRCELULARCONS, DSBAIRRO, NRENDECONS, IDSITCONSUMI
		)
        VALUES (
        	:CDCLIENTE, :CDCONSUMIDOR, :NMCONSUMIDOR, :CDCCUSCLIE, :CDPAIS, :SGESTADO,
    		:CDMUNICIPIO, :CDTIPOCONS, :DSENDECONS, :NRCEPCONS, :NRTELECONS,
    		:DSEMAILCONS, :NRCPFRESPCON, :IDSEXOCONS, CONVERT(DATE, :DTNASCCONS, 120), 
    		:DSCOMPLENDECONS, :NRCELULARCONS, :DSBAIRRO, :NRENDECONS, :IDATIVO
		)
    ";

  const INSERT_ADITIONAL_ADDRESS = "
		INSERT INTO ENDERECOCONS (
			CDENDECONS, NOMEENDE, CDCLIENTE, CDCONSUMIDOR, NRCEPCONS, 
			CDPAIS, SGESTADO, CDMUNICIPIO, DSBAIRRO,
			DSENDECONS, NRENDECONS, DSCOMPLENDECONS
		)
		VALUES (
			:CDENDECONS, :NOMEENDE, :CDCLIENTE, :CDCONSUMIDOR, :NRCEPCONS, 
			:CDPAIS, :SGESTADO, :CDMUNICIPIO, :DSBAIRRO,
			:DSENDECONS, :NRENDECONS, :DSCOMPLENDECONS
		)
    ";

  const ORACLE_GET_SALES_BY_PERIOD = "
        SELECT CDCLIENTE, CDCONSUMIDOR, CDFILIAL,CDCAIXA, NRSEQVENDA, TO_CHAR(DTVENDA,'DD/MM/YYYY HH24:MI') DTVENDA, IDSITUVENDA, IDRETBALLOJA, 0 VRACRVENDA, VRDESCVENDA, CDMUNICIBGE,
            'BR' CDPAIS, SGESTADO,DSENDECONSVENDA, DSCOMPLENDCOVEN, NRCEPCONSVENDA, DSREFENDCONSVEN, NVL(DSBAIRRO,'Indefinido') DSBAIRRO,
            0 AS ISOPEN, NRINSCRCONS, TO_CHAR(DTHRAGENDADA, 'DD/MM/YYYY HH24:MI:SS') AS DTHRAGENDADA, IDORIGEMVENDA, NRCOMANDA
        FROM (SELECT DTVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.CDFILIAL, V.CDCAIXA, NRSEQVENDA, NVL(CV.NRCOMANDA,V.NRSEQVENDA) AS NRCOMANDA,  V.IDSITUVENDA, V.IDRETBALLOJA, 0 VRACRVENDA, VRDESCVENDA, M.CDMUNICIBGE,
                'BR' CDPAIS, V.SGESTADO, DSENDECONSVENDA, DSCOMPLENDCOVEN, NRCEPCONSVENDA, DSREFENDCONSVEN, NVL(V.DSBAIRRO,'Indefinido') DSBAIRRO,
                0 AS ISOPEN, V.NRINSCRCONS, V.DTHRAGENDADA, V.IDORIGEMVENDA
          FROM (SELECT CDCLIENTE, CDCONSUMIDOR
                  FROM CONSUMIDOR
                  WHERE CDCLIENTE = :CDCLIENTE
                    AND CDCONSUMIDOR = :CDCONSUMIDOR) C,
                (SELECT DISTINCT CDFILIAL, CDCAIXA, CDLOJA
                  FROM V_FILIALLOJACAIXA
                  WHERE CDFILIAL IN (:CDFILIAL)) F, VENDA V LEFT JOIN MUNICIPIO M
                                                                  ON V.CDPAIS = M.CDPAIS
                                                                  AND V.SGESTADO = M.SGESTADO
                                                                  AND V.CDMUNICIPIO = M.CDMUNICIPIO
                JOIN VENDAREST VE
                  ON VE.CDFILIAL = V.CDFILIAL
                 AND VE.NRVENDARESTAUX = V.NRVENDAREST
                 AND VE.NRVENDAREST = V.NRVENDARESTORA
                JOIN COMANDAVEN CV
                  ON CV.CDFILIAL = VE.CDFILIAL
                 AND CV.NRVENDAREST = VE.NRVENDAREST
          WHERE V.CDCLIENTE = C.CDCLIENTE
            AND V.CDCONSUMIDOR = C.CDCONSUMIDOR
            AND V.IDSITUVENDA = 'O'
            AND V.CDFILIAL = F.CDFILIAL
            AND V.CDCAIXA = F.CDCAIXA
            AND V.CDLOJA = F.CDLOJA
            AND V.DTENTRVENDA BETWEEN TO_DATE(:DTINIPERIODO, 'DD/MM/YYYY') AND TO_DATE(:DTFIMPERIODO, 'DD/MM/YYYY')
            AND NVL(:CHECKDATE, 'XX') <> 'F'
            ORDER BY V.DTVENDA DESC) PRINC
        WHERE (ROWNUM < (:COUNTER + 1) OR :CHECKCOUNTER = 'F')
        UNION ALL
        SELECT CDCLIENTE, CDCONSUMIDOR, CDFILIAL,CDCAIXA, NRSEQVENDA, TO_CHAR(DTVENDA,'DD/MM/YYYY HH24:MI') DTVENDA, IDSITUVENDA, IDRETBALLOJA, 0 VRACRVENDA, VRDESCVENDA, CDMUNICIBGE,
            'BR' CDPAIS, SGESTADO,DSENDECONSVENDA, DSCOMPLENDCOVEN, NRCEPCONSVENDA, DSREFENDCONSVEN, NVL(DSBAIRRO,'Indefinido') DSBAIRRO,
            0 AS ISOPEN, NRINSCRCONS, TO_CHAR(DTHRAGENDADA, 'DD/MM/YYYY HH24:MI:SS') AS DTHRAGENDADA, IDORIGEMVENDA, NRCOMANDA
        FROM (SELECT DTVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.CDFILIAL, V.CDCAIXA, NRSEQVENDA, NVL(CV.NRCOMANDA,V.NRSEQVENDA) AS NRCOMANDA,  V.IDSITUVENDA, V.IDRETBALLOJA, 0 VRACRVENDA, VRDESCVENDA, M.CDMUNICIBGE,
                'BR' CDPAIS, V.SGESTADO, DSENDECONSVENDA, DSCOMPLENDCOVEN, NRCEPCONSVENDA, DSREFENDCONSVEN, NVL(V.DSBAIRRO,'Indefinido') DSBAIRRO,
                0 AS ISOPEN, V.NRINSCRCONS, V.DTHRAGENDADA, V.IDORIGEMVENDA
          FROM (SELECT CDCLIENTE, CDCONSUMIDOR
                  FROM CONSUMIDOR
                  WHERE CDCLIENTE = :CDCLIENTE
                    AND CDCONSUMIDOR = :CDCONSUMIDOR) C,
                (SELECT DISTINCT CDFILIAL, CDCAIXA, CDLOJA
                  FROM V_FILIALLOJACAIXA
                  WHERE CDFILIAL IN (:CDFILIAL)) F, VENDA V LEFT JOIN MUNICIPIO M
                                                                  ON V.CDPAIS = M.CDPAIS
                                                                  AND V.SGESTADO = M.SGESTADO
                                                                  AND V.CDMUNICIPIO = M.CDMUNICIPIO
                JOIN VENDAREST VE
                  ON VE.CDFILIAL = V.CDFILIAL
                 AND VE.NRVENDARESTAUX = V.NRVENDAREST
                 AND VE.NRVENDAREST = V.NRVENDARESTORA
                JOIN COMANDAVEN CV
                  ON CV.CDFILIAL = VE.CDFILIAL
                 AND CV.NRVENDAREST = VE.NRVENDAREST
          WHERE V.CDCLIENTE = C.CDCLIENTE
            AND V.CDCONSUMIDOR = C.CDCONSUMIDOR
            AND V.IDSITUVENDA = 'O'
            AND V.CDFILIAL = F.CDFILIAL
            AND V.CDCAIXA = F.CDCAIXA
            AND V.CDLOJA = F.CDLOJA
            AND :CHECKDATE = 'F'
            ORDER BY V.DTVENDA DESC) PRINC
        WHERE (ROWNUM < (:COUNTER + 1) OR :CHECKCOUNTER = 'F')
    ";

  const SQL_GET_SALES_BY_PERIOD = "
		SELECT CDCLIENTE, CDCONSUMIDOR, CDFILIAL,CDCAIXA, NRSEQVENDA, CONVERT(VARCHAR(10), DTVENDA, 103) AS DTVENDA,
			     IDSITUVENDA, IDRETBALLOJA, 0 AS VRACRVENDA, VRDESCVENDA, M.CDMUNICIBGE, 'BR' AS CDPAIS, V.SGESTADO,DSENDECONSVENDA,
			     DSCOMPLENDCOVEN, NRCEPCONSVENDA, DSREFENDCONSVEN, ISNULL(DSBAIRRO,'Indefinido') DSBAIRRO, 0 AS ISOPEN, NRINSCRCONS,
			     CONVERT(VARCHAR(12), DTHRAGENDADA, 103)+' '+CONVERT(VARCHAR(12), DTHRAGENDADA, 108) AS DTHRAGENDADA, IDORIGEMVENDA
		  FROM VENDA V
 LEFT JOIN MUNICIPIO M
		    ON V.CDPAIS = M.CDPAIS
		   AND V.SGESTADO = M.SGESTADO
		   AND V.CDMUNICIPIO = M.CDMUNICIPIO
		 WHERE IDSITUVENDA = 'O' -- venda aprovada
		   AND CDCLIENTE = :CDCLIENTE
		   AND CDCONSUMIDOR = :CDCONSUMIDOR
		   AND CAST(DTFECHAVENDA AS DATE) BETWEEN CONVERT(DATE, :DTINIPERIODO, 103) AND CONVERT(DATE, :DTFIMPERIODO, 103)
  ORDER BY CONVERT(VARCHAR(10), DTVENDA, 103) DESC
    ";

  const ORACLE_GET_LAST_SALE = "
	    SELECT VR.CDCLIENTE, VR.CDCONSUMIDOR, VR.CDFILIAL, CV.NRCOMANDA, VR.NRVENDAREST, VR.NRMESA, CV.IDORGCMDVENDA AS IDORIGEMVENDA,
             TO_CHAR(VR.DTHRABERMESA, 'DD/MM/YYYY HH24:MI') AS DTVENDA, 
             CV.IDSTCOMANDA, CV.IDRETBALLOJA, CV.VRACRCOMANDA, CV.VRDESCOMANDA, 
             M.CDMUNICIBGE, 'BR' CDPAIS , CV.SGESTADO, CV.DSENDECONSCOMAN, CV.DSCOMPLENDCOCOM, CV.NRCEPCONSCOMAND,
             CV.DSREFENDCONSCOM, CV.DSBAIRRO, CV.NRCOMANDAEXT, TO_CHAR(CV.DTHRAGENDADA, 'DD/MM/YYYY HH24:MI') AS DTHRAGENDADA,
             CASE CV.IDSTCOMANDA
                   WHEN '1' THEN 1
                   ELSE 0
             END AS ISOPEN
		    FROM COMANDAVEN CV
	      JOIN VENDAREST VR
	        ON CV.CDFILIAL = VR.CDFILIAL
	       AND CV.NRVENDAREST = VR.NRVENDAREST
	 LEFT JOIN MUNICIPIO M 
	 		    ON CV.CDMUNICIPIO = M.CDMUNICIPIO
	 	     AND CV.SGESTADO = M.SGESTADO
	 	     AND CV.CDPAIS = M.CDPAIS
		   WHERE CV.NRCOMANDA = :NRCOMANDA
		     AND CV.CDFILIAL = :CDFILIAL
		     AND VR.CDCLIENTE = :CDCLIENTE
		     AND VR.CDCONSUMIDOR = :CDCONSUMIDOR
    ORDER BY VR.DTHRABERMESA DESC
    ";

  const ORACLE_GET_LAST_SALE_VENDA = "
		SELECT VE.IDORIGEMVENDA, VE.CDCLIENTE, VE.CDCONSUMIDOR, VE.CDFILIAL, VE.NRSEQVENDA AS NRCOMANDA, VE.NRVENDAREST, VE.NRMESA, 
	 	       TO_CHAR(VE.DTVENDA, 'DD/MM/YYYY HH24:MI') AS DTVENDA,
	 	       VE.IDSITUVENDA AS IDSTCOMANDA, VE.IDRETBALLOJA AS IDRETBALLOJA, VE.VRTXSEVENDA AS VRACRCOMANDA, VE.VRDESCVENDA AS VRDESCOMANDA,
	 		     M.CDMUNICIBGE, 'BR' CDPAIS, VE.SGESTADO, VE.DSENDECONSVENDA AS DSENDECONSCOMAN, VE.DSCOMPLENDCOVEN AS DSCOMPLENDCOCOM, VE.NRCEPCONSVENDA AS NRCEPCONSCOMAND,
	 	       VE.DSREFENDCONSVEN AS DSREFENDCONSCOM, BA.NMBAIRRO AS DSBAIRRO, VE.NRCOMANDAEXT AS NRCOMANDAEXT, TO_CHAR(VE.DTHRAGENDADA, 'DD/MM/YYYY HH24:MI') AS DTHRAGENDADA,
	 	       0 AS ISOPEN
      FROM VENDA VE
 LEFT JOIN MUNICIPIO M 
	 		  ON VE.CDMUNICIPIO = M.CDMUNICIPIO
	 	   AND VE.SGESTADO = M.SGESTADO
	 	   AND VE.CDPAIS = M.CDPAIS
 LEFT JOIN BAIRRO BA
	 	    ON VE.CDMUNICIPIO = BA.CDMUNICIPIO
	 	   AND VE.SGESTADO = BA.SGESTADO
       AND VE.CDPAIS = BA.CDPAIS
       AND VE.CDBAIRRO = BA.CDBAIRRO
     WHERE VE.NRSEQVENDA = :NRCOMANDA
       AND VE.CDCLIENTE = :CDCLIENTE
       AND VE.CDCONSUMIDOR = :CDCONSUMIDOR
       AND VE.CDFILIAL = :CDFILIAL
    ";

  const SQL_GET_LAST_SALE = "
		SELECT VR.CDCLIENTE, VR.CDCONSUMIDOR, VR.CDFILIAL, CV.NRCOMANDA, VR.NRVENDAREST, VR.NRMESA,
           CONVERT(VARCHAR(12), VR.DTHRABERMESA, 103)+' '+CONVERT(VARCHAR(8), VR.DTHRABERMESA, 108) AS DTVENDA, 
           CV.IDSTCOMANDA, CV.IDRETBALLOJA, CV.VRACRCOMANDA,CV.VRDESCOMANDA,
           M.CDMUNICIBGE, 'BR' CDPAIS , CV.SGESTADO, CV.DSENDECONSCOMAN, CV.DSCOMPLENDCOCOM, CV.NRCEPCONSCOMAND,
           CV.DSREFENDCONSCOM, CV.DSBAIRRO, '0' AS NRCOMANDAEXT, CONVERT(VARCHAR(12), CV.DTHRAGENDADA, 103)+' '+CONVERT(VARCHAR(12), CV.DTHRAGENDADA, 108) AS DTHRAGENDADA,
           CASE CV.IDSTCOMANDA
               WHEN '1' THEN 1
               ELSE 0
           END AS ISOPEN
		  FROM COMANDAVEN CV
      JOIN VENDAREST VR
        ON CV.CDFILIAL = VR.CDFILIAL
       AND CV.NRVENDAREST = VR.NRVENDAREST
 LEFT JOIN MUNICIPIO M 
	 		  ON CV.CDMUNICIPIO = M.CDMUNICIPIO
	 	   AND CV.SGESTADO = M.SGESTADO
	 	   AND CV.CDPAIS = M.CDPAIS
 LEFT JOIN BAIRRO BA
	 	    ON CV.CDMUNICIPIO = BA.CDMUNICIPIO
	 	   AND CV.SGESTADO = BA.SGESTADO
       AND CV.CDPAIS = BA.CDPAIS
       AND CV.CDBAIRRO = BA.CDBAIRRO
		 WHERE CV.NRCOMANDA = :NRCOMANDA
		   AND CV.CDFILIAL = :CDFILIAL
		   AND VR.CDCLIENTE = :CDCLIENTE
		   AND VR.CDCONSUMIDOR 	= :CDCONSUMIDOR
  ORDER BY VR.DTHRABERMESA DESC
    ";

  const ORACLE_GET_LASTSALE_PRODUCTS = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION, '' AS CDPRODPROMOCAO, 
			     IT.VRPRECCOMVEN , IT.QTPRODCOMVEN , IT.VRDESCCOMVEN, IT.VRACRCOMVEN, IT.NRINSCRCONS, IT.NRPRODCOMVEN
		  FROM ITCOMANDAVEN IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		  JOIN VENDAREST VR
		    ON IT.CDFILIAL = VR.CDFILIAL
       AND IT.NRVENDAREST = VR.NRVENDAREST
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRVENDAREST = :NRVENDAREST
       AND IT.NRCOMANDA = :NRCOMANDA
       AND VR.CDCLIENTE = :CDCLIENTE
		   AND VR.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND IT.CDPRODPROMOCAO IS NULL
    ";

  const ORACLE_GET_LASTSALE_PRODUCTS_ITEMVENDA = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION, '' AS CDPRODPROMOCAO, 
			     IT.VRUNITVEND AS VRPRECCOMVEN, IT.QTPRODVEND  AS QTPRODCOMVEN, IT.VRDESITVEND AS VRDESCCOMVEN, IT.VRACRITVEND AS  VRACRCOMVEN,'' AS NRINSCRCONS, IT.NRSEQUITVEND AS NRPRODCOMVEN
		  FROM ITEMVENDA IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		  JOIN VENDA VE
		    ON VE.CDFILIAL = IT.CDFILIAL
		   AND VE.CDCAIXA = IT.CDCAIXA
		   AND VE.NRSEQVENDA = IT.NRSEQVENDA
		 WHERE IT.CDFILIAL = :CDFILIAL
       AND IT.NRSEQVENDA = :NRCOMANDA
       AND VE.CDCLIENTE = :CDCLIENTE
		   AND VE.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND IT.CDPRODPROMOCAO IS NULL
    ";

  const SQL_GET_LASTSALE_PRODUCTS = "
		SELECT IT.CDPRODUTO, ISNULL(PR.NMPRODVENDA,PR.NMPRODUTO) AS NMPRODUTO, ISNULL(PR.DSPRODVENDA, '') AS DESCRIPTION, '' AS CDPRODPROMOCAO, 
			     IT.VRPRECCOMVEN , IT.QTPRODCOMVEN , IT.VRDESCCOMVEN, IT.VRACRCOMVEN, IT.NRINSCRCONS, IT.NRPRODCOMVEN
		  FROM ITCOMANDAVEN IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		  JOIN VENDAREST VR
		    ON IT.CDFILIAL = VR.CDFILIAL
       AND IT.NRVENDAREST = VR.NRVENDAREST
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRVENDAREST  = :NRVENDAREST
       AND IT.NRCOMANDA = :NRCOMANDA
       AND VR.CDCLIENTE = :CDCLIENTE
		   AND VR.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND IT.CDPRODPROMOCAO IS NULL
    ";

  const GET_LASTSALE_COMBOS = "
		SELECT IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQPRODCOM,
			     SUM(IT.VRPRECCOMVEN) VRPRECCOMVEN, SUM(IT.VRDESCCOMVEN) VRDESCCOMVEN, SUM(IT.VRACRCOMVEN) VRACRCOMVEN
		  FROM ITCOMANDAVEN IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODPROMOCAO = PR.CDPRODUTO
		  JOIN VENDAREST VR
		    ON IT.CDFILIAL = VR.CDFILIAL
       AND IT.NRVENDAREST = VR.NRVENDAREST
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRVENDAREST = :NRVENDAREST
       AND IT.NRCOMANDA = :NRCOMANDA
       AND VR.CDCLIENTE = :CDCLIENTE
		   AND VR.CDCONSUMIDOR = :CDCONSUMIDOR
       AND IT.CDPRODPROMOCAO IS NOT NULL
  GROUP BY IT.CDFILIAL, IT.NRVENDAREST, IT.NRCOMANDA, IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO), IT.NRSEQPRODCOM
    ";

  const GET_LASTSALE_COMBOS_ITEMVENDA = "
		SELECT IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQPRODCOMIT AS NRSEQPRODCOM,
			     SUM(IT.VRUNITVEND) VRPRECCOMVEN, SUM(IT.VRDESITVEND) VRDESCCOMVEN, SUM(IT.VRACRITVEND) VRACRCOMVEN
		  FROM ITEMVENDA IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODPROMOCAO = PR.CDPRODUTO
		  JOIN VENDA VE
		    ON VE.CDFILIAL = IT.CDFILIAL
		   AND VE.CDCAIXA = IT.CDCAIXA
		   AND VE.NRSEQVENDA = IT.NRSEQVENDA
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRSEQVENDA = :NRCOMANDA
       AND VE.CDCLIENTE = :CDCLIENTE
		   AND VE.CDCONSUMIDOR = :CDCONSUMIDOR
       AND IT.CDPRODPROMOCAO IS NOT NULL
  GROUP BY IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO), IT.NRSEQPRODCOMIT
    ";

  const ORACLE_GET_LASTSALE_COMBO_PRODUCTS = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
			     IT.VRPRECCOMVEN , IT.QTPRODCOMVEN , IT.VRDESCCOMVEN, IT.VRACRCOMVEN, IT.NRINSCRCONS, IT.NRPRODCOMVEN
		  FROM ITCOMANDAVEN IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		  JOIN VENDAREST VR
		    ON IT.CDFILIAL = VR.CDFILIAL
       AND IT.NRVENDAREST = VR.NRVENDAREST
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRVENDAREST = :NRVENDAREST
       AND IT.NRCOMANDA = :NRCOMANDA
		   AND IT.CDPRODPROMOCAO = :CDPRODPROMOCAO
		   AND IT.NRSEQPRODCOM = :NRSEQPRODCOM
		   AND VR.CDCLIENTE = :CDCLIENTE
		   AND VR.CDCONSUMIDOR = :CDCONSUMIDOR
    ";

  const ORACLE_GET_LASTSALE_COMBO_PRODUCTS_ITEMVENDA = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
			     IT.VRUNITVEND AS VRPRECCOMVEN, IT.QTPRODVEND  AS QTPRODCOMVEN, IT.VRDESITVEND AS VRDESCCOMVEN, IT.VRACRITVEND AS  VRACRCOMVEN,'' AS NRINSCRCONS, IT.NRSEQUITVEND
		  FROM ITEMVENDA IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		  JOIN VENDA VE
		    ON VE.CDFILIAL = IT.CDFILIAL
		   AND VE.CDCAIXA = IT.CDCAIXA
		   AND VE.NRSEQVENDA = IT.NRSEQVENDA
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRSEQVENDA = :NRCOMANDA
		   AND IT.CDPRODPROMOCAO = :CDPRODPROMOCAO
       AND VE.CDCLIENTE = :CDCLIENTE
		   AND VE.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND IT.NRSEQPRODCOMIT = :NRSEQPRODCOM
    ";

  const SQL_GET_POSITION_COMBO_PRODUCTS = "
		SELECT IT.CDPRODUTO, PR.NMPRODUTO, ISNULL(PR.DSPRODVENDA, '') AS DESCRIPTION,
			     IT.VRPRECCOMVEN , IT.QTPRODCOMVEN , IT.VRDESCCOMVEN, IT.VRACRCOMVEN, IT.NRINSCRCONS, IT.NRPRODCOMVEN
		  FROM ITCOMANDAVEN IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRVENDAREST = :NRVENDAREST
       AND IT.NRCOMANDA = :NRCOMANDA
		   AND IT.CDPRODPROMOCAO = :CDPRODPROMOCAO
		   AND IT.NRSEQPRODCOM = :NRSEQPRODCOM
		   AND IT.IDSTPRCOMVEN <> '6'
    ";

  const GET_LASTSALE_PAYMENTS = "
		SELECT MV.CDTIPORECE, TR.NMTIPORECE, MV.VRMOVIVENDDLV AS VRMOVIVEND
		  FROM MOVCAIXADLV MV
      JOIN TIPORECE TR
        ON MV.CDTIPORECE = TR.CDTIPORECE
		 WHERE MV.CDFILIAL = :CDFILIAL
		   AND MV.NRVENDAREST = :NRVENDAREST
		   AND MV.CDCLIENTE = :CDCLIENTE
		   AND MV.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND MV.IDTIPOMOVIVEDLV = 'E'
    ";

  const GET_LASTSALE_PAYMENTS_MOVCAIXA = "
		SELECT MV.CDTIPORECE, TR.NMTIPORECE, MV.VRMOVIVEND
		  FROM MOVCAIXA MV
      JOIN TIPORECE TR
        ON MV.CDTIPORECE = TR.CDTIPORECE
      JOIN VENDA VE
		    ON VE.CDFILIAL = MV.CDFILIAL
		   AND VE.CDCAIXA = MV.CDCAIXA
		   AND VE.NRSEQVENDA = MV.NRSEQVENDA
		 WHERE MV.CDFILIAL = :CDFILIAL
		   AND MV.NRSEQVENDA = :NRCOMANDA
       AND VE.CDCLIENTE = :CDCLIENTE
		   AND VE.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND MV.IDTIPOMOVIVE = 'E'
    ";

  const GET_LASTSALE_PRODUCT_OBSERVATIONS = " 	
	   SELECT NVL(OC.DSAPELIDOOBS, OC.DSOCORR) DSOCORR, OC.CDOCORR, OC.CDGRPOCOR,
 		        OBIT.CDFILIAL, OBIT.NRVENDAREST, OBIT.NRCOMANDA, OBIT.NRPRODCOMVEN
	     FROM OBSITCOMANDAVEN OBIT, OCORRENCIA OC
		  WHERE OBIT.CDFILIAL = :CDFILIAL
	      AND OBIT.NRVENDAREST = :NRVENDAREST
	      AND OBIT.NRCOMANDA = :NRCOMANDA
	      AND OBIT.NRPRODCOMVEN = :NRPRODCOMVEN
        AND OBIT.CDGRPOCOR = OC.CDGRPOCOR
        AND OBIT.CDOCORR = OC.CDOCORR
        AND NOT EXISTS (SELECT 1
                          FROM ITCOMANDAVEN ITCO
                         WHERE OBIT.CDFILIAL = ITCO.CDFILIAL
                           AND OBIT.NRVENDAREST = ITCO.NRVENDAREST
                           AND OBIT.NRCOMANDA = ITCO.NRCOMANDA
                           AND OC.CDPRODUTO = ITCO.CDPRODUTO)
   ORDER BY OBIT.CDFILIAL, OBIT.NRVENDAREST, OBIT.NRCOMANDA, OBIT.NRPRODCOMVEN
    ";

  const GET_LASTSALE_PRODUCT_OBSERVATIONS_OBSITEMVENDA = "
	   SELECT NVL(OC.DSAPELIDOOBS, OC.DSOCORR) DSOCORR, OC.CDOCORR, OC.CDGRPOCOR,
 		        OBIT.CDFILIAL, OBIT.NRSEQVENDA, OBIT.NRSEQUITVEND
	     FROM OBSITEMVENDA OBIT, OCORRENCIA OC
		  WHERE OBIT.CDFILIAL = :CDFILIAL
	      AND OBIT.NRSEQVENDA = :NRCOMANDA
	      AND OBIT.NRSEQUITVEND = :NRSEQUITVEND
        AND OBIT.CDGRPOCOR = OC.CDGRPOCOR
        AND OBIT.CDOCORR = OC.CDOCORR
        AND NOT EXISTS (SELECT 1
                          FROM ITEMVENDA ITCO
                         WHERE OBIT.CDFILIAL = ITCO.CDFILIAL
                           AND OBIT.NRSEQVENDA = ITCO.NRSEQVENDA
                           AND OC.CDPRODUTO = ITCO.CDPRODUTO)
   ORDER BY OBIT.CDFILIAL, OBIT.NRSEQVENDA, OBIT.NRSEQUITVEND
    ";

  const GET_POSITION_PRODUCT_OBSERVATIONS = " 	
	  SELECT DSOCORR, CDOCORR, CDGRPOCOR, VRPRECCOMVEN, CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN
	    FROM (
	    	   SELECT ISNULL(OC.DSAPELIDOOBS,OC.DSOCORR) DSOCORR, OC.CDOCORR, OC.CDGRPOCOR, 0 VRPRECCOMVEN,
	    		        OBIT.CDFILIAL, OBIT.NRVENDAREST, OBIT.NRCOMANDA, OBIT.NRPRODCOMVEN	
			       FROM OBSITCOMANDAVEN OBIT
	  		     JOIN OCORRENCIA OC
		    	     ON OBIT.CDGRPOCOR = OC.CDGRPOCOR
		   	      AND OBIT.CDOCORR = OC.CDOCORR 	  
            WHERE OC.CDPRODUTO IS NULL
            UNION 
           SELECT ISNULL(OC.DSAPELIDOOBS,OC.DSOCORR) DSOCORR, OC.CDOCORR, OC.CDGRPOCOR, ISNULL(IT.VRPRECCOMVEN,0) VRPRECCOMVEN ,
		   		        OBIT.CDFILIAL, OBIT.NRVENDAREST, OBIT.NRCOMANDA, OBIT.NRPRODCOMVEN 
			       FROM OBSITCOMANDAVEN OBIT
			       JOIN OCORRENCIA OC
		         	 ON OBIT.CDGRPOCOR = OC.CDGRPOCOR
              AND OBIT.CDOCORR   = OC.CDOCORR	
        LEFT JOIN (SELECT DISTINCT CDFILIAL, NRCOMANDA, NRVENDAREST, CDPRODUTO, VRPRECCOMVEN, IDSTPRCOMVEN)IT
		           ON IT.NRCOMANDA = OBIT.NRCOMANDA
		          AND IT.NRVENDAREST = OBIT.NRVENDAREST
		          AND IT.CDPRODUTO = OC.CDPRODUTO
		   	      AND IT.CDFILIAL = OBIT.CDFILIAL
		   	      AND IT.IDSTPRCOMVEN <> '6' 	
		   	    WHERE OC.CDPRODUTO IS NOT NULL	
		  ) OBS
     WHERE NRCOMANDA = :NRCOMANDA
			 AND NRVENDAREST = :NRVENDAREST
			 AND CDFILIAL = :CDFILIAL
       AND NRPRODCOMVEN = :NRPRODCOMVEN
    ";

  const ORACLE_GET_SALE_PRODUCT_OBSERVATIONS = " 	
	  SELECT NVL(OC.DSAPELIDOOBS,OC.DSOCORR) DSOCORR, OC.CDOCORR, OC.CDGRPOCOR,
	         OI.CDFILIAL, OI.CDCAIXA, OI.NRSEQVENDA, OI.NRSEQUITVEND
      FROM OBSITEMVENDA OI, OCORRENCIA OC
     WHERE OI.CDFILIAL = :CDFILIAL
     	 AND OI.CDCAIXA = :CDCAIXA
	     AND OI.NRSEQVENDA = :NRSEQVENDA
	     AND OI.NRSEQUITVEND = :NRSEQUITVEND
       AND OI.CDGRPOCOR = OC.CDGRPOCOR
	     AND OI.CDOCORR = OC.CDOCORR
       AND NOT EXISTS (SELECT 1
                         FROM ITEMVENDA IT
                        WHERE OI.CDFILIAL = IT.CDFILIAL
                          AND OI.CDCAIXA = IT.CDCAIXA
                          AND OI.NRSEQVENDA = IT.NRSEQVENDA
                          AND OC.CDPRODUTO = IT.CDPRODUTO)
	ORDER BY OI.CDFILIAL, OI.CDCAIXA, OI.NRSEQVENDA, OI.NRSEQUITVEND
    ";

  const SQL_GET_SALE_PRODUCT_OBSERVATIONS = " 	
	  SELECT ISNULL(OC.DSAPELIDOOBS,OC.DSOCORR) DSOCORR, OC.CDOCORR, OC.CDGRPOCOR,
	         OI.CDFILIAL, OI.CDCAIXA, OI.NRSEQVENDA, OI.NRSEQUITVEND
      FROM OBSITEMVENDA OI, OCORRENCIA OC
     WHERE OI.CDFILIAL = :CDFILIAL
     	 AND OI.CDCAIXA = :CDCAIXA
	     AND OI.NRSEQVENDA = :NRSEQVENDA
	     AND OI.NRSEQUITVEND = :NRSEQUITVEND
       AND OI.CDGRPOCOR = OC.CDGRPOCOR
	     AND OI.CDOCORR = OC.CDOCORR
       AND NOT EXISTS (SELECT 1
                         FROM ITEMVENDA IT
                        WHERE OI.CDFILIAL = IT.CDFILIAL
                          AND OI.CDCAIXA = IT.CDCAIXA
                          AND OI.NRSEQVENDA = IT.NRSEQVENDA
                          AND OC.CDPRODUTO = IT.CDPRODUTO)
  ORDER BY OI.CDFILIAL, OI.CDCAIXA, OI.NRSEQVENDA, OI.NRSEQUITVEND
    ";

  const ORACLE_GET_SALE_PRODUCTS = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION, '' AS CDPRODPROMOCAO, 
			     IT.VRUNITVEND , IT.QTPRODVEND , IT.VRDESITVEND, IT.VRACRITVEND, IT.NRSEQUITVEND
		  FROM ITEMVENDA IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDCAIXA = :CDCAIXA
		   AND NRSEQVENDA = :NRSEQVENDA
		   AND CDPRODPROMOCAO IS NULL
    ";

  const SQL_GET_SALE_PRODUCTS = "
		SELECT IT.CDPRODUTO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, ISNULL(PR.DSPRODVENDA, '') AS DESCRIPTION, '' AS CDPRODPROMOCAO, 
			     IT.VRUNITVEND , IT.QTPRODVEND , IT.VRDESITVEND, IT.VRACRITVEND, IT.NRSEQUITVEND
		  FROM ITEMVENDA IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDCAIXA = :CDCAIXA
		   AND NRSEQVENDA = :NRSEQVENDA
		   AND IT.CDPRODUTO NOT IN (SELECT ISNULL(CDPRODUTO,'VAZIO') FROM OCORRENCIA)
		   AND CDPRODPROMOCAO IS NULL
    ";

  const ORACLE_GET_SALE_COMBOS = "
		SELECT CDFILIAL, CDCAIXA, NRSEQVENDA, CDPRODUTO, CDPRODPROMOCAO, NMPRODUTO, NRSEQUITVEND, AGRUPADO, NRSEQPRODCOMIT, VRUNITVEND, VRDESITVEND, VRACRITVEND 
      FROM ( 
		  		-- COMBOS AGRUPADOS
      SELECT IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA,IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQUITVEND,
					   'S' AGRUPADO, '000' NRSEQPRODCOMIT,
					   SUM(IT.VRUNITVEND) VRUNITVEND, SUM(IT.VRDESITVEND) VRDESITVEND, SUM(IT.VRACRITVEND) VRACRITVEND
        FROM ITEMVENDA IT
        JOIN PRODUTO PR
          ON IT.CDPRODPROMOCAO = PR.CDPRODUTO
       WHERE IT.CDPRODPROMOCAO IS NOT NULL
         AND IT.NRSEQPRODCOMIT IS NULL
    GROUP BY IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA, IT.CDPRODPROMOCAO,IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO), IT.NRSEQUITVEND, 'S', '000'
       UNION
          -- COMBOS NAO AGRUPADOS
      SELECT IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA,IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQUITVEND,
             'N' AGRUPADO, NRSEQPRODCOMIT,	
					   SUM(IT.VRUNITVEND) VRUNITVEND, SUM(IT.VRDESITVEND) VRDESITVEND, SUM(IT.VRACRITVEND) VRACRITVEND
        FROM ITEMVENDA IT
        JOIN PRODUTO PR
          ON IT.CDPRODPROMOCAO = PR.CDPRODUTO
       WHERE IT.CDPRODPROMOCAO IS NOT NULL
         AND IT.NRSEQPRODCOMIT IS NOT NULL
    GROUP BY IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA, IT.CDPRODPROMOCAO,IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO), IT.NRSEQUITVEND, 'N', NRSEQPRODCOMIT
  			)
     WHERE CDFILIAL = :CDFILIAL
       AND CDCAIXA = :CDCAIXA
       AND NRSEQVENDA = :NRSEQVENDA  
    ";

  const SQL_GET_SALE_COMBOS = "
		SELECT CDFILIAL, CDCAIXA, NRSEQVENDA, CDPRODUTO, CDPRODPROMOCAO, NMPRODUTO, NRSEQUITVEND, AGRUPADO, NRSEQPRODCOMIT, VRUNITVEND, VRDESITVEND, VRACRITVEND 
      FROM ( 
		  		-- COMBOS AGRUPADOS
				SELECT IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA,IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQUITVEND,
					     'S' AS AGRUPADO, '000' AS NRSEQPRODCOMIT,
					     SUM(IT.VRUNITVEND) AS VRUNITVEND, SUM(IT.VRDESITVEND) AS VRDESITVEND, SUM(IT.VRACRITVEND) AS VRACRITVEND
				  FROM ITEMVENDA IT
          JOIN PRODUTO PR
		    		ON IT.CDPRODPROMOCAO = PR.CDPRODUTO
		 		 WHERE IT.CDPRODPROMOCAO IS NOT NULL
				   AND IT.NRSEQPRODCOMIT IS NULL
      GROUP BY IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA,IT.CDPRODPROMOCAO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO), IT.NRSEQUITVEND, 'S', '000'
         UNION
       		  	 -- COMBOS NAO AGRUPADOS
        SELECT IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA,IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQUITVEND,
               'N' AS AGRUPADO, IT.NRSEQPRODCOMIT,	
					     SUM(IT.VRUNITVEND) AS  VRUNITVEND, SUM(IT.VRDESITVEND) AS VRDESITVEND, SUM(IT.VRACRITVEND) AS VRACRITVEND
				  FROM ITEMVENDA IT
          JOIN PRODUTO PR
		    		ON IT.CDPRODPROMOCAO = PR.CDPRODUTO
		 		 WHERE IT.CDPRODPROMOCAO IS NOT NULL
				   AND IT.NRSEQPRODCOMIT IS NOT NULL
      GROUP BY IT.CDFILIAL, IT.CDCAIXA, IT.NRSEQVENDA,IT.CDPRODPROMOCAO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO), IT.NRSEQUITVEND, 'N', IT.NRSEQPRODCOMIT
  			) A
     WHERE A.CDFILIAL = :CDFILIAL
       AND A.CDCAIXA = :CDCAIXA
       AND A.NRSEQVENDA = :NRSEQVENDA
    ";

  const ORACLE_GET_SALE_GROUPED_COMBO_PRODUCTS = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
			     IT.VRUNITVEND, IT.QTPRODVEND , IT.VRDESITVEND, 0 VRACRITVEND , IT.NRSEQUITVEND
		  FROM ITEMVENDA IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDCAIXA = :CDCAIXA
		   AND NRSEQVENDA = :NRSEQVENDA
		   AND NRSEQUITVEND = :NRSEQUITVEND   
     UNION 
    SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
			     IT.VRUNVENDAEST VRUNITVEND, IT.QTITVENDAEST QTPRODVEND , IT.VRDESITVENDAEST VRDESITVEND, 0 VRACRITVEND , IT.NRSEQUITVEND
		  FROM ITEMVENDAEST IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDCAIXA = :CDCAIXA
		   AND NRSEQVENDA = :NRSEQVENDA
		   AND NRSEQUITVEND = :NRSEQUITVEND
    ";

  const ORACLE_GET_SALE_UNGROUPED_COMBO_PRODUCTS = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
			     IT.VRUNITVEND, IT.QTPRODVEND , IT.VRDESITVEND, IT.VRACRITVEND , IT.NRSEQUITVEND
		  FROM ITEMVENDA IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDCAIXA = :CDCAIXA
		   AND NRSEQVENDA = :NRSEQVENDA
		   AND NRSEQPRODCOMIT = :NRSEQPRODCOMIT
       AND NRSEQUITVEND = :NRSEQUITVEND
     UNION
    SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
           IT.VRUNVENDAEST VRUNITVEND, IT.QTITVENDAEST QTPRODVEND , IT.VRDESITVENDAEST VRDESITVEND, 0 VRACRITVEND , IT.NRSEQUITVEND
		  FROM ITEMVENDAEST IT
      JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDCAIXA = :CDCAIXA
		   AND NRSEQVENDA = :NRSEQVENDA
		   AND NRSEQUITVEND = :NRSEQUITVEND
    ";

  const GET_SALE_PAYMENTS = "
		SELECT MV.CDTIPORECE, TR.NMTIPORECE, MV.VRMOVIVEND
		  FROM MOVCAIXA MV
      JOIN TIPORECE TR
        ON MV.CDTIPORECE = TR.CDTIPORECE
		 WHERE MV.CDFILIAL   = :CDFILIAL
		   AND MV.CDCAIXA    = :CDCAIXA
		   AND MV.NRSEQVENDA = :NRSEQVENDA
    ";

  const ORACLE_GET_EXTRACT_BY_PERIOD = "
		SELECT V.CDCLIENTE, V.CDCONSUMIDOR, V.CDFILIAL, TO_CHAR(V.DTVENDA, 'DD/MM/YYYY') AS DTVENDA,
			     SUM(IT.VRUNITVEND * IT.QTPRODVEND - IT.VRDESITVEND + IT.VRACRITVEND) AS VRTOTALVENDA,
           NVL(EC.VRSALDCONEXT, 0) AS VRSALDCONEXT, TO_CHAR(DTHRAGENDADA, 'DD/MM/YYYY HH24:MI:SS') AS DTHRAGENDADA
		  FROM VENDA V
		  JOIN ITEMVENDA IT
        ON V.CDFILIAL = IT.CDFILIAL
		   AND V.CDCAIXA = IT.CDCAIXA
		   AND V.NRSEQVENDA = IT.NRSEQVENDA
 LEFT JOIN EXTRATOCONS EC
		    ON V.CDCONSUMIDOR = EC.CDCONSUMIDOR
		   AND V.NRSEQVENDA = EC.NRSEQVENDA
		 WHERE V.IDSITUVENDA = 'O'
		   AND V.CDCLIENTE = :CDCLIENTE
		   AND V.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND TRUNC(V.DTFECHAVENDA) BETWEEN TO_DATE(:DTINIPERIODO, 'DD/MM/YYYY') AND TO_DATE(:DTFIMPERIODO, 'DD/MM/YYYY')
  GROUP BY V.NRSEQVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.CDFILIAL, 
			     V.DTVENDA, EC.VRSALDCONEXT, TO_CHAR(DTHRAGENDADA, 'DD/MM/YYYY HH24:MI:SS')
    ";

  const SQL_GET_EXTRACT_BY_PERIOD = "
		SELECT V.CDCLIENTE, V.CDCONSUMIDOR, V.CDFILIAL, CONVERT(VARCHAR(10), V.DTVENDA, 103) AS DTVENDA,
			     SUM(IT.VRUNITVEND * IT.QTPRODVEND - IT.VRDESITVEND + IT.VRACRITVEND) AS VRTOTALVENDA,
			     ISNULL(EC.VRSALDCONEXT, 0) AS VRSALDCONEXT,
			     CONVERT(VARCHAR(12), V.DTHRAGENDADA, 103)+' '+CONVERT(VARCHAR(12), V.DTHRAGENDADA, 108) AS DTHRAGENDADA
		  FROM VENDA V
		  JOIN ITEMVENDA IT
			  ON V.CDFILIAL = IT.CDFILIAL
		   AND V.CDCAIXA = IT.CDCAIXA
		   AND V.NRSEQVENDA = IT.NRSEQVENDA
 LEFT JOIN EXTRATOCONS EC
		    ON V.CDCONSUMIDOR = EC.CDCONSUMIDOR
		   AND V.NRSEQVENDA = EC.NRSEQVENDA
		 WHERE V.IDSITUVENDA  = 'O'
		   AND V.CDCLIENTE = :CDCLIENTE
		   AND V.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND CAST(V.DTFECHAVENDA AS DATE) BETWEEN CONVERT(DATE, :DTINIPERIODO, 120) AND CONVERT(DATE, :DTFIMPERIODO, 120)
  GROUP BY V.NRSEQVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.CDFILIAL, 
			     V.DTVENDA, EC.VRSALDCONEXT, V.DTHRAGENDADA
    ";

  const ORACLE_UPDATE_CONSUMER = "
    	UPDATE CONSUMIDOR
		     SET NMCONSUMIDOR    = :NMCONSUMIDOR,
		         CDCCUSCLIE      = :CDCCUSCLIE,
		         CDPAIS          = :CDPAIS,
		         SGESTADO        = :SGESTADO,
			       CDMUNICIPIO     = :CDMUNICIPIO,
			       CDTIPOCONS      = :CDTIPOCONS,
			       DSENDECONS      = :DSENDECONS,
			       NRCEPCONS       = :NRCEPCONS,
			       NRTELECONS      = :NRTELECONS,
			       DSEMAILCONS     = :DSEMAILCONS,
			       NRCPFRESPCON    = :NRCPFRESPCON,
			       IDSEXOCONS      = :IDSEXOCONS,
			       DTNASCCONS      = TO_DATE(NVL(:DTNASCCONS,TO_CHAR(SYSDATE,'DD/MM/YYYY')),'DD/MM/YYYY'),
		         DSCOMPLENDECONS = :DSCOMPLENDECONS,
			       NRCELULARCONS   = :NRCELULARCONS,
			       DSBAIRRO        = :DSBAIRRO,
			       NRENDECONS      = :NRENDECONS,
			       IDSITCONSUMI    = :IDATIVO
    	 WHERE CDCLIENTE       = :CDCLIENTE
    	   AND CDCONSUMIDOR    = :CDCONSUMIDOR
    ";

  const ORACLE_GET_OPEN_SALES = "
		SELECT V.DTHRABERMESA, C.NRCOMANDA, C.NRVENDAREST, C.CDFILIAL
		  FROM COMANDAVEN C, VENDAREST V  
		 WHERE C.CDFILIAL = V.CDFILIAL
		   AND C.NRVENDAREST = V.NRVENDAREST            	       
		   AND C.IDSTCOMANDA <> '4'	       
		   AND V.CDCONSUMIDOR = :CDCONSUMIDOR
		   AND V.CDCLIENTE = :CDCLIENTE
		   AND V.CDFILIAL IN (:CDFILIAL)
		   AND V.CDFILIAL||V.NRVENDARESTAUX NOT IN
		   				(SELECT VEN.CDFILIAL||VEN.NRVENDAREST 
					       FROM VENDA VEN
						    WHERE CDCONSUMIDOR = :CDCONSUMIDOR
						      AND CDCLIENTE = :CDCLIENTE
						      AND VEN.NRVENDAREST IS NOT NULL
							    AND VEN.CDFILIAL = V.CDFILIAL)
  ORDER BY DTHRABERMESA DESC
    ";

  const GET_CONSUMER_BY_ID = "
		SELECT CO.CDCONSUMIDOR, CO.NRCPFRESPCON, 
			     CO.NMCONSUMIDOR, CO.DSEMAILCONS, TO_CHAR(CO.DTNASCCONS, 'DD/MM/YYYY') AS DTNASCCONS, 
			     CO.IDSEXOCONS, CO.IDSITCONSUMI AS IDATIVO, CO.NRCEPCONS, CO.DSENDECONS, CO.NRENDECONS, 
			     MU.CDMUNICIBGE, CO.SGESTADO, PA.NMPAIS, CO.DSCOMPLENDECONS, 
			     BA.NMBAIRRO, CO.NRTELECONS, CO.NRCELULARCONS, 1 AS ISPRINCIPAL, TO_CHAR(CO.DTULTATUCSUM,'DD/MM/YYYY HH24:MI:SS') DTULTATUCSUM
		  FROM CONSUMIDOR CO
 LEFT JOIN PAIS PA
		    ON CO.CDPAIS = PA.CDPAIS
		  LEFT JOIN BAIRRO BA
		    ON CO.CDPAIS = BA.CDPAIS
		   AND CO.SGESTADO = BA.SGESTADO
		   AND CO.CDMUNICIPIO = BA.CDMUNICIPIO
		   AND CO.CDBAIRRO = BA.CDBAIRRO
 LEFT JOIN MUNICIPIO MU
		    ON CO.CDPAIS = MU.CDPAIS
		   AND CO.SGESTADO = MU.SGESTADO
		   AND CO.CDMUNICIPIO = MU.CDMUNICIPIO
		 WHERE CDCONSUMIDOR = :CDCONSUMIDOR
		   AND DTULTATUCSUM IN (SELECT MAX(DTULTATUCSUM)
		   	                      FROM CONSUMIDOR
		   	                     WHERE CDCONSUMIDOR = :CDCONSUMIDOR  
		   					   )
    ";

  const GET_CONSUMER_BY_CPF = "
		SELECT CO.NRCPFRESPCON, 
			     CO.NMCONSUMIDOR, CO.DSEMAILCONS, TO_CHAR(CO.DTNASCCONS, 'DD/MM/YYYY') AS DTNASCCONS, 
			     CO.IDSEXOCONS, CO.IDSITCONSUMI AS IDATIVO, CO.NRCEPCONS, CO.DSENDECONS, CO.NRENDECONS, 
			     MU.CDMUNICIBGE, CO.SGESTADO, PA.NMPAIS, CO.DSCOMPLENDECONS, 
			     BA.NMBAIRRO, CO.NRTELECONS, CO.NRCELULARCONS, 1 AS ISPRINCIPAL, 
			     TO_CHAR(CO.DTULTATUCSUM,'DD/MM/YYYY HH24:MI:SS') DTULTATUCSUM
		  FROM CONSUMIDOR CO
 LEFT JOIN PAIS PA
		    ON CO.CDPAIS = PA.CDPAIS
 LEFT JOIN BAIRRO BA
		    ON CO.CDPAIS = BA.CDPAIS
		   AND CO.SGESTADO = BA.SGESTADO
		   AND CO.CDMUNICIPIO = BA.CDMUNICIPIO
		   AND CO.CDBAIRRO = BA.CDBAIRRO
 LEFT JOIN MUNICIPIO MU
		    ON CO.CDPAIS = MU.CDPAIS
		   AND CO.SGESTADO = MU.SGESTADO
		   AND CO.CDMUNICIPIO = MU.CDMUNICIPIO
		 WHERE NRCPFRESPCON = :NRCPFRESPCON
		   AND DTULTATUCSUM IN (SELECT MAX(DTULTATUCSUM)
		   	                      FROM CONSUMIDOR
		   	                     WHERE NRCPFRESPCON = :NRCPFRESPCON  
		   					   )
    ";

  const GET_CONSUMER_GROUPS = "
	   SELECT C.CDCLIENTE, C.CDCCUSCLIE, C.CDTIPOCONS, T.NMTIPOCONS, C.IDSITCONSUMI AS IDATIVO, TO_CHAR(C.DTULTATUCSUM,'DD/MM/YYYY HH24:MI:SS') DTULTATUCSUM
	     FROM CONSUMIDOR C
	     JOIN TIPOCONS T	
	       ON C.CDTIPOCONS   = T.CDTIPOCONS
	    WHERE C.CDCONSUMIDOR = :CDCONSUMIDOR 
    ";

  const GET_CONSUMER_GROUPS_BY_CPF = "
	   SELECT C.CDCLIENTE, C.CDCONSUMIDOR, C.CDCCUSCLIE, C.CDTIPOCONS, T.NMTIPOCONS, C.IDSITCONSUMI AS IDATIVO,
	    	    TO_CHAR(C.DTULTATUCSUM,'DD/MM/YYYY HH24:MI:SS') DTULTATUCSUM, SAL.CDFAMILISALD
	     FROM CONSUMIDOR C
	     JOIN TIPOCONS T	
	       ON C.CDTIPOCONS   = T.CDTIPOCONS
  LEFT JOIN SALDOCONS SAL
         ON SAL.CDCLIENTE    = C.CDCLIENTE
        AND SAL.CDCONSUMIDOR = C.CDCONSUMIDOR
      WHERE C.NRCPFRESPCON   = :NRCPFRESPCON 
    ";

  const CHECK_VALID_CHECKINID = "
		SELECT IDCHECKIN
      FROM CHECKINMESPOS CK
      JOIN VENDAREST VR
        ON CK.CDFILIAL = VR.CDFILIAL
       AND CK.NRVENDAREST = VR.NRVENDAREST
     WHERE IDCHECKIN = :IDCHECKIN
       AND VR.DTHRFECHMESA IS NULL
    ";

  const CONSUMER_CHECKED = "
		SELECT IDCHECKIN
      FROM CHECKINMESPOS
     WHERE CDCLIENTE = :CDCLIENTE
		   AND CDCONSUMIDOR = :CDCONSUMIDOR
		   AND IDCHECKIN <> :IDCHECKIN
    ";

  const UPDATE_CHECKIN_CONSUMER = "
		UPDATE CHECKINMESPOS
		   SET CDCLIENTE = :CDCLIENTE,
		       CDCONSUMIDOR = :CDCONSUMIDOR
	 	 WHERE IDCHECKIN = :IDCHECKIN       
    ";

  const GET_RESULT_CHECKINMESPOS = "
		SELECT CK.CDFILIAL, CK.NRVENDAREST, CK.NRPOSICAO, CK.NRCOMANDA, VR.NRMESA, VR.CDLOJA, CK.CDCLIENTE, CK.CDCONSUMIDOR
		  FROM CHECKINMESPOS CK
		  JOIN VENDAREST VR
        ON CK.CDFILIAL = VR.CDFILIAL
       AND CK.NRVENDAREST = VR.NRVENDAREST
		 WHERE IDCHECKIN = :IDCHECKIN
    ";

  const SQL_GET_TABLE_BILL = "
		SELECT VR.CDCLIENTE, VR.CDCONSUMIDOR, VR.CDFILIAL, CV.NRCOMANDA, VR.NRVENDAREST, VR.NRMESA,
           CONVERT(VARCHAR(12), VR.DTHRABERMESA, 103)+' '+CONVERT(VARCHAR(12), VR.DTHRABERMESA, 108) AS DTVENDA, 
           CV.IDSTCOMANDA, CV.IDRETBALLOJA, CV.VRACRCOMANDA, CV.VRDESCOMANDA, 
           ISNULL(M.CDMUNICIBGE,'N/E') CDMUNICIBGE, 'BR' CDPAIS , CV.SGESTADO, CV.DSENDECONSCOMAN, CV.DSCOMPLENDCOCOM, CV.NRCEPCONSCOMAND,
           CV.DSREFENDCONSCOM, CV.DSBAIRRO,1 ISOPEN,IT.NRLUGARMESA NRPOSICAO,CHCK.IDCHECKIN,CONS.NMCONSUMIDOR,SUM(IT.VRPRECCOMVEN) AS VRPRECCOMVEN,
           CONVERT(VARCHAR(12), CV.DTHRAGENDADA, 103)+' '+CONVERT(VARCHAR(12), CV.DTHRAGENDADA, 108) AS DTHRAGENDADA
		  FROM COMANDAVEN CV
	    JOIN VENDAREST VR
	      ON CV.CDFILIAL = VR.CDFILIAL
	     AND CV.NRVENDAREST = VR.NRVENDAREST
 LEFT JOIN MUNICIPIO M 
 	 		  ON CV.CDMUNICIPIO = M.CDMUNICIPIO
       AND CV.SGESTADO = M.SGESTADO
       AND CV.CDPAIS = M.CDPAIS
      JOIN ITCOMANDAVEN IT
        ON CV.NRCOMANDA = IT.NRCOMANDA
       AND CV.NRVENDAREST = IT.NRVENDAREST
       AND CV.CDFILIAL = IT.CDFILIAL 
 LEFT JOIN CHECKINMESPOS  CHCK
        ON CHCK.NRCOMANDA = CV.NRCOMANDA
       AND CHCK.NRVENDAREST = CV.NRVENDAREST
       AND CHCK.CDFILIAL = CV.CDFILIAL
       AND CAST(IT.NRLUGARMESA AS INT) = CAST(CHCK.NRPOSICAO  AS INT)
 LEFT JOIN CONSUMIDOR CONS
        ON CHCK.CDCONSUMIDOR = CONS.CDCONSUMIDOR
       AND CHCK.CDCLIENTE = CONS.CDCLIENTE 
		 WHERE CV.NRCOMANDA = :NRCOMANDA
		   AND CV.NRVENDAREST = :NRVENDAREST
		   AND CV.CDFILIAL = :CDFILIAL
       AND IT.IDSTPRCOMVEN <> '6'
  GROUP BY VR.CDCLIENTE, VR.CDCONSUMIDOR, VR.CDFILIAL, CV.NRCOMANDA, VR.NRVENDAREST, VR.NRMESA,
			     VR.DTHRABERMESA, CV.IDSTCOMANDA, CV.IDRETBALLOJA, CV.VRACRCOMANDA, CV.VRDESCOMANDA,
			     M.CDMUNICIBGE, CV.SGESTADO, CV.DSENDECONSCOMAN, CV.DSCOMPLENDCOCOM, CV.NRCEPCONSCOMAND,
           CV.DSREFENDCONSCOM, CV.DSBAIRRO, IT.NRLUGARMESA, CHCK.IDCHECKIN,
           CONS.NMCONSUMIDOR, CV.DTHRAGENDADA
    ";

  const SQL_GET_POSITION_PRODUCTS = "
		SELECT IT.CDPRODUTO, PR.NMPRODUTO, ISNULL(PR.DSPRODVENDA, '') AS DESCRIPTION, '' AS CDPRODPROMOCAO, 
			     IT.VRPRECCOMVEN , IT.QTPRODCOMVEN , IT.VRDESCCOMVEN, IT.VRACRCOMVEN, IT.NRINSCRCONS, IT.NRPRODCOMVEN
		  FROM ITCOMANDAVEN IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRVENDAREST = :NRVENDAREST
       AND IT.NRCOMANDA = :NRCOMANDA
       AND IT.NRLUGARMESA = :NRPOSICAO
       AND IT.IDSTPRCOMVEN <> '6'
		   AND IT.CDPRODPROMOCAO IS NULL
    ";

  const SQL_GET_POSITION_COMBOS = "
		SELECT IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, PR.NMPRODUTO, IT.NRSEQPRODCOM,
			     SUM(IT.VRPRECCOMVEN) VRPRECCOMVEN, SUM(IT.VRDESCCOMVEN) VRDESCCOMVEN, SUM(IT.VRACRCOMVEN) VRACRCOMVEN
		  FROM ITCOMANDAVEN IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODPROMOCAO = PR.CDPRODUTO
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRVENDAREST = :NRVENDAREST
       AND IT.NRCOMANDA = :NRCOMANDA
		   AND IT.NRLUGARMESA = :NRPOSICAO
		   AND IT.IDSTPRCOMVEN <> '6'
       AND IT.CDPRODPROMOCAO IS NOT NULL
  GROUP BY IT.CDFILIAL, IT.NRVENDAREST, IT.NRCOMANDA, IT.CDPRODPROMOCAO, PR.NMPRODUTO, IT.NRSEQPRODCOM
    ";

  const ORACLE_GET_POSITION_COMBO_PRODUCTS = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
			     IT.VRPRECCOMVEN , IT.QTPRODCOMVEN , IT.VRDESCCOMVEN, IT.VRACRCOMVEN, IT.NRINSCRCONS, IT.NRPRODCOMVEN
		  FROM ITCOMANDAVEN IT
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		 WHERE IT.CDFILIAL = :CDFILIAL
		   AND IT.NRVENDAREST = :NRVENDAREST
       AND IT.NRCOMANDA = :NRCOMANDA
		   AND IT.CDPRODPROMOCAO = :CDPRODPROMOCAO
		   AND IT.NRSEQPRODCOM = :NRSEQPRODCOM
    ";

  const SQL_INSERT_EXTRACT_MOVEMENT = "
		INSERT INTO EXTRATOCONS 
		            (CDCLIENTE,CDCONSUMIDOR, CDFAMILISALD, DTMOVEXTCONS, NRSEQMOVEXT, DSOPEEXTCONS,VRMOVEXTCONS,IDTPMOVEXT,CDFILIAL,VRSALDCONEXT)
		     VALUES (:CDCLIENTE,:CDCONSUMIDOR,:CDFAMILISALD,TO_DATE(:DTMOVEXTCONS, 'DD/MM/YYYY HH24:MI:SS'), :NRSEQMOVEXT, :DSOPEEXTCONS,:VRMOVEXTCONS,:IDTPMOVEXT,:CDFILIAL,:VRSALDCONEXT)       
    ";

  const GET_GROUPS = "
    SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,
           IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, IT.DSENDEIMG, IT.DSENDEIMGAUX, IT.DSITMENUVENDA
		  FROM ITMENUCONFTE IT
		  JOIN CAIXA CX
		    ON IT.CDFILIAL   = CX.CDFILIAL
		   AND IT.NRCONFTELA = CX.NRCONFTELA
		   AND CX.CDFILIAL = :CDFILIAL
		   AND CX.CDCAIXA  = :CDCAIXA
		   AND IT.IDTPBUTTON = '2'
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON
    ";

  const GET_GROUPS_CONFTELA = "	
    SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,	
           IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, IT.DSENDEIMG, IT.DSENDEIMGAUX, IT.DSITMENUVENDA	
      FROM ITMENUCONFTE IT	
      JOIN CONFTELACAIXA CFTX	
        ON IT.CDFILIAL   = CFTX.CDFILIAL	
       AND IT.NRCONFTELA = CFTX.NRCONFTELA	
       AND CFTX.CDFILIAL = :CDFILIAL	
       AND CFTX.CDCAIXA  = :CDCAIXA	
       AND IT.IDTPBUTTON = '2'	
       AND CFTX.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)	
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON	
    ";


    const GET_GROUPS_FROM_CONFTELA_EX = "	
      SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,	
             IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, IT.DSENDEIMG, IT.DSENDEIMGAUX, 
             IT.DSITMENUVENDA	
        FROM ITMENUCONFTE IT	
      WHERE IT.CDFILIAL = :CDFILIAL
        AND IT.NRCONFTELA = :NRCONFTELA
        AND IT.IDTPBUTTON = '2'	
      ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON	
    ";

    const GET_SUB_GROUPS_FROM_CONFTELA_EX = "
      SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,	
             IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, IT.DSENDEIMG, IT.DSENDEIMGAUX, 
             IT.DSITMENUVENDA	
        FROM ITMENUCONFTE IT
       WHERE IT.CDFILIAL = :CDFILIAL
         AND IT.NRCONFTELA = :NRCONFTELA
         AND IT.IDTPBUTTON = 'I'	
       ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON  
    ";

    const GET_PRODUCTS_FROM_CONFTELA_EX = "	
    SELECT DISTINCT PD.CDBARPRODUTO, PD.CDPRODUTO, IT.DSBUTTON, ISNULL(PD.DSPRODVENDA, '') AS DESCRIPTION, 
           ISNULL(IT.DSENDEIMG, PD.DSENDEIMG) DSENDEIMG, PD.IDIMPPRODUTO, PD.IDTIPOPROD, PD.IDIMPPRODUTO, 
           PD.IDTIPOCOMPPROD, GPP.CDPRODPROMOCAO, IT.NRBUTTONAUX, IT.NRPGCONFTAUX, IT.IDTPBUTONAUX,
           IT.NRPGCONFTAUX2, IT.NRBUTTONAUX2, IT.IDTPBUTONAUX2, IT.IDEXIBEAPPCONS, IT.NRPGCONFTELA, IT.NRBUTTON
        FROM ITMENUCONFTE IT
        JOIN PRODUTO PD
          ON IT.CDIDENTBUTON = PD.CDPRODUTO
        LEFT JOIN GRUPROMOCPROD GPP
          ON GPP.CDPRODPROMOCAO = PD.CDPRODUTO
      WHERE IT.IDTPBUTTON = '1'
        AND IT.CDFILIAL = :CDFILIAL
        AND IT.NRCONFTELA = :NRCONFTELA
      ORDER BY IT.NRBUTTON
    ";


    const GET_LOCAL_GROUPS_PROMO_FROM_CONFTELA_EX = "	
      SELECT GP.NMGRUPROMOC, PF.CDPRODPROMOCAO, PF.CDGRUPROMOC, PF.QTPRGRUPROMINFIL AS QTPRGRUPROMIN,
	        PF.QTPRGRUPPROMFIL AS QTPRGRUPPROMOC, PF.CDGRUPMUTEXFIL AS CDGRUPMUTEX, PF.IDIMPGRPROMOFIL AS IDIMPGRPROMO
        FROM GRUPROMOCPRFIL PF
          JOIN GRUPROMOC GP
            ON PF.CDGRUPROMOC = GP.CDGRUPROMOC
        WHERE 
          PF.CDFILIAL = :CDFILIAL
        AND PF.CDPRODPROMOCAO IN (:ARR)
      ORDER BY PF.NRORDPROMOGRUPFIL, GP.CDGRUPROMOC
    ";

    const GET_ADDITIONAL_PRODUCTS_EX = "
      SELECT A.IDCOBRAADIC, A.CDPRODUTO, A.CDSUBPRODUTO, P.CDARVPROD, P.NMPRODUTO, A.IDMODOVENDA, A.QTPRODADIC
        FROM PRODUTOADIC A, PRODUTO P 
        WHERE (A.CDSUBPRODUTO = P.CDPRODUTO)
     ORDER BY A.CDSUBPRODUTO, A.IDMODOVENDA
    ";

    const GET_GROUPS_PROMO_FROM_CONFTELA_EX = "	
      SELECT GP.NMGRUPROMOC, GPP.CDPRODPROMOCAO, GPP.CDGRUPROMOC, GPP.QTPRGRUPROMIN, GPP.QTPRGRUPPROMOC, GPP.CDGRUPMUTEX, GPP.IDIMPGRPROMO
        FROM GRUPROMOCPROD GPP
        JOIN GRUPROMOC GP
          ON GP.CDGRUPROMOC = GPP.CDGRUPROMOC
       WHERE CDPRODPROMOCAO IN (?)
       ORDER BY GPP.NRORDPROMOGRUP, GPP.CDGRUPROMOC
    ";

    const GET_OBSERVATIONS_FROM_CONFTELA_EX = "	
      SELECT GR.DSGRPOCOR, GR.CDGRPOCOR, OC.CDOCORR, PR.CDPRODUTO AS CDPRODUTOPAI, OC.CDPRODUTO AS CDPRODUTOOBS, OC.DSOCORR, '0.00' AS PRICE, 
      OC.IDCONTROLAOBS, ISNULL(GR.NRMINOCORR, '0') AS NRMINOCORR, ISNULL(GR.NRMAXOCORR, '0') AS NRMAXOCORR,
      OC.DSENDEIMGOCORR, 
      OC.IDEXIOBSAPPCONS, OC.NRORDOBSGRPOCOR
        FROM GRUPOCOR GR
        JOIN PRODOCORRE PR
          ON PR.CDGRPOCOR = GR.CDGRPOCOR
        JOIN LOJA LJ
          ON GR.CDGRPOCOR = LJ.CDGRPOCORPED
        JOIN OCORRENCIA OC
          ON GR.CDGRPOCOR = OC.CDGRPOCOR
         AND PR.CDOCORR   = OC.CDOCORR
       WHERE LJ.CDFILIAL IN (?)
         AND LJ.CDLOJA IN (?)
    ";

    const GET_GROUP_PROMO_PRODS_FROM_CONFTELA_EX = "	
      SELECT PD.CDPRODUTO, PD.CDBARPRODUTO, COALESCE(PG.DSAPELIDOMOB, PG.DSAPELIDOPROD, PD.DSPRODVENDA, IT.DSBUTTON, PD.NMPRODUTO) AS DSBUTTON,
            ISNULL(PD.DSPRODVENDA, '') AS DESCRIPTION, ISNULL(IT.DSENDEIMG, PD.DSENDEIMG) DSENDEIMG, PD.IDIMPPRODUTO, PD.IDTIPOPROD,
            PD.IDIMPPRODUTO, PD.IDTIPOCOMPPROD, PG.CDGRUPROMOC, GPP.CDPRODPROMOCAO, IT.IDEXIBEAPPCONS, IT.NRPGCONFTELA, IT.NRBUTTON
          FROM PRODGRUPROMOC PG
          JOIN PRODUTO PD
            ON PD.CDPRODUTO = PG.CDPRODUTO
          LEFT JOIN ITMENUCONFTE IT
            ON IT.CDIDENTBUTON = PD.CDPRODUTO
          AND IT.NRCONFTELA IN (?)
          LEFT JOIN GRUPROMOCPROD GPP
            ON GPP.CDPRODPROMOCAO = PD.CDPRODUTO
          AND GPP.CDGRUPROMOC = PG.CDGRUPROMOC
        WHERE PG.CDGRUPROMOC IN (?)
      ";

    const GET_IDPRODPRESELEC = "
      SELECT CDPRODUTO
        FROM DESGRUPROMOCPR
        WHERE CDGRUPROMOC = :CDGRUPROMOC
          AND CDPRODPROMOCAO = :CDPRODPROMOCAO
          AND IDPRODPRESELEC = 'S'
    ";

    const GET_IDOBRPRODSELEC = "
      SELECT CDPRODUTO
        FROM DESGRUPROMOCPR
        WHERE CDGRUPROMOC = :CDGRUPROMOC
          AND CDPRODPROMOCAO = :CDPRODPROMOCAO
          AND IDOBRPRODSELEC = 'S'
    ";

    const GET_IDPRINCPROD = "
      SELECT CDPRODUTO
        FROM DESGRUPROMOCPR
        WHERE CDGRUPROMOC = :CDGRUPROMOC
          AND CDPRODPROMOCAO = :CDPRODPROMOCAO
          AND IDPRINCPROD = 'S'
    ";

    const GET_BRANCH_TABEPRECDIA_PRICES = "
      SELECT NRDIASEMANPR, HRINIPRECDIA, HRFINPRECDIA, CDTIPOCONSPD, VRPRECODIA, IDPERVALORPR, IDDESCACREPR, VRPRECODIF, VRPRECODIADLV, VRPRECODIACMD
        FROM ITEMPRECODIA
       WHERE CDFILIAL = :CDFILIAL
         AND CDTABEPREC = :CDTABEPREC
    ";

    const GET_GENERAL_TABEPRECDIA_PRICES = "
      SELECT NRDIASEMANPR, HRINIPRECDIA, HRFINPRECDIA, CDTIPOCONSPD, VRPRECODIA, IDPERVALORPR, IDDESCACREPR, VRPRECODIF, VRPRECODIADLV, VRPRECODIACMD
        FROM ITEMPRECODIAGER
       WHERE CDTABEPREC = :CDTABEPREC
    ";

    const GET_BRANCH_DIFF_PRICES = "
      SELECT CDGRUPROMOC, CDPRODPROMOCAO, IDPERVALDESFIL AS IDPERVALORDES, VRDESPRPROMOFIL AS VRDESPRODPROMOC, IDDESCACRPROFIL AS IDDESCACRPROMO, IDPRODPRESELFIL AS IDPRODPRESELEC
        FROM DESGRUPROMPRFIL
       WHERE CDFILIAL = :CDFILIAL
    ";

    const GET_GENERAL_DIFF_PRICES = "
      SELECT CDGRUPROMOC, CDPRODPROMOCAO, IDPERVALORDES, VRDESPRODPROMOC, IDDESCACRPROMO, IDPRODPRESELEC
        FROM DESGRUPROMOCPR      
    ";

    const GET_CLIENT_BRANCH_TABEPREC = "
      SELECT CDTABEPREC, CDCFILTABPRE
        FROM CLIENFILIAL
       WHERE CDCLIENTE = :CDCLIENTE
         AND CDFILIAL = :CDFILIAL
    ";

    const GET_CLIENT_TABEPREC = "
      SELECT CDTABEPREC, CDFILTABPREC
        FROM CLIENTE
       WHERE (CDCLIENTE = :CDCLIENTE)
    ";

    const GET_STORE_TABEPREC = "
      SELECT CDTABEPREC
        FROM LOJA
       WHERE (CDFILIAL = :CDFILIAL)
         AND (CDLOJA = :CDLOJA)
    ";

    const GET_BRANCH_TABEPREC = "
      SELECT CDTABEPREC, IDPRECDIFCOM
        FROM PARAVEND
       WHERE (CDFILIAL = :CDFILIAL)
    ";

    const GET_TABEPREC_VIG = "
      SELECT DTINIVGPREC
        FROM TABEVEND
       WHERE (CDFILIAL = :CDFILIAL)
         AND (CDTABEPREC = :CDTABEPREC)
         AND (CONVERT(DATE, :DATA, 120) BETWEEN DTINIVGPREC AND DTFINVGPREC)
    ";

    const GET_GENERAL_TABEPREC = "
      SELECT T.CDTABEPREC, T.DTINIVGPREC
        FROM TABEVENDGER T, FILITABGER FT
       WHERE (FT.CDFILIAL = :CDFILIAL)
         AND (T.CDTABEPREC = FT.CDTABEPREC)
         AND (CONVERT(DATE, :DATA, 120) BETWEEN DTINIVGPREC AND DTFINVGPREC)
    ";

    const GET_BRANCH_TABEPREC_PRICES = "
      SELECT CDPRODUTO,
             ISNULL(VRPRECITEM, 0) AS PRECO,
             ISNULL(VRPRECITEMCL, 0) AS PRECOCLIE,
             ISNULL(VRPRESUGITEM, 0) AS PRECOSUGER,
             IDPRECVARIA,
             HRINIVENPROD,
             HRFIMVENPROD,
             ISNULL(VRPRECITEMDLV, 0) AS PRECODLV,
             ISNULL(VRPRECITEMCMD, 0) AS PRECOCMD
        FROM ITEMPRECO
       WHERE (CDFILIAL = :CDFILIAL)
         AND (CDTABEPREC = :CDTABEPREC)
    ";

    const GET_GENERAL_TABEPREC_PRICES = "
      SELECT CDPRODUTO,
             ISNULL(VRPRECITEM, 0) AS PRECO,
             ISNULL(VRPRECITEMCL, 0) AS PRECOCLIE,
             ISNULL(VRPRESUGITEM, 0) AS PRECOSUGER,
             IDPRECVARIA,
             HRINIVENPROD,
             HRFIMVENPROD,
             ISNULL(VRPRECITEMDLV, 0) AS PRECODLV,
             ISNULL(VRPRECITEMCMD, 0) AS PRECOCMD
        FROM ITEMPRECOGER
       WHERE (CDTABEPREC = :CDTABEPREC)
    ";

    const GET_BRANCH_DAILY_PRICES = "
      SELECT CDPRODUTO, CDPRPAITABPR, VRPRECODIA, IDPERVALORPR, IDDESCACREPR, IDVISUACUPOM, CDTIPOCONSPD, VRPRECODIADLV, VRPRECODIACMD
        FROM ITEMPRECODIA
       WHERE (CDFILIAL      = :CDFILIAL)
         AND (CDTABEPREC    = :CDTABEPREC)
         AND ((NRDIASEMANPR  = :NRDIASEMANPR) OR (NRDIASEMANPR = 'T'))
         AND ((CDTIPOCONSPD = :CDTIPOCONSPD) OR (CDTIPOCONSPD = 'T'))
         AND (CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)) BETWEEN
              CONVERT(DATETIME, CONVERT(VARCHAR,DTINIVALPREC,103)) AND CONVERT
              (DATETIME,CONVERT(VARCHAR,DTFINVALPREC,103)))
    ";

    const GET_GENERAL_DAILY_PRICES = "
      SELECT CDPRODUTO, CDPRPAITABPR, VRPRECODIA, IDPERVALORPR, IDDESCACREPR, IDVISUACUPOM, CDTIPOCONSPD, VRPRECODIADLV, VRPRECODIACMD
        FROM ITEMPRECODIAGER
       WHERE (CDTABEPREC    = :CDTABEPREC)
         AND ((NRDIASEMANPR  = :NRDIASEMANPR) OR (NRDIASEMANPR = 'T'))
         AND ((CDTIPOCONSPD = :CDTIPOCONSPD) OR (CDTIPOCONSPD = 'T'))
         AND (CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)) BETWEEN
              CONVERT(DATETIME, CONVERT(VARCHAR,DTINIVALPREC,103)) AND CONVERT
              (DATETIME,CONVERT(VARCHAR,DTFINVALPREC,103)))
    ";

    const HOLIDAY_CHECK = "
        SELECT DTFERIFILI
          FROM FERIFILI
         WHERE CDFILIAL   = :CDFILIAL
           AND DTFERIFILI = :DTFERIFILI
    ";

    const GET_BRANCH_COMBO_PRICES = "
      SELECT CDPRODPROMOCAO, CDGRUPROMOC, CDPRODUTO, NRSEQGRPROMOFIL AS NRSEQGRPROMO, IDPERVALDESFIL AS IDPERCVALOR, VRDESPRPROMOFIL AS VRDESCACR, IDAPLICADESCPRFI AS IDAPLICADESCONTO, IDDESCACRPROFIL AS IDDESCACRPROMO
        FROM DESGRUPROMPRFIL
       WHERE CDFILIAL = :CDFILIAL
         AND VRDESPRPROMOFIL <> 0
    ";

    const GET_GENERAL_COMBO_PRICES = "
      SELECT CDPRODPROMOCAO, CDGRUPROMOC, CDPRODUTO, NRSEQGRPROMO, IDPERVALORDES AS IDPERCVALOR, VRDESPRODPROMOC AS VRDESCACR, IDAPLICADESCPR AS IDAPLICADESCONTO, IDDESCACRPROMO AS IDDESCACRPROMO
        FROM DESGRUPROMOCPR
       WHERE VRDESPRODPROMOC <> 0
    ";

    const GET_FAM_SALD_PRODS = "
      SELECT CDFAMILISALD, CDPRODUTO
        FROM FAMSALDOPROD
       WHERE CDFILIAL = :CDFILIAL
    ";

    const GET_PRODBLOQVNDTAA =  "
      SELECT CDPRODUTO FROM PRODBLOQVNDTAA
       WHERE CDFILIAL = :CDFILIAL
         AND CDLOJA = :CDLOJA
         AND ((NRDIASEMANABLOQ = :NRDIASEMANABLOQ) OR (NRDIASEMANABLOQ = 'T'))
    ";

    const GET_PRODBLOQVND =  "
      SELECT CDPRODUTO FROM PRODBLOQVND
       WHERE CDFILIAL = :CDFILIAL
         AND CDLOJA = :CDLOJA
         AND ((NRDIASEMANABLOQ = :NRDIASEMANABLOQ) OR (NRDIASEMANABLOQ = 'T'))
    ";

  const ORACLE_GET_GROUP_PRODUCTS = "
    SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO,
           PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, NVL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG,
           PR.CDBARPRODUTO, PR.IDIMPPRODUTO	
      FROM ITMENUCONFTE IT
      JOIN PRODUTO PR
        ON IT.CDIDENTBUTON = PR.CDPRODUTO
      JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, 
                   IT.NRPGCONFTELA, IT.NRBUTTON
              FROM ITMENUCONFTE IT
              JOIN CAIXA CX
                ON IT.CDFILIAL = CX.CDFILIAL
               AND IT.NRCONFTELA = CX.NRCONFTELA
               AND CX.CDFILIAL = :CDFILIAL
               AND CX.CDCAIXA  = :CDCAIXA
               AND IDTPBUTTON = '2') GR
        ON IT.NRCONFTELA = GR.NRCONFTELA
       AND IT.CDFILIAL   = GR.CDFILIAL
       AND IT.NRPGCONFTAUX = GR.NRPGCONFTELA
       AND IT.NRBUTTONAUX  = GR.NRBUTTON
       AND IT.IDTPBUTTON = '1'
       AND (IT.IDTPBUTONAUX2 IS NULL OR IT.IDTPBUTONAUX2 = 0)
       AND IT.NRPGCONFTAUX = :NRPGCONFTELA
       AND IT.NRBUTTONAUX  = :NRBUTTON
       AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO
           								           FROM PRODBLOQVND
           								          WHERE CDFILIAL = :CDFILIAL
           								            AND CDLOJA = :CDLOJA)
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON
    ";

  const ORACLE_GET_GROUP_PRODUCTS_CONFTELACX = "	
    SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO, PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, NVL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG, PR.CDBARPRODUTO, PR.IDIMPPRODUTO	
      FROM ITMENUCONFTE IT	
      JOIN PRODUTO PR	
        ON IT.CDIDENTBUTON = PR.CDPRODUTO	
      JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, 	
                   IT.NRPGCONFTELA, IT.NRBUTTON	
              FROM ITMENUCONFTE IT	
              JOIN CONFTELACAIXA CX	
              ON IT.CDFILIAL = CX.CDFILIAL	
              AND IT.NRCONFTELA = CX.NRCONFTELA	
              AND CX.CDFILICAIXA = :CDFILIAL	
              AND CX.CDCAIXA  = :CDCAIXA	
              AND IDTPBUTTON = '2'	
       AND CX.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)) GR	
        ON IT.NRCONFTELA = GR.NRCONFTELA	
       AND IT.CDFILIAL   = GR.CDFILIAL	
       AND IT.NRPGCONFTAUX = GR.NRPGCONFTELA	
       AND IT.NRBUTTONAUX  = GR.NRBUTTON	
       AND IT.IDTPBUTTON = '1'	
       AND (IT.IDTPBUTONAUX2 IS NULL OR IT.IDTPBUTONAUX2 = 0)	
       AND IT.NRPGCONFTAUX = :NRPGCONFTELA	
       AND IT.NRBUTTONAUX  = :NRBUTTON	
       AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO	
                                     FROM PRODBLOQVND	
                                    WHERE CDFILIAL = :CDFILIAL	
                                      AND CDLOJA = :CDLOJA)	
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON	
    ";

  const SQL_GET_GROUP_PRODUCTS = "
    SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO,
           PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, ISNULL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG,
           PR.CDBARPRODUTO, PR.IDIMPPRODUTO
      FROM ITMENUCONFTE IT
      JOIN PRODUTO PR
        ON IT.CDIDENTBUTON = PR.CDPRODUTO
      JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, 
                   IT.NRPGCONFTELA, IT.NRBUTTON
              FROM ITMENUCONFTE IT
              JOIN CAIXA CX
                ON IT.CDFILIAL = CX.CDFILIAL
               AND IT.NRCONFTELA = CX.NRCONFTELA
               AND CX.CDFILIAL = :CDFILIAL
               AND CX.CDCAIXA  = :CDCAIXA
               AND IDTPBUTTON = '2') GR
        ON IT.NRCONFTELA = GR.NRCONFTELA
       AND IT.CDFILIAL   = GR.CDFILIAL
       AND IT.NRPGCONFTAUX = GR.NRPGCONFTELA
       AND IT.NRBUTTONAUX  = GR.NRBUTTON
       AND IT.IDTPBUTTON = '1'
       AND (IT.IDTPBUTONAUX2 IS NULL OR IT.IDTPBUTONAUX2 = 0)
       AND IT.NRPGCONFTAUX = :NRPGCONFTELA
       AND IT.NRBUTTONAUX  = :NRBUTTON
       AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO
                                     FROM PRODBLOQVND
                                    WHERE CDFILIAL = :CDFILIAL
                                      AND CDLOJA = :CDLOJA)
    ";

  const SQL_GET_GROUP_PRODUCTS_CONFTELACX = "	
    SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO, PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, ISNULL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG, PR.CDBARPRODUTO, PR.IDIMPPRODUTO
      FROM ITMENUCONFTE IT	
      JOIN PRODUTO PR	
        ON IT.CDIDENTBUTON = PR.CDPRODUTO	
      JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, 	
                   IT.NRPGCONFTELA, IT.NRBUTTON	
              FROM ITMENUCONFTE IT	
              JOIN CONFTELACAIXA CX	
              ON IT.CDFILIAL = CX.CDFILIAL	
              AND IT.NRCONFTELA = CX.NRCONFTELA	
              AND CX.CDFILICAIXA = :CDFILIAL	
              AND CX.CDCAIXA  = :CDCAIXA	
              AND IDTPBUTTON = '2'	
       AND CX.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)) GR	
        ON IT.NRCONFTELA = GR.NRCONFTELA	
       AND IT.CDFILIAL   = GR.CDFILIAL	
       AND IT.NRPGCONFTAUX = GR.NRPGCONFTELA	
       AND IT.NRBUTTONAUX  = GR.NRBUTTON	
       AND IT.IDTPBUTTON = '1'	
       AND (IT.IDTPBUTONAUX2 IS NULL OR IT.IDTPBUTONAUX2 = 0)	
       AND IT.NRPGCONFTAUX = :NRPGCONFTELA	
       AND IT.NRBUTTONAUX  = :NRBUTTON	
       AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO	
                                     FROM PRODBLOQVND	
                                    WHERE CDFILIAL = :CDFILIAL	
                                      AND CDLOJA = :CDLOJA)	
    ";

  const GET_ALL_PRODUCTS_MENU = "
    SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO, PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, ISNULL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG,	
    PR.CDBARPRODUTO, PR.IDIMPPRODUTO, IT.IDTPBUTONAUX, IT.NRPGCONFTAUX, IT.NRBUTTONAUX, IT.NRPGCONFTAUX2, IT.NRBUTTONAUX2, IT.CDIDENTBUTON,
    IT.NRPGCONFTELA, IT.NRBUTTON
   FROM ITMENUCONFTE   IT	
   INNER JOIN CONFTELACAIXA       O ON IT.CDFILIAL = O.CDFILIAL AND IT.NRCONFTELA = O.NRCONFTELA 
    INNER JOIN PRODUTO PR 	
    ON IT.CDIDENTBUTON = PR.CDPRODUTO AND PR.IDPRODATIVPR = 'S' 	
     WHERE
	 O.CDFILICAIXA = :CDFILIAL
	 AND IT.IDTPBUTTON = '1'
   AND O.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)	
       AND O.CDCAIXA  = :CDCAIXA	
	AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO		
                                         FROM PRODBLOQVNDTAA		
                                       WHERE CDFILIAL = :CDFILIAL		
                                         AND CDLOJA = :CDLOJA)	
     		GROUP BY IT.CDIDENTBUTON, IT.DSBUTTON, PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, ISNULL(IT.DSENDEIMG, PR.DSENDEIMG),
                                         PR.CDBARPRODUTO, PR.IDIMPPRODUTO, IT.IDTPBUTONAUX, IT.NRPGCONFTAUX, IT.NRBUTTONAUX, IT.NRPGCONFTAUX2,
                                          IT.NRBUTTONAUX2, IT.CDIDENTBUTON, IT.NRPGCONFTELA, IT.NRBUTTON
    ";

  const GET_SUBGROUPS = "
    SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,
           IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, IT.DSENDEIMG, IT.DSENDEIMGAUX
		  FROM ITMENUCONFTE IT
		  JOIN CAIXA CX
		    ON IT.CDFILIAL = CX.CDFILIAL
		   AND IT.NRCONFTELA = CX.NRCONFTELA
		   AND CX.CDFILIAL = :CDFILIAL
		   AND CX.CDCAIXA = :CDCAIXA
		   AND IT.IDTPBUTTON = 'I'
		   AND IT.NRPGCONFTAUX = :NRPGCONFTELA
		   AND IT.NRBUTTONAUX = :NRBUTTON
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON
    ";

  const GET_SUBGROUPS_CONFTELACX = "	
    SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,	
           IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, IT.DSENDEIMG, IT.DSENDEIMGAUX
      FROM ITMENUCONFTE IT	
      JOIN CONFTELACAIXA CX	
        ON IT.CDFILIAL = CX.CDFILIAL	
       AND IT.NRCONFTELA = CX.NRCONFTELA	
       AND CX.CDFILICAIXA = :CDFILIAL	
       AND CX.CDCAIXA = :CDCAIXA	
       AND IT.IDTPBUTTON = 'I'	
       AND IT.NRPGCONFTAUX = :NRPGCONFTELA	
       AND IT.NRBUTTONAUX = :NRBUTTON	
       AND CX.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)	
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON	
    ";

  const GET_SUBGROUPS_CONFTELACX_NO_FILTER = "	
    SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,	
           IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, IT.DSENDEIMG, IT.DSENDEIMGAUX
      FROM ITMENUCONFTE IT	
      JOIN CONFTELACAIXA CX	
        ON IT.CDFILIAL = CX.CDFILIAL	
       AND IT.NRCONFTELA = CX.NRCONFTELA	
       AND CX.CDFILICAIXA = :CDFILIAL	
       AND CX.CDCAIXA = :CDCAIXA	
       AND IT.IDTPBUTTON = 'I'
       AND CX.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)	
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON	
    ";
  // AND IT.NRPGCONFTAUX = :NRPGCONFTELA	
  // AND IT.NRBUTTONAUX = :NRBUTTON	

  const ORACLE_GET_SUBGROUP_PRODUCTS = "
    SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO,
           PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, NVL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG,
           PR.CDBARPRODUTO, PR.IDIMPPRODUTO
      FROM ITMENUCONFTE IT
      JOIN PRODUTO PR
        ON IT.CDIDENTBUTON = PR.CDPRODUTO
      JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, 
                   IT.NRPGCONFTELA, IT.NRBUTTON
              FROM ITMENUCONFTE IT
              JOIN CAIXA CX
                ON IT.CDFILIAL   = CX.CDFILIAL
               AND IT.NRCONFTELA = CX.NRCONFTELA
               AND CX.CDFILIAL = :CDFILIAL
               AND CX.CDCAIXA  = :CDCAIXA
               AND IDTPBUTTON  = 'I'
               AND IT.NRPGCONFTAUX = :NRPGCONFTELA
				       AND IT.NRBUTTONAUX  = :NRBUTTON) GR
        ON IT.NRCONFTELA = GR.NRCONFTELA
       AND IT.CDFILIAL = GR.CDFILIAL
       AND IT.NRPGCONFTAUX = GR.NRPGCONFTELA
       AND IT.NRBUTTONAUX  = GR.NRBUTTON
       AND IT.IDTPBUTTON = '1'
       AND IT.NRPGCONFTAUX = :NRPGCONFTAUX
       AND IT.NRBUTTONAUX  = :NRBUTTONAUX
       AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO
                                     FROM PRODBLOQVND
                                    WHERE CDFILIAL = :CDFILIAL
                                      AND CDLOJA = :CDLOJA)
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON
    ";

  const ORACLE_GET_SUBGROUP_PRODUCTS_CONFTELACX = "	
    SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO, PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, NVL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG, PR.CDBARPRODUTO, PR.IDIMPPRODUTO
      FROM ITMENUCONFTE IT	
      JOIN PRODUTO PR	
        ON IT.CDIDENTBUTON = PR.CDPRODUTO	
      JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, 	
                   IT.NRPGCONFTELA, IT.NRBUTTON	
              FROM ITMENUCONFTE IT	
              JOIN CONFTELACAIXA CX	
                ON IT.CDFILIAL   = CX.CDFILIAL	
               AND IT.NRCONFTELA = CX.NRCONFTELA	
               AND CX.CDFILICAIXA = :CDFILIAL	
               AND CX.CDCAIXA  = :CDCAIXA	
               AND IDTPBUTTON  = 'I'	
               AND IT.NRPGCONFTAUX = :NRPGCONFTELA	
               AND IT.NRBUTTONAUX  = :NRBUTTON	
               AND CX.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)) GR	
        ON IT.NRCONFTELA = GR.NRCONFTELA	
       AND IT.CDFILIAL = GR.CDFILIAL	
       AND IT.NRPGCONFTAUX = GR.NRPGCONFTELA	
       AND IT.NRBUTTONAUX  = GR.NRBUTTON	
       AND IT.IDTPBUTTON = '1'	
       AND IT.NRPGCONFTAUX = :NRPGCONFTAUX	
       AND IT.NRBUTTONAUX  = :NRBUTTONAUX	
       AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO	
                                     FROM PRODBLOQVND	
                                    WHERE CDFILIAL = :CDFILIAL	
                                      AND CDLOJA = :CDLOJA)	
  ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON	
    ";

  const SQL_GET_SUBGROUP_PRODUCTS = "
    SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO,
           PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, ISNULL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG,
           PR.CDBARPRODUTO, PR.IDIMPPRODUTO
      FROM ITMENUCONFTE IT
      JOIN PRODUTO PR
        ON IT.CDIDENTBUTON = PR.CDPRODUTO
      JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, 
                    IT.NRPGCONFTELA, IT.NRBUTTON
              FROM ITMENUCONFTE IT
              JOIN CAIXA CX
                ON IT.CDFILIAL = CX.CDFILIAL
                AND IT.NRCONFTELA = CX.NRCONFTELA
                AND CX.CDFILIAL = :CDFILIAL
                AND CX.CDCAIXA  = :CDCAIXA
                AND IDTPBUTTON  = 'I'
                AND IT.NRPGCONFTAUX = :NRPGCONFTELA
                AND IT.NRBUTTONAUX  = :NRBUTTON) GR
        ON IT.NRCONFTELA = GR.NRCONFTELA
        AND IT.CDFILIAL   = GR.CDFILIAL
        AND IT.NRPGCONFTAUX = GR.NRPGCONFTELA
        AND IT.NRBUTTONAUX  = GR.NRBUTTON
        AND IT.IDTPBUTTON = '1'
        AND IT.NRPGCONFTAUX = :NRPGCONFTAUX
        AND IT.NRBUTTONAUX  = :NRBUTTONAUX
        AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO
                                      FROM PRODBLOQVND
                                    WHERE CDFILIAL = :CDFILIAL
                                      AND CDLOJA = :CDLOJA)
    ";

  // const SQL_GET_SUBGROUP_PRODUCTS_CONFTELACX = "	
  // SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO, PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, ISNULL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG, PR.CDBARPRODUTO, PR.IDIMPPRODUTO
  //   FROM ITMENUCONFTE IT	
  //   JOIN PRODUTO PR	
  //     ON IT.CDIDENTBUTON = PR.CDPRODUTO	
  //   JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, 	
  //                 IT.NRPGCONFTELA, IT.NRBUTTON	
  //           FROM ITMENUCONFTE IT	
  //           JOIN CONFTELACAIXA CX	
  //             ON IT.CDFILIAL = CX.CDFILIAL	
  //             AND IT.NRCONFTELA = CX.NRCONFTELA	
  //             AND CX.CDFILICAIXA = :CDFILIAL	
  //             AND CX.CDCAIXA  = :CDCAIXA	
  //             AND IDTPBUTTON  = 'I'	
  //             AND IT.NRPGCONFTAUX = :NRPGCONFTELA	
  //             AND IT.NRBUTTONAUX  = :NRBUTTON	
  //             AND CX.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)) GR	
  //     ON IT.NRCONFTELA = GR.NRCONFTELA	
  //     AND IT.CDFILIAL   = GR.CDFILIAL	
  //     AND IT.NRPGCONFTAUX = GR.NRPGCONFTELA	
  //     AND IT.NRBUTTONAUX  = GR.NRBUTTON	
  //     AND IT.IDTPBUTTON = '1'	
  //     AND IT.NRPGCONFTAUX = :NRPGCONFTAUX	
  //     AND IT.NRBUTTONAUX  = :NRBUTTONAUX	

  //     AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO	
  //                                   FROM PRODBLOQVND	
  //                                 WHERE CDFILIAL = :CDFILIAL	
  //                                   AND CDLOJA = :CDLOJA)	
  // ";

  const SQL_GET_SUBGROUP_PRODUCTS_CONFTELACX = "	
  SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON AS NMPRODUTO, PR.DSPRODVENDA, PR.IDTIPOCOMPPROD, ISNULL(IT.DSENDEIMG, PR.DSENDEIMG) DSENDEIMG,
  PR.CDBARPRODUTO, PR.IDIMPPRODUTO
 FROM ITMENUCONFTE   IT
  INNER JOIN PRODUTO PR 
  ON IT.CDIDENTBUTON = PR.CDPRODUTO AND PR.IDPRODATIVPR = 'S' 
   WHERE IT.CDFILIAL = :CDFILIAL
   
   AND IT.IDTPBUTTON = '1' AND IT.IDTPBUTONAUX = 'I'
    AND IT.NRBUTTONAUX = :NRBUTTON
    AND IT.NRPGCONFTAUX = :NRPGCONFTELA
     AND IT.IDTPBUTONAUX2 = '2' 
    AND IT.NRBUTTONAUX2 = :NRBUTTONAUX
    AND IT.NRPGCONFTAUX2 = :NRPGCONFTAUX
    AND IT.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)
    AND IT.CDIDENTBUTON NOT IN (SELECT CDPRODUTO  
                                       FROM PRODBLOQVND 
                                     WHERE CDFILIAL = :CDFILIAL 
                                       AND CDLOJA = :CDLOJA) 
    ";

  const ORACLE_GET_CHECK_PRODUCT_OBSERVATIONS = "
    SELECT *
      FROM LOJAGRUPOOCORR LGO
      JOIN PRODOCORRE PO
        ON LGO.CDGRPOCOR = PO.CDGRPOCOR
      JOIN OCORRENCIA O
        ON O.CDGRPOCOR = LGO.CDGRPOCOR
       AND O.CDOCORR = PO.CDOCORR
     WHERE LGO.CDLOJA = :CDLOJA
       AND LGO.CDFILIAL = :CDFILIAL
       AND PO.CDPRODUTO = :CDPRODUTO
       AND NVL(O.IDEXIOBSAPPCONS,'S') = 'S'
    ";

  const SQL_GET_CHECK_PRODUCT_OBSERVATIONS = "
    SELECT *
      FROM LOJAGRUPOOCORR LGO
      JOIN PRODOCORRE PO
        ON LGO.CDGRPOCOR = PO.CDGRPOCOR
      JOIN OCORRENCIA O
        ON O.CDGRPOCOR = LGO.CDGRPOCOR
       AND O.CDOCORR = PO.CDOCORR
     WHERE LGO.CDLOJA = :CDLOJA
       AND LGO.CDFILIAL = :CDFILIAL
       AND PO.CDPRODUTO = :CDPRODUTO
       AND ISNULL(O.IDEXIOBSAPPCONS,'S') = 'S'
    ";

  const STORE_PRICING_TABLE = "
		SELECT CDTABEPREC
      FROM LOJA
     WHERE CDFILIAL = :CDFILIAL
       AND CDLOJA = :CDLOJA
    ";

  const PARAVEND_PRICING_TABLE = "
        SELECT CDTABEPREC 
        FROM PARAVEND 
        WHERE CDFILIAL = :CDFILIAL
    ";

  const GET_PRICING_TABLE = "
        SELECT TV.CDTABEPREC, TP.NMTABEPREC, CONVERT(VARCHAR, TV.DTINIVGPREC, 21) AS DTINIVGPREC,
            CONVERT(VARCHAR, TV.DTFINVGPREC, 21) AS DTFINVGPREC
          FROM TABEVENDGER TV
        JOIN TABEPRECGER TP
          ON TP.CDTABEPREC = TV.CDTABEPREC
           AND CONVERT(VARCHAR, GETDATE(), 103) BETWEEN TV.DTINIVGPREC AND TV.DTFINVGPREC
        ORDER BY TV.CDTABEPREC";
  // , TO_CHAR(TV.DTINIVGPREC, 'DD/MM/YYYY')

  const ORACLE_GET_PRICING_TABLE = "
        SELECT TV.CDTABEPREC, TP.NMTABEPREC, TO_CHAR(TV.DTINIVGPREC, 'DD/MM/YYYY HH24:MI:SS') AS DTINIVGPREC,
               TO_CHAR(TV.DTFINVGPREC, 'DD/MM/YYYY HH24:MI:SS') AS DTFINVGPREC
          FROM TABEVENDGER TV
          JOIN TABEPRECGER TP
            ON TP.CDTABEPREC = TV.CDTABEPREC
           AND TRUNC(SYSDATE) BETWEEN TV.DTINIVGPREC AND TV.DTFINVGPREC
      ORDER BY TV.CDTABEPREC";
  
  const ORACLE_HOLIDAY = "
		SELECT DTFERIFILI
      FROM FERIFILI
     WHERE CDFILIAL = :CDFILIAL
       AND DTFERIFILI = TO_DATE(:DTFERIFILI, 'DD/MM/YYYY HH24:MI:SS')
    ";

  const SQL_HOLIDAY = "
		SELECT DTFERIFILI
      FROM FERIFILI
     WHERE CDFILIAL = :CDFILIAL
       AND DTFERIFILI = :DTFERIFILI
    ";

  const ORACLE_GET_PRICES = "
    SELECT PR.CDPRODUTO,
      CASE NVL(PRDIA.IDDESCACREPR, 'N')
      WHEN 'D' THEN
      CASE PRDIA.IDPERVALORPR
                  WHEN 'V' THEN PR.VRPRECITEM - PRDIA.VRPRECODIA
                  WHEN 'P' THEN PR.VRPRECITEM - (PR.VRPRECITEM * PRDIA.VRPRECODIA / 100)
              END
                  WHEN 'A' THEN
              CASE PRDIA.IDPERVALORPR
                  WHEN 'V' THEN PR.VRPRECITEM + PRDIA.VRPRECODIA
                  WHEN 'P' THEN PR.VRPRECITEM + (PR.VRPRECITEM * PRDIA.VRPRECODIA / 100)
              END
                  ELSE PR.VRPRECITEM
        END AS VRPRECITEM, PRDIA.IDPERVALORPR, PRDIA.IDDESCACREPR, PRDIA.VRPRECODIA, PRDIA.NRDIASEMANPR
       FROM ITEMPRECO PR
  LEFT JOIN (SELECT CDFILIAL, CDTABEPREC, CDPRODUTO, CDTIPOCONSPD,
                    VRPRECODIA, IDPERVALORPR, IDDESCACREPR, NRDIASEMANPR
               FROM ITEMPRECODIA
              WHERE CDFILIAL = :CDFILIAL
                AND (NRDIASEMANPR = :DAYOFWEEK OR NRDIASEMANPR = 'T')
                AND (:TIMEOFDAY BETWEEN HRINIPRECDIA AND HRFINPRECDIA OR NVL(:TIMEOFDAY,'T') = 'T')
                AND ((CDTIPOCONSPD = NVL(:CDTIPOCONSPD,'T')) OR CDTIPOCONSPD = 'T')
           ORDER BY CDPRODUTO DESC, CDTIPOCONSPD DESC) PRDIA
         ON PR.CDFILIAL = PRDIA.CDFILIAL
        AND PR.CDTABEPREC = PRDIA.CDTABEPREC
        AND PR.CDPRODUTO  = PRDIA.CDPRODUTO
      LEFT JOIN PRODFILI PF
       ON PF.CDFILIAL = PR.CDFILIAL 
       AND PF.CDPRODUTO = PR.CDPRODUTO
      WHERE PR.CDFILIAL = :CDFILIAL
        AND PR.CDTABEPREC = :CDTABEPREC
        AND PR.DTINIVGPREC = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY HH24:MI:SS')
        AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
    ";

  const ORACLE_GET_PRICES_GERAL = "
    SELECT PR.CDPRODUTO,
      CASE NVL(PRDIA.IDDESCACREPR, 'N')
      WHEN 'D' THEN
      CASE PRDIA.IDPERVALORPR
                  WHEN 'V' THEN PR.VRPRECITEM - PRDIA.VRPRECODIA
                  WHEN 'P' THEN PR.VRPRECITEM - (PR.VRPRECITEM * PRDIA.VRPRECODIA / 100)
              END
                  WHEN 'A' THEN
              CASE PRDIA.IDPERVALORPR
                  WHEN 'V' THEN PR.VRPRECITEM + PRDIA.VRPRECODIA
                  WHEN 'P' THEN PR.VRPRECITEM + (PR.VRPRECITEM * PRDIA.VRPRECODIA / 100)
              END
                  ELSE PR.VRPRECITEM
        END AS VRPRECITEM, PRDIA.IDPERVALORPR, PRDIA.IDDESCACREPR, PRDIA.VRPRECODIA, PRDIA.NRDIASEMANPR
       FROM ITEMPRECOGER PR
  LEFT JOIN (SELECT CDFILIAL, CDTABEPREC, CDPRODUTO, CDTIPOCONSPD,
                    VRPRECODIA, IDPERVALORPR, IDDESCACREPR, NRDIASEMANPR
               FROM ITEMPRECODIA
              WHERE CDFILIAL = :CDFILIAL
                AND (NRDIASEMANPR = :DAYOFWEEK OR NRDIASEMANPR = 'T')
                AND (:TIMEOFDAY BETWEEN HRINIPRECDIA AND HRFINPRECDIA OR NVL(:TIMEOFDAY,'T') = 'T')
                AND ((CDTIPOCONSPD = NVL(:CDTIPOCONSPD,'T')) OR CDTIPOCONSPD = 'T')
           ORDER BY CDPRODUTO DESC, CDTIPOCONSPD DESC) PRDIA
         ON 
         PR.CDTABEPREC = PRDIA.CDTABEPREC
        AND PR.CDPRODUTO  = PRDIA.CDPRODUTO
      LEFT JOIN PRODFILI PF
       ON PF.CDPRODUTO = PR.CDPRODUTO
      WHERE 
       PR.CDTABEPREC = :CDTABEPREC
        AND PR.DTINIVGPREC = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY HH24:MI:SS')
        AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
    ";

  const ORACLE_GET_PRICES_COMBOS = "
    SELECT PR.CDPRODUTO,
      PR.VRPRECITEM, PRDIA.IDPERVALORPR, PRDIA.IDDESCACREPR, PRDIA.VRPRECODIA, PRDIA.NRDIASEMANPR
       FROM ITEMPRECO PR
  LEFT JOIN (SELECT CDFILIAL, CDTABEPREC, CDPRODUTO, CDTIPOCONSPD,
                    VRPRECODIA, IDPERVALORPR, IDDESCACREPR, NRDIASEMANPR
               FROM ITEMPRECODIA
              WHERE CDFILIAL = :CDFILIAL
                AND (NRDIASEMANPR = :DAYOFWEEK OR NRDIASEMANPR = 'T')
                AND (:TIMEOFDAY BETWEEN HRINIPRECDIA AND HRFINPRECDIA OR NVL(:TIMEOFDAY,'T') = 'T')
                AND ((CDTIPOCONSPD = NVL(:CDTIPOCONSPD,'T')) OR CDTIPOCONSPD = 'T')
           ORDER BY CDPRODUTO DESC, CDTIPOCONSPD DESC) PRDIA
         ON PR.CDFILIAL = PRDIA.CDFILIAL
        AND PR.CDTABEPREC = PRDIA.CDTABEPREC
        AND PR.CDPRODUTO  = PRDIA.CDPRODUTO
      LEFT JOIN PRODFILI PF
       ON PF.CDFILIAL = PR.CDFILIAL 
       AND PF.CDPRODUTO = PR.CDPRODUTO
      WHERE PR.CDFILIAL = :CDFILIAL
        AND PR.CDTABEPREC = :CDTABEPREC
        AND PR.DTINIVGPREC = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY HH24:MI:SS')
        AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
    ";

  const ORACLE_GET_PRICES_COMBOS_GERAL = "
    SELECT PR.CDPRODUTO,
      PR.VRPRECITEM, PRDIA.IDPERVALORPR, PRDIA.IDDESCACREPR, PRDIA.VRPRECODIA, PRDIA.NRDIASEMANPR
       FROM ITEMPRECOGERAL PR
  LEFT JOIN (SELECT CDFILIAL, CDTABEPREC, CDPRODUTO, CDTIPOCONSPD,
                    VRPRECODIA, IDPERVALORPR, IDDESCACREPR, NRDIASEMANPR
               FROM ITEMPRECODIA
              WHERE CDFILIAL = :CDFILIAL
                AND (NRDIASEMANPR = :DAYOFWEEK OR NRDIASEMANPR = 'T')
                AND (:TIMEOFDAY BETWEEN HRINIPRECDIA AND HRFINPRECDIA OR NVL(:TIMEOFDAY,'T') = 'T')
                AND ((CDTIPOCONSPD = NVL(:CDTIPOCONSPD,'T')) OR CDTIPOCONSPD = 'T')
           ORDER BY CDPRODUTO DESC, CDTIPOCONSPD DESC) PRDIA
         ON PR.CDTABEPREC = PRDIA.CDTABEPREC
        AND PR.CDPRODUTO  = PRDIA.CDPRODUTO
      LEFT JOIN PRODFILI PF
       ON PF.CDPRODUTO = PR.CDPRODUTO
      WHERE PR.CDTABEPREC = :CDTABEPREC
        AND PR.DTINIVGPREC = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY HH24:MI:SS')
        AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
    ";

  const SQL_GET_PRICES = "
		SELECT PR.CDPRODUTO,
      CASE ISNULL(PRDIA.IDDESCACREPR, 'N')
           WHEN 'D' THEN
             CASE PRDIA.IDPERVALORPR
                 WHEN 'V' THEN PR.VRPRECITEM - PRDIA.VRPRECODIA
                 WHEN 'P' THEN PR.VRPRECITEM - (PR.VRPRECITEM * PRDIA.VRPRECODIA / 100)
             END
                 WHEN 'A' THEN
             CASE PRDIA.IDPERVALORPR
                 WHEN 'V' THEN PR.VRPRECITEM + PRDIA.VRPRECODIA
                 WHEN 'P' THEN PR.VRPRECITEM + (PR.VRPRECITEM * PRDIA.VRPRECODIA / 100)
             END
                 ELSE PR.VRPRECITEM
       END AS VRPRECITEM, PRDIA.IDPERVALORPR, PRDIA.IDDESCACREPR, PRDIA.VRPRECODIA, PRDIA.NRDIASEMANPR
      FROM ITEMPRECO PR
 LEFT JOIN (SELECT CDFILIAL, CDTABEPREC, DTINIVGPREC, CDPRODUTO, CDTIPOCONSPD,
     				       VRPRECODIA, IDPERVALORPR, IDDESCACREPR, NRDIASEMANPR
              FROM ITEMPRECODIA
             WHERE CDFILIAL = :CDFILIAL
               AND (NRDIASEMANPR = :DAYOFWEEK OR NRDIASEMANPR = 'T')
               AND (:TIMEOFDAY BETWEEN HRINIPRECDIA AND HRFINPRECDIA OR ISNULL(:TIMEOFDAY,'T') = 'T')
               AND ((CDTIPOCONSPD = ISNULL(:CDTIPOCONSPD,'T')) OR CDTIPOCONSPD = 'T')) PRDIA
        ON PR.CDFILIAL   = PRDIA.CDFILIAL
       AND PR.CDTABEPREC = PRDIA.CDTABEPREC
       AND PR.CDPRODUTO  = PRDIA.CDPRODUTO
      LEFT JOIN PRODFILI PF
       ON PF.CDFILIAL = PR.CDFILIAL 
       AND PF.CDPRODUTO = PR.CDPRODUTO
     WHERE PR.CDFILIAL    = :CDFILIAL
       AND PR.CDTABEPREC  = :CDTABEPREC
       AND PR.DTINIVGPREC = CONVERT(DATE, :DTINIVGPREC, 120)
       AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
     ORDER BY PR.CDPRODUTO DESC, PRDIA.CDTIPOCONSPD, PRDIA.DTINIVGPREC DESC
    ";

  const SQL_GET_PRICES_GERAL = "
		SELECT PR.CDPRODUTO,
      CASE ISNULL(PRDIA.IDDESCACREPR, 'N')
           WHEN 'D' THEN
             CASE PRDIA.IDPERVALORPR
                 WHEN 'V' THEN PR.VRPRECITEM - PRDIA.VRPRECODIA
                 WHEN 'P' THEN PR.VRPRECITEM - (PR.VRPRECITEM * PRDIA.VRPRECODIA / 100)
             END
                 WHEN 'A' THEN
             CASE PRDIA.IDPERVALORPR
                 WHEN 'V' THEN PR.VRPRECITEM + PRDIA.VRPRECODIA
                 WHEN 'P' THEN PR.VRPRECITEM + (PR.VRPRECITEM * PRDIA.VRPRECODIA / 100)
             END
                 ELSE PR.VRPRECITEM
       END AS VRPRECITEM, PRDIA.IDPERVALORPR, PRDIA.IDDESCACREPR, PRDIA.VRPRECODIA, PRDIA.NRDIASEMANPR
      FROM ITEMPRECOGER PR
 LEFT JOIN (SELECT CDFILIAL, CDTABEPREC, DTINIVGPREC, CDPRODUTO, CDTIPOCONSPD,
     				       VRPRECODIA, IDPERVALORPR, IDDESCACREPR, NRDIASEMANPR
              FROM ITEMPRECODIA
             WHERE CDFILIAL = :CDFILIAL
               AND (NRDIASEMANPR = :DAYOFWEEK OR NRDIASEMANPR = 'T')
               AND (:TIMEOFDAY BETWEEN HRINIPRECDIA AND HRFINPRECDIA OR ISNULL(:TIMEOFDAY,'T') = 'T')
               AND ((CDTIPOCONSPD = ISNULL(:CDTIPOCONSPD,'T')) OR CDTIPOCONSPD = 'T')) PRDIA
        ON PR.CDTABEPREC = PRDIA.CDTABEPREC
       AND PR.CDPRODUTO  = PRDIA.CDPRODUTO
      LEFT JOIN PRODFILI PF
       ON  PF.CDPRODUTO = PR.CDPRODUTO
     WHERE PR.CDTABEPREC  = :CDTABEPREC
       AND PR.DTINIVGPREC = CONVERT(DATE, :DTINIVGPREC, 120)
       AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
     ORDER BY PR.CDPRODUTO DESC, PRDIA.CDTIPOCONSPD, PRDIA.DTINIVGPREC DESC
    ";

  const SQL_GET_PRICES_COMBOS = "
		SELECT PR.CDPRODUTO,
      PR.VRPRECITEM, PRDIA.IDPERVALORPR, PRDIA.IDDESCACREPR, PRDIA.VRPRECODIA, PRDIA.NRDIASEMANPR
      FROM ITEMPRECO PR
 LEFT JOIN (SELECT CDFILIAL, CDTABEPREC, DTINIVGPREC, CDPRODUTO, CDTIPOCONSPD,
     				       VRPRECODIA, IDPERVALORPR, IDDESCACREPR, NRDIASEMANPR
              FROM ITEMPRECODIA
             WHERE CDFILIAL = :CDFILIAL
               AND (NRDIASEMANPR = :DAYOFWEEK OR NRDIASEMANPR = 'T')
               AND (:TIMEOFDAY BETWEEN HRINIPRECDIA AND HRFINPRECDIA OR ISNULL(:TIMEOFDAY,'T') = 'T')
               AND ((CDTIPOCONSPD = ISNULL(:CDTIPOCONSPD,'T')) OR CDTIPOCONSPD = 'T')) PRDIA
        ON PR.CDFILIAL   = PRDIA.CDFILIAL
       AND PR.CDTABEPREC = PRDIA.CDTABEPREC
       AND PR.CDPRODUTO  = PRDIA.CDPRODUTO
      LEFT JOIN PRODFILI PF
       ON PF.CDFILIAL = PR.CDFILIAL 
       AND PF.CDPRODUTO = PR.CDPRODUTO
     WHERE PR.CDFILIAL    = :CDFILIAL
       AND PR.CDTABEPREC  = :CDTABEPREC
       AND PR.DTINIVGPREC = CONVERT(DATE, :DTINIVGPREC, 120)
       AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
     ORDER BY PR.CDPRODUTO DESC, PRDIA.CDTIPOCONSPD, PRDIA.DTINIVGPREC DESC
    ";

  const SQL_GET_PRICES_COMBOS_GERAL = "
		SELECT PR.CDPRODUTO,
      PR.VRPRECITEM, PRDIA.IDPERVALORPR, PRDIA.IDDESCACREPR, PRDIA.VRPRECODIA, PRDIA.NRDIASEMANPR
      FROM ITEMPRECOGER PR
 LEFT JOIN (SELECT CDFILIAL, CDTABEPREC, DTINIVGPREC, CDPRODUTO, CDTIPOCONSPD,
     				       VRPRECODIA, IDPERVALORPR, IDDESCACREPR, NRDIASEMANPR
              FROM ITEMPRECODIA
             WHERE CDFILIAL = :CDFILIAL
               AND (NRDIASEMANPR = :DAYOFWEEK OR NRDIASEMANPR = 'T')
               AND (:TIMEOFDAY BETWEEN HRINIPRECDIA AND HRFINPRECDIA OR ISNULL(:TIMEOFDAY,'T') = 'T')
               AND ((CDTIPOCONSPD = ISNULL(:CDTIPOCONSPD,'T')) OR CDTIPOCONSPD = 'T')) PRDIA
        ON PR.CDTABEPREC = PRDIA.CDTABEPREC
       AND PR.CDPRODUTO  = PRDIA.CDPRODUTO
      LEFT JOIN PRODFILI PF
       ON PF.CDPRODUTO = PR.CDPRODUTO
     WHERE PR.CDTABEPREC  = :CDTABEPREC
       AND PR.DTINIVGPREC = CONVERT(DATE, :DTINIVGPREC, 120)
       AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
     ORDER BY PR.CDPRODUTO DESC, PRDIA.CDTIPOCONSPD, PRDIA.DTINIVGPREC DESC
    ";

  const ORACLE_GET_PRODUCT_OBSERVATIONS = "
    SELECT O.CDOCORR, NVL(O.DSAPELIDOOBS,O.DSOCORR) DSOCORR, O.CDPRODUTO
      FROM PRODOCORRE PO
      JOIN OCORRENCIA O 
        ON PO.CDOCORR = O.CDOCORR 
       AND PO.CDGRPOCOR = O.CDGRPOCOR
      LEFT JOIN PRODFILI PF
        ON PF.CDPRODUTO = O.CDPRODUTO
       AND PF.CDFILIAL = :CDFILIAL
     WHERE PO.CDPRODUTO = :CDPRODUTO
       AND O.CDGRPOCOR = :CDGRPOCOR	
       AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
       AND NVL(O.IDEXIOBSAPPCONS,'S') = 'S'
       AND NVL(O.CDPRODUTO,'NE') NOT IN (SELECT CDPRODUTO
                                           FROM PRODBLOQVND
                                          WHERE CDFILIAL = :CDFILIAL
                                            AND CDLOJA = :CDLOJA)   
        
    ";
  // ORDER BY NLSSORT(O.CDOCORR, 'NLS_SORT=BINARY')

  const SQL_GET_PRODUCT_OBSERVATIONS = "
    SELECT O.CDOCORR, ISNULL(O.DSAPELIDOOBS,O.DSOCORR) DSOCORR, O.CDPRODUTO, O.IDCONTROLAOBS
      FROM PRODOCORRE PO
      JOIN OCORRENCIA O 
        ON PO.CDOCORR = O.CDOCORR 
       AND PO.CDGRPOCOR = O.CDGRPOCOR
      LEFT JOIN PRODFILI PF
        ON PF.CDPRODUTO = O.CDPRODUTO
       AND PF.CDFILIAL = :CDFILIAL
     WHERE PO.CDPRODUTO = :CDPRODUTO
       AND O.CDGRPOCOR = :CDGRPOCOR	
       AND (PF.IDPRODATIV = 'A' OR PF.IDPRODATIV IS NULL)
       AND ISNULL(O.IDEXIOBSAPPCONS,'S') = 'S'
       AND ISNULL(O.CDPRODUTO,'NE') NOT IN (SELECT CDPRODUTO
                                              FROM PRODBLOQVND
                                             WHERE CDFILIAL = :CDFILIAL
                                               AND CDLOJA = :CDLOJA)
      ";

  const ORACLE_GET_STORE_OBSERVATIONS_GROUPS = "
    SELECT LGO.CDGRPOCOR, G.DSGRPOCOR, NVL(LGO.NRMINOCORR,G.NRMINOCORR) NRMINOCORR, 
           NVL(LGO.NRMAXOCORR,G.NRMAXOCORR) NRMAXOCORR
      FROM LOJAGRUPOOCORR LGO
      JOIN GRUPOCOR G 
        ON LGO.CDGRPOCOR = G.CDGRPOCOR 
     WHERE LGO.CDFILIAL = :CDFILIAL
       AND LGO.CDLOJA = :CDLOJA	  
    ";

    const ORACLE_GET_STORE_OBSERVATIONS_GROUPS_EX = "
    SELECT G.CDGRPOCOR, G.DSGRPOCOR, ISNULL(G.NRMINOCORR,G.NRMINOCORR) NRMINOCORR, 
           ISNULL(G.NRMAXOCORR,G.NRMAXOCORR) NRMAXOCORR
      FROM GRUPOCOR G
      JOIN  LOJA L
        ON G.CDGRPOCOR = L.CDGRPOCORPED 
     WHERE L.CDFILIAL = :CDFILIAL
       AND L.CDLOJA = :CDLOJA  
    ";

  const SQL_GET_STORE_OBSERVATIONS_GROUPS = "
    SELECT LGO.CDGRPOCOR, G.DSGRPOCOR, ISNULL(LGO.NRMINOCORR,G.NRMINOCORR) NRMINOCORR, 
           ISNULL(LGO.NRMAXOCORR,G.NRMAXOCORR) NRMAXOCORR
      FROM LOJAGRUPOOCORR LGO
      JOIN GRUPOCOR G 
        ON LGO.CDGRPOCOR = G.CDGRPOCOR 
     WHERE LGO.CDFILIAL = :CDFILIAL
       AND LGO.CDLOJA = :CDLOJA	  
    ";

    const SQL_GET_STORE_OBSERVATIONS_GROUPS_EX = "
    SELECT G.CDGRPOCOR, G.DSGRPOCOR, ISNULL(G.NRMINOCORR,G.NRMINOCORR) NRMINOCORR, 
           ISNULL(G.NRMAXOCORR,G.NRMAXOCORR) NRMAXOCORR
      FROM GRUPOCOR G
      JOIN  LOJA L
        ON G.CDGRPOCOR = L.CDGRPOCORPED 
     WHERE L.CDFILIAL = :CDFILIAL
       AND L.CDLOJA = :CDLOJA
    ";

  const SQL_GET_COMBO_GROUPS_SUBSIDIARY = "
    SELECT G.CDGRUPROMOC, P.NMGRUPROMOC, G.QTPRGRUPPROMFIL AS QTPRGRUPPROMOC, IDAPLICADESCFIL 
      FROM GRUPROMOCPRFIL G 
      JOIN GRUPROMOC P
        ON G.CDGRUPROMOC = P.CDGRUPROMOC
      WHERE G.CDPRODPROMOCAO = :CDIDENTBUTON
        AND G.CDFILIAL = :CDFILIAL
  ORDER BY G.NRORDPROMOGRUPFIL
    ";

  const SQL_GET_COMBO_GROUPS_PRODUCT = "
    SELECT G.CDGRUPROMOC, P.NMGRUPROMOC, G.QTPRGRUPPROMOC, IDAPLICADESC 
      FROM GRUPROMOCPROD G 
      JOIN GRUPROMOC P
        ON G.CDGRUPROMOC = P.CDGRUPROMOC
     WHERE G.CDPRODPROMOCAO = :CDIDENTBUTON
  ORDER BY G.NRORDPROMOGRUP
    ";

  const ORACLE_GET_COMBO_PRODUCTS_SUBSIDIARY = "
    SELECT DP.CDPRODPROMOCAO, PP.CDGRUPROMOC, PP.CDPRODUTO, P.CDARVPROD, NVL(PP.DSAPELIDOMOB,P.NMPRODUTO) NMPRODUTO, P.IDIMPPRODUTO,
           NVL(DP.IDPERVALDESFIL, 'P') AS IDPERVALORDES, '0' AS IDCTRLMODIFY,
           NVL(DP.VRDESPRPROMOFIL, 0) AS VRDESPRODPROMOC,
           NVL(DP.IDAPLICADESCPRFI, 'T') AS IDAPLICADESCPR,
           CASE WHEN PB.CDPRODUTO IS NULL THEN 'N' ELSE 'S' END AS IDPRODBLOQ,
           P.DSPRODVENDA, NVL(PP.DSENDEIMGPROMO, P.DSENDEIMG) DSENDEIMG, P.IDTIPOCOMPPROD,
           P.CDBARPRODUTO
      FROM PRODUTO P 
      JOIN PRODGRUPROMOC PP
        ON P.CDPRODUTO = PP.CDPRODUTO
       AND PP.CDGRUPROMOC = :CDGRUPROMOC
 LEFT JOIN DESGRUPROMPRFIL DP
        ON DP.CDPRODPROMOCAO = :CDIDENTBUTON
       AND DP.CDGRUPROMOC = PP.CDGRUPROMOC
       AND DP.CDPRODUTO = PP.CDPRODUTO
       AND DP.CDFILIAL = :CDFILIAL
 LEFT JOIN PRODBLOQVND PB
        ON PB.CDFILIAL = :CDFILIAL
       AND PB.CDLOJA = :CDLOJA
       AND PP.CDPRODUTO = PB.CDPRODUTO
     WHERE PP.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                  FROM PRODBLOQVND
                                 WHERE CDFILIAL = :CDFILIAL
                                   AND CDLOJA = :CDLOJA)   
  ORDER BY PP.NRORDPROMOPR, PP.CDPRODUTO
    ";

  const SQL_GET_COMBO_PRODUCTS_SUBSIDIARY = "
    SELECT DP.CDPRODPROMOCAO, PP.CDGRUPROMOC, PP.CDPRODUTO, P.CDARVPROD,  ISNULL(PP.DSAPELIDOMOB,P.NMPRODUTO) NMPRODUTO, P.IDIMPPRODUTO,
           ISNULL(DP.IDPERVALDESFIL, 'P') AS IDPERVALORDES, '0' AS IDCTRLMODIFY,
           ISNULL(DP.VRDESPRPROMOFIL, 0) AS VRDESPRODPROMOC,
           ISNULL(DP.IDAPLICADESCPRFI, 'T') AS IDAPLICADESCPR,
           CASE WHEN PB.CDPRODUTO IS NULL THEN 'N' ELSE 'S' END AS IDPRODBLOQ,
           P.DSPRODVENDA, ISNULL(PP.DSENDEIMGPROMO, P.DSENDEIMG) DSENDEIMG, P.IDTIPOCOMPPROD,
           P.CDBARPRODUTO
      FROM PRODUTO P 
      JOIN PRODGRUPROMOC PP
        ON P.CDPRODUTO = PP.CDPRODUTO
       AND PP.CDGRUPROMOC = :CDGRUPROMOC
 LEFT JOIN DESGRUPROMPRFIL DP
        ON DP.CDPRODPROMOCAO = :CDIDENTBUTON
       AND DP.CDGRUPROMOC = PP.CDGRUPROMOC
       AND DP.CDPRODUTO = PP.CDPRODUTO
       AND DP.CDFILIAL = :CDFILIAL
 LEFT JOIN PRODBLOQVND PB
        ON PB.CDFILIAL = :CDFILIAL
       AND PB.CDLOJA = :CDLOJA
       AND PP.CDPRODUTO = PB.CDPRODUTO 
     WHERE PP.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                  FROM PRODBLOQVND
                                 WHERE CDFILIAL = :CDFILIAL
                                   AND CDLOJA = :CDLOJA)            
  ORDER BY PP.NRORDPROMOPR, PP.CDPRODUTO
    ";

  const ORACLE_GET_COMBO_PRODUCTS_PRODUCT = "
    SELECT DP.CDPRODPROMOCAO, PP.CDGRUPROMOC, PP.CDPRODUTO, P.CDARVPROD, NVL(PP.DSAPELIDOMOB,P.NMPRODUTO) NMPRODUTO, P.IDIMPPRODUTO,
           NVL(DP.IDPERVALORDES, 'P') AS IDPERVALORDES,  '0' AS IDCTRLMODIFY,
           NVL(DP.VRDESPRODPROMOC, 0) AS VRDESPRODPROMOC,
           NVL(DP.IDAPLICADESCPR, 'T') AS IDAPLICADESCPR,
           CASE WHEN PB.CDPRODUTO IS NULL THEN 'N' ELSE 'S' END AS IDPRODBLOQ,
           P.DSPRODVENDA, NVL(PP.DSENDEIMGPROMO, P.DSENDEIMG) DSENDEIMG, P.IDTIPOCOMPPROD,
           P.CDBARPRODUTO
      FROM PRODUTO P 
      JOIN PRODGRUPROMOC PP
        ON P.CDPRODUTO = PP.CDPRODUTO
       AND PP.CDGRUPROMOC = :CDGRUPROMOC
      JOIN ITEMPRECO IT
        ON IT.CDPRODUTO = PP.CDPRODUTO
       AND IT.CDFILIAL = :CDFILIAL
       AND IT.CDTABEPREC = :CDTABEPREC
 LEFT JOIN DESGRUPROMOCPR DP
        ON DP.CDPRODPROMOCAO = :CDIDENTBUTON
       AND DP.CDGRUPROMOC = PP.CDGRUPROMOC
       AND DP.CDPRODUTO = PP.CDPRODUTO
 LEFT JOIN PRODBLOQVND PB
        ON PB.CDFILIAL = :CDFILIAL
       AND PB.CDLOJA = :CDLOJA
       AND PP.CDPRODUTO = PB.CDPRODUTO
     WHERE PP.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                  FROM PRODBLOQVND
                                 WHERE CDFILIAL = :CDFILIAL
                                   AND CDLOJA = :CDLOJA) 
  ORDER BY PP.NRORDPROMOPR, PP.CDPRODUTO
    ";

  const SQL_GET_COMBO_PRODUCTS_PRODUCT = "
    SELECT DP.CDPRODPROMOCAO, PP.CDGRUPROMOC, PP.CDPRODUTO, P.CDARVPROD, ISNULL(PP.DSAPELIDOMOB,P.NMPRODUTO) NMPRODUTO, P.IDIMPPRODUTO,
           ISNULL(DP.IDPERVALORDES, 'P') AS IDPERVALORDES,  '0' AS IDCTRLMODIFY,
           ISNULL(DP.VRDESPRODPROMOC, 0) AS VRDESPRODPROMOC,
           ISNULL(DP.IDAPLICADESCPR, 'T') AS IDAPLICADESCPR,
           CASE WHEN PB.CDPRODUTO IS NULL THEN 'N' ELSE 'S' END AS IDPRODBLOQ,
           P.DSPRODVENDA, ISNULL(PP.DSENDEIMGPROMO, P.DSENDEIMG) DSENDEIMG, P.IDTIPOCOMPPROD,
           P.CDBARPRODUTO
      FROM PRODUTO P 
      JOIN PRODGRUPROMOC PP
        ON P.CDPRODUTO = PP.CDPRODUTO
       AND PP.CDGRUPROMOC = :CDGRUPROMOC
      JOIN ITEMPRECO IT
        ON IT.CDPRODUTO = PP.CDPRODUTO
       AND IT.CDFILIAL = :CDFILIAL
       AND IT.CDTABEPREC = :CDTABEPREC
 LEFT JOIN DESGRUPROMOCPR DP
        ON DP.CDPRODPROMOCAO = :CDIDENTBUTON
       AND DP.CDGRUPROMOC = PP.CDGRUPROMOC
       AND DP.CDPRODUTO = PP.CDPRODUTO
 LEFT JOIN PRODBLOQVND PB
        ON PB.CDFILIAL = :CDFILIAL
       AND PB.CDLOJA = :CDLOJA
       AND PP.CDPRODUTO = PB.CDPRODUTO
     WHERE PP.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                  FROM PRODBLOQVND
                                 WHERE CDFILIAL = :CDFILIAL
                                   AND CDLOJA = :CDLOJA)         
  ORDER BY PP.NRORDPROMOPR, PP.CDPRODUTO
    ";

  const ORACLE_STANDARD_SELLER = "		
    SELECT V.CDVENDEDOR,L.CDLOJA, V.NMFANVEN, C.CDCAIXA, V.CDOPERADOR, L.NRMESAPADRAO AS NRMESA,		
            L.IDPOSOBSPED, L.IDLUGARMESA, PV.NRORG
      FROM PARAVEND PV		
      JOIN VENDEDOR V		
        ON PV.CDVENDEDOR = V.CDVENDEDOR		
      JOIN CAIXA C		
        ON V.CDCAIXA = C.CDCAIXA		
       AND PV.CDFILIAL = C.CDFILIAL		
      JOIN LOJA L		
        ON C.CDLOJA = L.CDLOJA		
       AND L.CDFILIAL = C.CDFILIAL 	 		
     WHERE PV.CDFILIAL = :CDFILIAL		
    ";

  const SQL_STANDARD_SELLER = "
    SELECT V.CDVENDEDOR,L.CDLOJA, V.NMFANVEN, C.CDCAIXA, V.CDOPERADOR, L.NRMESAPADRAO AS NRMESA,
           L.IDPOSOBSPED, L.IDLUGARMESA, PV.NRORG
      FROM PARAVEND PV
      JOIN VENDEDOR V
        ON PV.CDVENDEDOR = V.CDVENDEDOR
      JOIN CAIXA C
        ON V.CDCAIXA = C.CDCAIXA
       AND PV.CDFILIAL = C.CDFILIAL
      JOIN LOJA L
        ON C.CDLOJA = L.CDLOJA
       AND L.CDFILIAL = C.CDFILIAL 	 
     WHERE PV.CDFILIAL = :CDFILIAL
    ";

  const ORACLE_INSERT_VENDAREST = "
    INSERT INTO VENDAREST (CDFILIAL, NRVENDAREST, CDLOJA, NRMESA, CDVENDEDOR,
           DTHRABERMESA, DTHRFECHMESA, CDOPERADOR, NRPESMESAVEN,
           CDCLIENTE, CDCONSUMIDOR, IDPEDIDOPAGO)
    VALUES (:CDFILIAL, :NRVENDAREST, :CDLOJA, :NRMESA,
           :CDVENDEDOR, SYSDATE, null, :CDOPERADOR,
           :NRPESMESAVEN, :CDCLIENTE, :CDCONSUMIDOR, :IDPEDIDOPAGO)
    ";

  const SQL_INSERT_VENDAREST = "
    INSERT INTO VENDAREST (
        CDFILIAL, NRVENDAREST, CDLOJA, NRMESA, CDVENDEDOR,
        DTHRABERMESA, DTHRFECHMESA, CDOPERADOR, NRPESMESAVEN,
        CDCLIENTE, CDCONSUMIDOR, IDPEDIDOPAGO
    )
    VALUES (
        :CDFILIAL, :NRVENDAREST, :CDLOJA, :NRMESA,
        :CDVENDEDOR, GETDATE(), null, :CDOPERADOR,
        :NRPESMESAVEN, :CDCLIENTE, :CDCONSUMIDOR, :IDPEDIDOPAGO
    )
    ";

  const ORACLE_INSERT_COMANDAVEN = "
      INSERT INTO COMANDAVEN (
          CDFILIAL, NRVENDAREST, NRCOMANDA, CDLOJA,
          DSCOMANDA, IDSTCOMANDA, SGSEXOCON, TXMOTIVCANCE,
          VRACRCOMANDA, CDPAIS, SGESTADO, CDMUNICIPIO,
          NRCEPCONSCOMAND, CDBAIRRO, DSBAIRRO, DSENDECONSCOMAN,
          DSCOMPLENDCOCOM, DSREFENDCONSCOM, IDORGCMDVENDA,
          IDRETBALLOJA, NRCOMANDAEXT, IDSINCAGENDA, DTHRAGENDADA, IDIMPCUPEXP,
          DSCONSUMIDOR, VRDESCFID, DSOBSCOMANDA, IDFECHAMENTOAPI, NRCPFFIDUDS, VRDESCCASHUDS 
      )
      VALUES (
          :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :CDLOJA,
          :DSCOMANDA, :IDSTCOMANDA, :SGSEXOCON, :TXMOTIVCANCE,
          :VRACRCOMANDA, :CDPAIS, :SGESTADO, :CDMUNICIPIO,
          :NRCEPCONSCOMAND, :CDBAIRRO, :DSBAIRRO, :DSENDECONSCOMAN,
          :DSCOMPLENDCOCOM, :DSREFENDCONSCOM, :IDORGCMDVENDA,
          :IDRETBALLOJA, :NRCOMANDAEXT, :IDSINCAGENDA, TO_DATE(:DTHRAGENDADA,'DD/MM/YYYY HH24:MI:SS'),:IDIMPCUPEXP,
          :DSCONSUMIDOR, :VRDESCFID, :DSOBSCOMANDA, :IDFECHAMENTOAPI, :NRCPFFIDUDS, :VRDESCCASHUDS 
      )
    ";

  const SQL_INSERT_COMANDAVEN = "
    INSERT INTO COMANDAVEN (
        CDFILIAL, NRVENDAREST, NRCOMANDA, CDLOJA,
        DSCOMANDA, IDSTCOMANDA, SGSEXOCON, TXMOTIVCANCE,
        VRACRCOMANDA, CDPAIS, SGESTADO, CDMUNICIPIO,
        NRCEPCONSCOMAND, CDBAIRRO, DSBAIRRO, DSENDECONSCOMAN,
        DSCOMPLENDCOCOM, DSREFENDCONSCOM, IDORGCMDVENDA,
        IDRETBALLOJA, NRCOMANDAEXT, IDSINCAGENDA, DTHRAGENDADA, IDIMPCUPEXP,
        DSCONSUMIDOR, VRDESCFID, DSOBSCOMANDA, IDFECHAMENTOAPI, NRCPFFIDUDS, VRDESCCASHUDS 
    )
    VALUES (
        :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :CDLOJA,
        :DSCOMANDA, :IDSTCOMANDA, :SGSEXOCON, :TXMOTIVCANCE,
        :VRACRCOMANDA, :CDPAIS, :SGESTADO, :CDMUNICIPIO,
        :NRCEPCONSCOMAND, :CDBAIRRO, :DSBAIRRO, :DSENDECONSCOMAN,
        :DSCOMPLENDCOCOM, :DSREFENDCONSCOM, :IDORGCMDVENDA,
        :IDRETBALLOJA, :NRCOMANDAEXT, :IDSINCAGENDA, CONVERT(DATETIME, :DTHRAGENDADA, 103),
        :IDIMPCUPEXP, :DSCONSUMIDOR, :VRDESCFID, :DSOBSCOMANDA, :IDFECHAMENTOAPI, :NRCPFFIDUDS, :VRDESCCASHUDS 
    )
    ";

    const ORACLE_INSERT_COMANDAVEN_EX = "
      INSERT INTO COMANDAVEN (
          CDFILIAL, NRVENDAREST, NRCOMANDA, CDLOJA,
          DSCOMANDA, IDSTCOMANDA, SGSEXOCON, TXMOTIVCANCE,
          VRACRCOMANDA, CDPAIS, SGESTADO, CDMUNICIPIO,
          NRCEPCONSCOMAND, CDBAIRRO, DSBAIRRO, DSENDECONSCOMAN,
          DSCOMPLENDCOCOM, DSREFENDCONSCOM, IDORGCMDVENDA,
          IDRETBALLOJA, NRCOMANDAEXT, IDSINCAGENDA, DTHRAGENDADA, IDIMPCUPEXP,
          DSCONSUMIDOR, DSOBSCOMANDA, IDFECHAMENTOAPI
      )
      VALUES (
          :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :CDLOJA,
          :DSCOMANDA, :IDSTCOMANDA, :SGSEXOCON, :TXMOTIVCANCE,
          :VRACRCOMANDA, :CDPAIS, :SGESTADO, :CDMUNICIPIO,
          :NRCEPCONSCOMAND, :CDBAIRRO, :DSBAIRRO, :DSENDECONSCOMAN,
          :DSCOMPLENDCOCOM, :DSREFENDCONSCOM, :IDORGCMDVENDA,
          :IDRETBALLOJA, :NRCOMANDAEXT, :IDSINCAGENDA, TO_DATE(:DTHRAGENDADA,'DD/MM/YYYY HH24:MI:SS'),:IDIMPCUPEXP,
          :DSCONSUMIDOR, :DSOBSCOMANDA, :IDFECHAMENTOAPI
      )
    ";

    const SQL_INSERT_COMANDAVEN_EX = "
    INSERT INTO COMANDAVEN (
        CDFILIAL, NRVENDAREST, NRCOMANDA, CDLOJA,
        DSCOMANDA, IDSTCOMANDA, SGSEXOCON, TXMOTIVCANCE,
        VRACRCOMANDA, CDPAIS, SGESTADO, CDMUNICIPIO,
        NRCEPCONSCOMAND, CDBAIRRO, DSBAIRRO, DSENDECONSCOMAN,
        DSCOMPLENDCOCOM, DSREFENDCONSCOM, IDORGCMDVENDA,
        IDRETBALLOJA, NRCOMANDAEXT, IDSINCAGENDA, DTHRAGENDADA, IDIMPCUPEXP,
        DSCONSUMIDOR, DSOBSCOMANDA, IDFECHAMENTOAPI
    )
    VALUES (
        :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :CDLOJA,
        :DSCOMANDA, :IDSTCOMANDA, :SGSEXOCON, :TXMOTIVCANCE,
        :VRACRCOMANDA, :CDPAIS, :SGESTADO, :CDMUNICIPIO,
        :NRCEPCONSCOMAND, :CDBAIRRO, :DSBAIRRO, :DSENDECONSCOMAN,
        :DSCOMPLENDCOCOM, :DSREFENDCONSCOM, :IDORGCMDVENDA,
        :IDRETBALLOJA, :NRCOMANDAEXT, :IDSINCAGENDA, CONVERT(DATETIME, :DTHRAGENDADA, 103),
        :IDIMPCUPEXP, :DSCONSUMIDOR, :DSOBSCOMANDA, :IDFECHAMENTOAPI
    )
    ";

    const INSERT_ITCOMANDAVEN_EX = "
      INSERT INTO ITCOMANDAVEN (
        CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, CDPRODUTO, QTPRODCOMVEN, VRPRECCOMVEN, 
        TXPRODCOMVEN, IDSTPRCOMVEN, VRDESCCOMVEN, NRLUGARMESA, IDPRODIMPFIS, CDLOJA, VRACRCOMVEN, 
        NRSEQPRODCOM, NRSEQPRODCUP, VRPRECCLCOMVEN, CDCAIXACOLETOR, CDPRODPROMOCAO, CDVENDEDOR, 
        NRINSCRCONS, CDSENHAPED, NRATRAPRODCOVE, IDORIGEMVENDA, DSOBSPEDDIGCMD, IDIMPPRGRPROMO,
        DTHRINCOMVEN, IDOBSERVACAOAD
      )
      VALUES (
        :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :CDPRODUTO, :QTPRODCOMVEN, :VRPRECCOMVEN, 
        :TXPRODCOMVEN, :IDSTPRCOMVEN, :VRDESCCOMVEN, :NRLUGARMESA, :IDPRODIMPFIS, :CDLOJA, :VRACRCOMVEN, 
        :NRSEQPRODCOM, :NRSEQPRODCUP, :VRPRECCLCOMVEN, :CDCAIXACOLETOR, :CDPRODPROMOCAO, :CDVENDEDOR, 
        :NRINSCRCONS, :CDSENHAPED, :NRATRAPRODCOVE, :IDORIGEMVENDA, :DSOBSPEDDIGCMD, :IDIMPPRGRPROMO,
        GETDATE(), :IDOBSERVACAOAD
      )
    ";

    const INSERT_ITCOMANDAEST_EX = "
      INSERT INTO ITCOMANDAEST (
        CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, CDPRODUTO, QTPROCOMEST, VRPRECCOMEST, 
        VRDESITCOMEST, IDIMPPRGRPROMO, VRACRITCOMEST, TXPRODCOMVENEST
      )
      VALUES (
        :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :CDPRODUTO, :QTPROCOMEST, :VRPRECCOMEST, 
        :VRDESITCOMEST, :IDIMPPRGRPROMO, :VRACRITCOMEST, :TXPRODCOMVENEST
      )
    ";

    const INSERT_OBSITCOMANDAVEN_EX = "
      INSERT INTO OBSITCOMANDAVEN (
        CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, CDGRPOCOR, CDOCORR
      )
      VALUES (
        :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :CDGRPOCOR, :CDOCORR
      )
    ";

    const INSERT_OBSITCOMANDAEST_EX = "
      INSERT INTO OBSITCOMANDAEST (
        CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, CDPRODUTO, CDGRPOCOR, CDOCORR
      )
      VALUES (
        :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :CDPRODUTO, :CDGRPOCOR, :CDOCORR
      )
    ";

    const ORACLE_INSERT_MOVCAIXADLV = "		
    INSERT INTO MOVCAIXADLV (		
        CDFILIAL, NRVENDAREST, NRSEQMOVDLV, IDTIPOMOVIVEDLV,		
        VRMOVIVENDDLV, CDTIPORECE, CDCLIENTE, CDCONSUMIDOR, CDNSUTEFDLV, QTPARCRECEB, NRAUTORIZATEFDLV)		
    VALUES (		
        :CDFILIAL, :NRVENDAREST, :NRSEQMOVDLV, :IDTIPOMOVIVEDLV,		
        :VRMOVIVENDDLV, :CDTIPORECE, :CDCLIENTE, :CDCONSUMIDOR, :CDNSUTEFDLV, :QTPARCRECEB, :NRAUTORIZATEFDLV
    )		
    ";

  const SQL_INSERT_MOVCAIXADLV = "
    INSERT INTO MOVCAIXADLV (
        CDFILIAL, NRVENDAREST, NRSEQMOVDLV, IDTIPOMOVIVEDLV,
        VRMOVIVENDDLV, CDTIPORECE, CDCLIENTE, CDCONSUMIDOR, CDNSUTEFDLV, NRAUTORIZATEFDLV)
    VALUES (
        :CDFILIAL, :NRVENDAREST, :NRSEQMOVDLV, :IDTIPOMOVIVEDLV,
        :VRMOVIVENDDLV, :CDTIPORECE, :CDCLIENTE, :CDCONSUMIDOR, :CDNSUTEFDLV, :NRAUTORIZATEFDLV
    )
    ";

  const ORACLE_INSERT_ITCOMANDAVEN = "
    INSERT INTO ITCOMANDAVEN (
        CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN,
        CDPRODUTO, QTPRODCOMVEN, VRPRECCOMVEN, TXPRODCOMVEN,
        IDSTPRCOMVEN, VRDESCCOMVEN, NRLUGARMESA, DTHRINCOMVEN,
        IDPRODIMPFIS, CDLOJA, VRACRCOMVEN, NRSEQPRODCOM,
        NRSEQPRODCUP, VRPRECCLCOMVEN, CDCAIXACOLETOR,
        CDPRODPROMOCAO, CDVENDEDOR, NRINSCRCONS, CDSENHAPED, NRATRAPRODCOVE, IDORIGEMVENDA, DSOBSPEDDIGCMD, IDIMPPRGRPROMO
    )
    VALUES (
        :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN,
        :CDPRODUTO, :QTPRODCOMVEN, :VRPRECCOMVEN, :TXPRODCOMVEN,
        :IDSTPRCOMVEN, :VRDESCCOMVEN, :NRLUGARMESA, SYSDATE,
        :IDPRODIMPFIS, :CDLOJA, :VRACRCOMVEN, :NRSEQPRODCOM,
        :NRSEQPRODCUP, :VRPRECCLCOMVEN, :CDCAIXACOLETOR,
        :CDPRODPROMOCAO, :CDVENDEDOR, :NRINSCRCONS, :CDSENHAPED, :NRATRAPRODCOVE, :IDORIGEMVENDA, :DSOBSPEDDIGCMD, :IDIMPPRGRPROMO
    )
    ";

  const SQL_INSERT_ITCOMANDAVEN = "
    INSERT INTO ITCOMANDAVEN (
        CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN,
        CDPRODUTO, QTPRODCOMVEN, VRPRECCOMVEN, TXPRODCOMVEN,
        IDSTPRCOMVEN, VRDESCCOMVEN, NRLUGARMESA, DTHRINCOMVEN,
        IDPRODIMPFIS, CDLOJA, VRACRCOMVEN, NRSEQPRODCOM,
        NRSEQPRODCUP, VRPRECCLCOMVEN, CDCAIXACOLETOR,
        CDPRODPROMOCAO, CDVENDEDOR, NRINSCRCONS, CDSENHAPED, NRATRAPRODCOVE, IDORIGEMVENDA, DSOBSPEDDIGCMD, IDIMPPRGRPROMO
    )
    VALUES (
        :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN,
        :CDPRODUTO, :QTPRODCOMVEN, :VRPRECCOMVEN, :TXPRODCOMVEN,
        :IDSTPRCOMVEN, :VRDESCCOMVEN, :NRLUGARMESA, GETDATE(),
        :IDPRODIMPFIS, :CDLOJA, :VRACRCOMVEN, :NRSEQPRODCOM,
        :NRSEQPRODCUP, :VRPRECCLCOMVEN, :CDCAIXACOLETOR,
        :CDPRODPROMOCAO, :CDVENDEDOR, :NRINSCRCONS, :CDSENHAPED, :NRATRAPRODCOVE, :IDORIGEMVENDA, :DSOBSPEDDIGCMD, :IDIMPPRGRPROMO
    )
    ";

  const INSERT_ITCOMANDAEST = "
      INSERT INTO ITCOMANDAEST(
        CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, CDPRODUTO, QTPROCOMEST, VRPRECCOMEST, VRDESITCOMEST, 
        IDIMPPRGRPROMO, VRACRITCOMEST)
      VALUES
        (:CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :CDPRODUTO, :QTPROCOMEST, :VRPRECCOMEST, 
        :VRDESITCOMEST, :IDIMPPRGRPROMO, :VRACRITCOMEST)
    ";

  const INSERT_ITHRCOMANDA = "
    INSERT INTO ITHRCOMANDA
          (CDFILIAL,NRSEQUITEM,CDPRODUTO,DTHRPEDIDO,QTPRODCOMVEN,CDCAIXA,NRVENDAREST,NRSEQVENDA,IDIMPITHRCOMANDA)
    VALUES
      (:CDFILIAL,:NRSEQUITEM,:CDPRODUTO,GETDATE(),:QTPRODCOMVEN,:CDCAIXA,:NRVENDAREST,:NRSEQVENDA,:IDIMPITHRCOMANDA)
    ";

  const GET_NRCOMANDA = "
    SELECT NRCOMANDA 
		  FROM COMANDAVEN 
	   WHERE NRVENDAREST = :NRVENDAREST 
		   AND CDFILIAL = :CDFILIAL
    ";

  const GET_NRMESA = "
	  SELECT NRMESA 
		FROM VENDAREST 
	   WHERE CDFILIAL = :CDFILIAL 
	  	 AND NRVENDAREST = :NRVENDAREST
    ";

  const INSERT_MOVCAIXAMOB = "
		INSERT INTO MOVCAIXAMOB (
	                NRSEQMOVMOB, CDFILIAL, CDCAIXA, CDVENDEDOR, NRVENDAREST, NRCOMANDA, NRSEQVENDA, NRMESA, 
	                NRLUGARMESA, CDTIPORECE, IDTIPMOV, VRMOV, DTHRINCMOV, DSBANDEIRA, IDTPTEF, IDSTMOV, IDADMTASK, IDUTILTXSERV, CDCLIENTE, CDCONSUMIDOR)
	            VALUES
	           ( :NRSEQMOVMOB , :CDFILIAL , :CDCAIXA , :CDVENDEDOR , :NRVENDAREST , :NRCOMANDA , :NRSEQVENDA , :NRMESA ,
	            :NRLUGARMESA , :CDTIPORECE , :IDTIPMOV , :VRMOV , SYSDATE, :DSBANDEIRA , :IDTPTEF, '1', '0', :IDUTILTXSERV, :CDCLIENTE, :CDCONSUMIDOR ) 
    ";

  const SQL_ALTERA_STATUS_MESA = "
        UPDATE MESA
           SET IDSTMESAAUX = :IDSTMESAAUX,
               DTBLOQMESA  = TO_DATE(:DTBLOQMESA, 'DD/MM/YYYY HH24:MI:SS')
         WHERE CDFILIAL    = :CDFILIAL
           AND CDLOJA      = :CDLOJA
           AND NRMESA IN (SELECT DISTINCT NRMESA
                             FROM MESA
                            WHERE CDFILIAL = :CDFILIAL
                              AND CDLOJA   = :CDLOJA
                              AND NRMESA   = :NRMESA
                            UNION
                           SELECT NRMESA
                             FROM JUNCAOMESA JM, MESAJUNCAO MJ
                            WHERE JM.CDFILIAL  = :CDFILIAL
                              AND JM.CDFILIAL  = MJ.CDFILIAL
                              AND JM.CDLOJA    = :CDLOJA
                              AND JM.NRJUNMESA = MJ.NRJUNMESA
                              AND JM.CDLOJA    = MJ.CDLOJA
                              AND JM.NRJUNMESA = (SELECT NRJUNMESA
                                                    FROM MESAJUNCAO
                                                   WHERE CDFILIAL = :CDFILIAL
                                                     AND CDLOJA   = :CDLOJA
                                                     AND NRMESA   = :NRMESA
                                                 )
                         )
    ";

  const SQL_ALTERA_STATUS_POSICAO = "
		UPDATE ITCOMANDAVEN
		   SET IDSTLUGARMESA = :IDSTLUGARMESA,
		       DTBLOQPOS     = TO_DATE(:DTBLOQPOS, 'DD/MM/YYYY HH24:MI:SS')
		 WHERE CDFILIAL    = :CDFILIAL
		   AND NRVENDAREST = :NRVENDAREST
		   AND NRCOMANDA   = :NRCOMANDA 
		   AND NRLUGARMESA = :NRLUGARMESA
    ";

  const SQL_ALTERA_CPF_POSICAO = "
		UPDATE ITCOMANDAVEN
		   SET NRINSCRCONS = :NRINSCRCONS
		 WHERE CDFILIAL    = :CDFILIAL
		   AND NRVENDAREST = :NRVENDAREST
		   AND NRCOMANDA   = :NRCOMANDA 
		   AND (NRLUGARMESA = :NRLUGARMESA OR nvl(:NRLUGARMESA,'T') = 'T')
		   AND NRINSCRCONS IS NULL
    ";

  const ORACLE_GET_DELIVERY_AREAS = "
	  SELECT NVL(FA.VRTXENTRFILIAR,NVL(PA.VRTXENTREGA,0)) AS VRTXENTREGA,
           FA.CDFILIAL, 
           A.CDAREA,
           REPLACE(A.COORDAREA,:DOUBLE,:SINGLE) COORDAREA,
           FA.NRORDATEND
      FROM AREAATEND A
      JOIN FILIALAREA FA
        ON A.CDAREA = FA.CDAREA
      JOIN PARAVEND PA
        ON FA.CDFILIAL = PA.CDFILIAL
  ORDER BY NVL(FA.VRTXENTRFILIAR,NVL(PA.VRTXENTREGA,0))
	";

  const SQL_GET_DELIVERY_AREAS = "
	  SELECT ISNULL(FA.VRTXENTRFILIAR,ISNULL(PA.VRTXENTREGA,0)) AS VRTXENTREGA,
           FA.CDFILIAL, 
           A.CDAREA,
           REPLACE(A.COORDAREA,:DOUBLE,:SINGLE) COORDAREA,
           FA.NRORDATEND
      FROM AREAATEND A
      JOIN FILIALAREA FA
        ON A.CDAREA = FA.CDAREA
      JOIN PARAVEND PA
        ON FA.CDFILIAL = PA.CDFILIAL
  ORDER BY ISNULL(FA.VRTXENTRFILIAR,ISNULL(PA.VRTXENTREGA,0))
    ";

  const ORACLE_GET_PRODUCTS_RECALCULATE = "
		SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
		       '' AS CDPRODPROMOCAO, IT.VRPRECCOMVEN , IT.QTPRODCOMVEN, IT.VRDESCCOMVEN, IT.TXPRODCOMVEN, IT.NRPRODCOMVEN,
		       IT.NRVENDAREST, IT.NRCOMANDA, IT.CDFILIAL
			   
		  FROM ITCOMANDAVEN IT
		  JOIN COMANDAVEN CV
	        ON IT.NRVENDAREST = CV.NRVENDAREST
	       AND IT.CDFILIAL = CV.CDFILIAL
	      JOIN VENDAREST VE
	        ON CV.NRVENDAREST = VE.NRVENDAREST
	       AND CV.CDFILIAL = VE.CDFILIAL
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		  
		 WHERE VE.CDFILIAL   = :CDFILIAL
		   AND VE.NRMESA    = :NRMESA
		   AND (IT.NRLUGARMESA = :NRLUGARMESA OR NVL(:NRLUGARMESA,'T') = 'T')
		   AND IT.IDSTLUGARMESA <> 'P'
           AND VE.CDLOJA = :CDLOJA
		   AND IT.CDPRODPROMOCAO IS NULL
	  ORDER BY IT.NRVENDAREST DESC
	";
  
  const ORACLE_GET_PRODUCTS_RECALCULATE_EX = "
    SELECT IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
          '' AS CDPRODPROMOCAO, IT.VRPRECCOMVEN , IT.QTPRODCOMVEN, IT.VRDESCCOMVEN, IT.TXPRODCOMVEN, IT.NRPRODCOMVEN,
          IT.NRVENDAREST, IT.NRCOMANDA, IT.CDFILIAL
        
      FROM ITCOMANDAVEN IT
      JOIN COMANDAVEN CV
          ON IT.NRVENDAREST = CV.NRVENDAREST
        AND IT.CDFILIAL = CV.CDFILIAL
        JOIN VENDAREST VE
          ON CV.NRVENDAREST = VE.NRVENDAREST
        AND CV.CDFILIAL = VE.CDFILIAL
      JOIN PRODUTO PR
        ON IT.CDPRODUTO = PR.CDPRODUTO
      
    WHERE VE.CDFILIAL   = :CDFILIAL
      AND IT.NRCOMANDA = :NRCOMANDA
          AND VE.CDLOJA = :CDLOJA
      AND IT.CDPRODPROMOCAO IS NULL
    ORDER BY IT.NRVENDAREST DESC
  ";

  const SQL_GET_PRODUCTS_RECALCULATE = "
		SELECT IT.CDPRODUTO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, ISNULL(PR.DSPRODVENDA, '') AS DESCRIPTION,
		       '' AS CDPRODPROMOCAO, IT.VRPRECCOMVEN , IT.QTPRODCOMVEN, IT.VRDESCCOMVEN, IT.TXPRODCOMVEN, IT.NRPRODCOMVEN,
		       IT.NRVENDAREST, IT.NRCOMANDA, IT.CDFILIAL
			   
		  FROM ITCOMANDAVEN IT
		  JOIN COMANDAVEN CV
	        ON IT.NRVENDAREST = CV.NRVENDAREST
	       AND IT.CDFILIAL = CV.CDFILIAL
	      JOIN VENDAREST VE
	        ON CV.NRVENDAREST = VE.NRVENDAREST
	       AND CV.CDFILIAL = VE.CDFILIAL
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		  
		 WHERE VE.CDFILIAL   = :CDFILIAL
		   AND VE.NRMESA    = :NRMESA
		   AND (IT.NRLUGARMESA = :NRLUGARMESA OR ISNULL(:NRLUGARMESA,'T') = 'T')
		   AND IT.IDSTLUGARMESA <> 'P'
           AND VE.CDLOJA = :CDLOJA
		   AND IT.CDPRODPROMOCAO IS NULL
	  ORDER BY IT.NRVENDAREST DESC
    ";

    const SQL_GET_PRODUCTS_RECALCULATE_EX = "
		SELECT IT.CDPRODUTO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, ISNULL(PR.DSPRODVENDA, '') AS DESCRIPTION,
		       '' AS CDPRODPROMOCAO, IT.VRPRECCOMVEN , IT.QTPRODCOMVEN, IT.VRDESCCOMVEN, IT.TXPRODCOMVEN, IT.NRPRODCOMVEN,
		       IT.NRVENDAREST, IT.NRCOMANDA, IT.CDFILIAL
			   
		  FROM ITCOMANDAVEN IT
		  JOIN COMANDAVEN CV
	        ON IT.NRVENDAREST = CV.NRVENDAREST
	       AND IT.CDFILIAL = CV.CDFILIAL
	      JOIN VENDAREST VE
	        ON CV.NRVENDAREST = VE.NRVENDAREST
	       AND CV.CDFILIAL = VE.CDFILIAL
		  JOIN PRODUTO PR
		    ON IT.CDPRODUTO = PR.CDPRODUTO
		  
		 WHERE VE.CDFILIAL   = :CDFILIAL
          AND IT.NRCOMANDA = :NRCOMANDA
           AND VE.CDLOJA = :CDLOJA
		   AND IT.CDPRODPROMOCAO IS NULL
	  ORDER BY IT.NRVENDAREST DESC
    ";

  const ORACLE_GET_COMBOS_RECALCULATE = "
		SELECT IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQPRODCOM,
			   SUM(IT.VRPRECCOMVEN) VRPRECCOMVEN, SUM(IT.VRDESCCOMVEN) VRDESCCOMVEN, SUM(IT.VRACRCOMVEN) VRACRCOMVEN, IT.CDFILIAL,
			   IT.NRVENDAREST, IT.NRCOMANDA, IT.NRLUGARMESA
	
		  FROM ITCOMANDAVEN IT, VENDAREST VE, PRODUTO PR    		 
 		 WHERE IT.CDPRODPROMOCAO IS NOT NULL
           AND IT.CDPRODPROMOCAO = PR.CDPRODUTO
           AND IT.NRVENDAREST = VE.NRVENDAREST      
           AND IT.CDLOJA = VE.CDLOJA    
           AND IT.CDFILIAL = VE.CDFILIAL
           AND VE.CDFILIAL     = :CDFILIAL
           AND VE.NRMESA       = :NRMESA
           AND (IT.NRLUGARMESA = :NRLUGARMESA OR NVL(:NRLUGARMESA,'T') = 'T')
           AND VE.CDLOJA       = :CDLOJA
   	  GROUP BY IT.CDPRODPROMOCAO,NVL(PR.NMPRODVENDA ,PR.NMPRODUTO),IT.NRSEQPRODCOM, IT.CDFILIAL, IT.NRVENDAREST, IT.NRCOMANDA, IT.NRLUGARMESA
	  ORDER BY IT.NRVENDAREST DESC
	";

  const ORACLE_GET_COMBOS_RECALCULATE_EX = "
		SELECT IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQPRODCOM,
			   SUM(IT.VRPRECCOMVEN) VRPRECCOMVEN, SUM(IT.VRDESCCOMVEN) VRDESCCOMVEN, SUM(IT.VRACRCOMVEN) VRACRCOMVEN, IT.CDFILIAL,
			   IT.NRVENDAREST, IT.NRCOMANDA, IT.NRLUGARMESA
	
		  FROM ITCOMANDAVEN IT, VENDAREST VE, PRODUTO PR    		 
 		 WHERE IT.CDPRODPROMOCAO IS NOT NULL
           AND IT.CDPRODPROMOCAO = PR.CDPRODUTO
           AND IT.NRVENDAREST = VE.NRVENDAREST      
           AND IT.CDLOJA = VE.CDLOJA    
           AND IT.CDFILIAL = VE.CDFILIAL
           AND VE.CDFILIAL     = :CDFILIAL
           AND IT.NRCOMANDA = :NRCOMANDA
           AND VE.CDLOJA       = :CDLOJA
   	  GROUP BY IT.CDPRODPROMOCAO,NVL(PR.NMPRODVENDA ,PR.NMPRODUTO),IT.NRSEQPRODCOM, IT.CDFILIAL, IT.NRVENDAREST, IT.NRCOMANDA, IT.NRLUGARMESA
	  ORDER BY IT.NRVENDAREST DESC
	";

  const SQL_GET_COMBOS_RECALCULATE = "
		SELECT IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQPRODCOM,
			   SUM(IT.VRPRECCOMVEN) VRPRECCOMVEN, SUM(IT.VRDESCCOMVEN) VRDESCCOMVEN, SUM(IT.VRACRCOMVEN) VRACRCOMVEN, IT.CDFILIAL,
			   IT.NRVENDAREST, IT.NRCOMANDA, IT.NRLUGARMESA
	
		  FROM ITCOMANDAVEN IT, VENDAREST VE, PRODUTO PR    		 
 		 WHERE IT.CDPRODPROMOCAO IS NOT NULL
           AND IT.CDPRODPROMOCAO = PR.CDPRODUTO
           AND IT.NRVENDAREST = VE.NRVENDAREST      
           AND IT.CDLOJA = VE.CDLOJA    
           AND IT.CDFILIAL = VE.CDFILIAL
           AND VE.CDFILIAL     = :CDFILIAL
           AND VE.NRMESA       = :NRMESA
           AND (IT.NRLUGARMESA = :NRLUGARMESA OR ISNULL(:NRLUGARMESA,'T') = 'T')
           AND VE.CDLOJA       = :CDLOJA
   	  GROUP BY IT.CDPRODPROMOCAO,ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO),IT.NRSEQPRODCOM, IT.CDFILIAL, IT.NRVENDAREST, IT.NRCOMANDA, IT.NRLUGARMESA
	  ORDER BY IT.NRVENDAREST DESC
    ";

  const SQL_GET_COMBOS_RECALCULATE_EX = "
		SELECT IT.CDPRODPROMOCAO AS CDPRODUTO, IT.CDPRODPROMOCAO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRSEQPRODCOM,
			   SUM(IT.VRPRECCOMVEN) VRPRECCOMVEN, SUM(IT.VRDESCCOMVEN) VRDESCCOMVEN, SUM(IT.VRACRCOMVEN) VRACRCOMVEN, IT.CDFILIAL,
			   IT.NRVENDAREST, IT.NRCOMANDA, IT.NRLUGARMESA
	
		  FROM ITCOMANDAVEN IT, VENDAREST VE, PRODUTO PR    		 
 		 WHERE IT.CDPRODPROMOCAO IS NOT NULL
           AND IT.CDPRODPROMOCAO = PR.CDPRODUTO
           AND IT.NRVENDAREST = VE.NRVENDAREST      
           AND IT.CDLOJA = VE.CDLOJA    
           AND IT.CDFILIAL = VE.CDFILIAL
           AND VE.CDFILIAL     = :CDFILIAL
           AND IT.NRCOMANDA = :NRCOMANDA
           AND VE.CDLOJA       = :CDLOJA
   	  GROUP BY IT.CDPRODPROMOCAO,ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO),IT.NRSEQPRODCOM, IT.CDFILIAL, IT.NRVENDAREST, IT.NRCOMANDA, IT.NRLUGARMESA
	  ORDER BY IT.NRVENDAREST DESC
    ";

  const ORACLE_GET_COMBO_PRODUCTS_RECALCULATE = "
		SELECT IT.CDFILIAL, IT.CDPRODUTO, NVL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, NVL(PR.DSPRODVENDA, '') AS DESCRIPTION,
			   IT.VRPRECCOMVEN , IT.QTPRODCOMVEN , IT.VRDESCCOMVEN, IT.VRACRCOMVEN, IT.NRINSCRCONS, IT.NRPRODCOMVEN
          FROM ITCOMANDAVEN IT 
          JOIN PRODUTO PR
            ON PR.CDPRODUTO = IT.CDPRODUTO
         WHERE IT.CDFILIAL       = :CDFILIAL
           AND IT.CDPRODPROMOCAO = :CDPRODPROMOCAO
           AND IT.NRVENDAREST    = :NRVENDAREST
           AND IT.NRCOMANDA      = :NRCOMANDA
           AND IT.NRSEQPRODCOM   = :NRSEQPRODCOM
           AND IT.IDSTLUGARMESA  <> 'P'
      ORDER BY IT.NRPRODCOMVEN
	";

  const SQL_GET_COMBO_PRODUCTS_RECALCULATE = "
		SELECT IT.CDFILIAL, IT.CDPRODUTO, ISNULL(PR.NMPRODVENDA ,PR.NMPRODUTO) AS NMPRODUTO, IT.NRPRODCOMVEN, IT.NRCOMANDA,
               IT.NRVENDAREST, IT.QTPRODCOMVEN, IT.VRPRECCOMVEN, IT.TXPRODCOMVEN, IT.VRDESCCOMVEN, IT.VRACRCOMVEN
          FROM ITCOMANDAVEN IT 
          JOIN PRODUTO PR
            ON PR.CDPRODUTO = IT.CDPRODUTO
         WHERE IT.CDFILIAL       = :CDFILIAL
           AND IT.CDPRODPROMOCAO = :CDPRODPROMOCAO
           AND IT.NRVENDAREST    = :NRVENDAREST
           AND IT.NRCOMANDA      = :NRCOMANDA
           AND IT.NRSEQPRODCOM   = :NRSEQPRODCOM
           AND IT.IDSTLUGARMESA  <> 'P'
      ORDER BY IT.NRPRODCOMVEN
    ";

  const UPDATE_ITEM_PRICE = "
        UPDATE ITCOMANDAVEN
           SET VRPRECCOMVEN = :VRPRECCOMVEN,
               VRDESCCOMVEN = :VRDESCCOMVEN
         WHERE CDFILIAL 	= :CDFILIAL 
           AND NRVENDAREST 	= :NRVENDAREST 
           AND NRCOMANDA 	= :NRCOMANDA 
           AND NRPRODCOMVEN = :NRPRODCOMVEN
    ";

  const ORACLE_GET_TODAYS_EXPENDITURE = "
        SELECT SUM(VRMOVEXTCONS) AS VRMOVEXTCONS
          FROM EXTRATOCONS EX
         WHERE EX.CDCLIENTE    = :CDCLIENTE
           AND EX.CDCONSUMIDOR = :CDCONSUMIDOR
           AND EX.IDTPMOVEXT   = 'V' 
           AND TO_DATE(TO_CHAR(DTMOVEXTCONS, 'DD/MM/YYYY'), 'DD/MM/YYYY') = TO_DATE(TO_CHAR(SYSDATE, 'DD/MM/YYYY'),'DD/MM/YYYY')
      ORDER BY DTMOVEXTCONS DESC
    ";

  const SQL_GET_TODAYS_EXPENDITURE = "
        SELECT SUM(VRMOVEXTCONS) AS VRMOVEXTCONS
          FROM EXTRATOCONS EX
         WHERE EX.CDCLIENTE    = :CDCLIENTE
           AND EX.CDCONSUMIDOR = :CDCONSUMIDOR
           AND EX.IDTPMOVEXT   = 'V' 
           AND CONVERT(VARCHAR(10),DTMOVEXTCONS, 103) = CONVERT(VARCHAR(10),GETDATE(), 103)
      GROUP BY DTMOVEXTCONS
      ORDER BY DTMOVEXTCONS DESC
    ";

  const ORACLE_TABELA_VENDA = "
		SELECT TO_CHAR(DTINIVGPREC, 'DD/MM/YYYY HH24:MI:SS') AS DTINIVGPREC
		  FROM TABEVEND
		 WHERE CDFILIAL   = :CDFILIAL
		   AND CDTABEPREC = :CDTABEPREC
		   AND TRUNC(SYSDATE) BETWEEN DTINIVGPREC AND DTFINVGPREC
	";

  const SQL_TABELA_VENDA = "
        SELECT CONVERT(VARCHAR, DTINIVGPREC, 21) AS DTINIVGPREC
	 	  FROM TABEVEND
	 	 WHERE CDFILIAL   = :CDFILIAL
	       AND CDTABEPREC = :CDTABEPREC
           AND (CONVERT(VARCHAR, GETDATE(), 103) BETWEEN DTINIVGPREC AND DTFINVGPREC)
    ";

  const CLIENTE_FILIAL = "
        SELECT CDTABEPREC, CDCFILTABPRE
          FROM CLIENFILIAL
         WHERE CDFILIAL = :CDFILIAL
           AND CDCLIENTE = :CDCLIENTE
    ";

  const EXISTE_PRECO_CLIE = "
        SELECT CDTABEPREC, CDFILTABPREC
          FROM CLIENTE
         WHERE (CDCLIENTE = :CDCLIENTE)
    ";

  const TABELA_PRECO_LOJA = "
        SELECT CDTABEPREC
          FROM LOJA
         WHERE (CDFILIAL = :CDFILIAL)
           AND (CDLOJA   = :CDLOJA)
    ";

  const PARAVEND = "
        SELECT CDTABEPREC, IDPRECDIFCOM
          FROM PARAVEND
         WHERE (CDFILIAL = :CDFILIAL)
    ";

  const VALIDA_MESA = "
        SELECT NRMESA, IDSTMESAAUX  
          FROM MESA
         WHERE NRMESA = :NRMESA 
    ";

  const ABRE_MESA = "
        UPDATE MESA 
           SET IDSTMESAAUX = 'O' 
         WHERE NRMESA = :NRMESA
    ";

  const GET_DADOS_MESA = "
      SELECT V.NRVENDAREST, C.NRCOMANDA
        FROM VENDAREST V
        JOIN COMANDAVEN C
          ON C.CDFILIAL = V.CDFILIAL
         AND C.NRVENDAREST = V.NRVENDAREST
       WHERE V.NRMESA = :NRMESA
         AND V.CDFILIAL = :CDFILIAL
    ";

  const ATUALIZA_MESA = "
        UPDATE MESA
           SET IDSTMESAAUX = 'O'
         WHERE CDFILIAL = :CDFILIAL
           AND NRMESA = :NRMESA
           AND CDLOJA = :CDLOJA
    ";

  const GET_TABLES = "
        SELECT NRMESA
          FROM MESA
         WHERE CDFILIAL = :CDFILIAL
    ";

  const GET_CONSUMER_BALANCE = "
	    SELECT EX.VRSALDCONEXT, CO.VRMAXCREDCONS
	      FROM CONSUMIDOR CO
	 LEFT JOIN EXTRATOCONS EX
	        ON EX.CDCLIENTE    = CO.CDCLIENTE
	       AND EX.CDCONSUMIDOR = CO.CDCONSUMIDOR
	     WHERE CO.CDCLIENTE    = :CDCLIENTE
	       AND CO.CDCONSUMIDOR = :CDCONSUMIDOR
	  ORDER BY DTMOVEXTCONS DESC
    ";

  const GET_DADOS_IMPRESSORA = "
        SELECT NRSEQIMPRLOJA, '' AS DSENDPORTA, CDPORTAIMPR, PR.DSIPIMPR, IMP.IDMODEIMPRES, PR.DSIPPONTE
          FROM IMPRLOJA PR
     LEFT JOIN IMPRESSORA IMP
            ON IMP.CDIMPRESSORA = PR.CDIMPRESSORA
         WHERE DSIPPONTE IS NOT NULL
    ";

  const GET_COMANDA_INFO = "
        SELECT V.NMFANVEN, VE.CDFILIAL, VE.NRVENDAREST, CV.DSCOMANDA, VE.CDLOJA, VE.NRPESMESAVEN, M.IDSTMESAAUX,
		       L.CDPRODCOUVER, L.CDPRODCONSUM, L.IDCOMISVENDA, L.VRCOMISVENDA, L.IDLUGARMESA
          FROM VENDAREST VE
          JOIN MESA M
            ON M.NRMESA = VE.NRMESA
          JOIN COMANDAVEN CV
            ON CV.NRVENDAREST = VE.NRVENDAREST
           AND CV.CDFILIAL = VE.CDFILIAL
          JOIN LOJA L
		    ON L.CDFILIAL = VE.CDFILIAL
           AND L.CDLOJA = VE.CDLOJA
          JOIN VENDEDOR V
		    ON V.CDVENDEDOR = VE.CDVENDEDOR
         WHERE M.NRMESA = :NRMESA
           AND CV.NRCOMANDA = :NRCOMANDA
    ";

  const SQL_TEMPO_PERMANENCIA = "
        SELECT CONVERT(VARCHAR,VE.DTHRABERMESA,21) AS DATA
          FROM VENDAREST VE, COMANDAVEN CM
         WHERE CM.CDFILIAL    = :CDFILIAL
           AND CM.NRVENDAREST = :NRVENDAREST
           AND CM.NRCOMANDA   = :NRCOMANDA
           AND VE.CDFILIAL    = CM.CDFILIAL
           AND VE.NRVENDAREST = CM.NRVENDAREST
    ";

  const SQL_PRODUTOS_PARCIAL = "
        SELECT IT.NRVENDAREST, IT.NRCOMANDA, MIN(IT.NRPRODCOMVEN) AS NRPRODCOMVEN, SUM(IT.QTPRODCOMVEN) AS QTPRODCOMVEN,
               SUM(IT.VRDESCCOMVEN) AS VRDESCCOMVEN, ISNULL(PR.NMPRODIMPFIS, PR.NMPRODUTO) AS NMPRODUTO,
               IT.VRPRECCOMVEN, IT.VRPRECCLCOMVEN, PR.CDARVPROD, IT.CDPRODUTO, IT.IDSTPRCOMVEN, IT.NRMESADSCOMORIT,
               SUM(VRACRCOMVEN) AS VRACRCOMVEN, PR.IDCOBTXSERV, ISNULL(IT.NRLUGARMESA, '001') AS NRLUGARMESA, V.DTHRABERMESA,
               PR.CDBARPRODUTO AS CDPRODIMPFIS, ISNULL(VE.VRPERCCOMISVEND, 0) AS VRPERCCOMISVEND, VE.IDVRINCIDECONTA,
               SUM((IT.VRPRECCOMVEN + IT.VRPRECCLCOMVEN) * IT.QTPRODCOMVEN + IT.VRACRCOMVEN - IT.VRDESCCOMVEN) AS PRECO, PR.IDPESAPROD
          FROM ITCOMANDAVEN IT
          JOIN PRODUTO PR ON PR.CDPRODUTO = IT.CDPRODUTO
          JOIN VENDAREST V ON V.CDFILIAL = IT.CDFILIAL
                          AND V.NRVENDAREST = IT.NRVENDAREST
          LEFT JOIN VENDEDOR VE ON VE.CDVENDEDOR = IT.CDVENDEDOR
         WHERE (IT.CDFILIAL = :CDFILIAL)
           AND (CHARINDEX(IT.NRCOMANDA, :STCOMANDAVENS) > 0)
           AND (IT.IDSTPRCOMVEN <> '6' AND IT.IDSTPRCOMVEN <> '7')
           AND (IT.CDPRODUTO <> 'X')
           AND (PR.IDPESAPROD = 'N')
           AND ((CHARINDEX(IT.NRLUGARMESA, :STPOSICOES) > 0) OR ('T' = :IMPPOSICAO))
           AND IT.IDPRODREFIL = 'N'
         GROUP BY IT.NRVENDAREST, IT.NRCOMANDA, ISNULL(PR.NMPRODIMPFIS, PR.NMPRODUTO), IT.VRPRECCOMVEN, IT.VRPRECCLCOMVEN,
                  PR.CDARVPROD, IT.CDPRODUTO, IT.IDSTPRCOMVEN, IT.NRMESADSCOMORIT, PR.IDCOBTXSERV,
                  IT.NRLUGARMESA, V.DTHRABERMESA, PR.CDBARPRODUTO, IT.NRPRODCOMVEN, IT.QTPRODCOMVEN,
                  IT.VRDESCCOMVEN, IT.VRACRCOMVEN, VRPERCCOMISVEND, VE.IDVRINCIDECONTA, PR.IDPESAPROD
         UNION
        SELECT IT.NRVENDAREST, IT.NRCOMANDA, IT.NRPRODCOMVEN AS NRPRODCOMVEN, IT.QTPRODCOMVEN AS QTPRODCOMVEN,
               IT.VRDESCCOMVEN AS VRDESCCOMVEN, ISNULL(PR.NMPRODIMPFIS, PR.NMPRODUTO) AS NMPRODUTO,
               IT.VRPRECCOMVEN, IT.VRPRECCLCOMVEN, PR.CDARVPROD, IT.CDPRODUTO, IT.IDSTPRCOMVEN, IT.NRMESADSCOMORIT,
               VRACRCOMVEN AS VRACRCOMVEN, PR.IDCOBTXSERV, ISNULL(IT.NRLUGARMESA, '001') AS NRLUGARMESA, V.DTHRABERMESA,
               PR.CDBARPRODUTO AS CDPRODIMPFIS, ISNULL(VE.VRPERCCOMISVEND, 0) AS VRPERCCOMISVEND, VE.IDVRINCIDECONTA,
               SUM((IT.VRPRECCOMVEN + IT.VRPRECCLCOMVEN) * IT.QTPRODCOMVEN + IT.VRACRCOMVEN - IT.VRDESCCOMVEN) AS PRECO, PR.IDPESAPROD
          FROM ITCOMANDAVEN IT
          JOIN PRODUTO PR ON PR.CDPRODUTO = IT.CDPRODUTO
          JOIN VENDAREST V ON V.CDFILIAL = IT.CDFILIAL
                          AND V.NRVENDAREST = IT.NRVENDAREST
          LEFT JOIN VENDEDOR VE ON VE.CDVENDEDOR = IT.CDVENDEDOR
         WHERE (IT.CDFILIAL = :CDFILIAL)
           AND (CHARINDEX(IT.NRCOMANDA, :STCOMANDAVENS) > 0)
           AND (IT.IDSTPRCOMVEN <> '6' AND IT.IDSTPRCOMVEN <> '7')
           AND (IT.CDPRODUTO <> 'X')
           AND (PR.IDPESAPROD = 'S')
           AND ((CHARINDEX(IT.NRLUGARMESA, :STPOSICOES) > 0) OR ('T' = :IMPPOSICAO))
           AND IT.IDPRODREFIL = 'N'
         GROUP BY IT.NRVENDAREST, IT.NRCOMANDA, ISNULL(PR.NMPRODIMPFIS, PR.NMPRODUTO), IT.VRPRECCOMVEN, IT.VRPRECCLCOMVEN,
                  PR.CDARVPROD, IT.CDPRODUTO, IT.IDSTPRCOMVEN, IT.NRMESADSCOMORIT, PR.IDCOBTXSERV,
                  IT.NRLUGARMESA, V.DTHRABERMESA, PR.CDBARPRODUTO, IT.NRPRODCOMVEN, IT.QTPRODCOMVEN,
                  IT.VRDESCCOMVEN, IT.VRACRCOMVEN, VRPERCCOMISVEND, VE.IDVRINCIDECONTA, PR.IDPESAPROD
         ORDER BY NRLUGARMESA, IT.NRVENDAREST, IT.NRCOMANDA, NRPRODCOMVEN, QTPRODCOMVEN,
                  VRDESCCOMVEN, NMPRODUTO, IT.VRPRECCOMVEN, PR.CDARVPROD, IT.CDPRODUTO, IT.IDSTPRCOMVEN,
                  IT.NRMESADSCOMORIT, VRACRCOMVEN, PR.IDCOBTXSERV, V.DTHRABERMESA, CDPRODIMPFIS, PRECO
    ";

  const SQL_GET_COMISSAO_VENDA = "
        SELECT VRCOMISVENDE, VRCOMISPOR
          FROM COMANDAVEN
         WHERE CDFILIAL     = :CDFILIAL
           AND NRVENDAREST  = :NRVENDAREST
           AND NRCOMANDA    = :NRCOMANDA
    ";

  const SQL_VAL_IMPRE_LOJA = "
        SELECT I.IDMODEIMPRES, L.CDPORTAIMPR, L.NRSEQIMPRLOJA, M.DSENDPORTA,
               L.DSIPIMPR, L.DSIPPONTE
          FROM IMPRESSORA I,
               IMPRLOJA L LEFT JOIN MAPIMPRLOJA M
                                 ON L.CDFILIAL = M.CDFILIAL
                                AND L.CDLOJA = M.CDLOJA
                                AND L.CDPORTAIMPR = M.CDPORTAIMPR
         WHERE L.CDFILIAL      = :CDFILIAL
           AND L.CDLOJA        = :CDLOJA
           AND L.NRSEQIMPRLOJA = :NRSEQIMPRLOJA
           AND L.CDIMPRESSORA  = I.CDIMPRESSORA
    ";

  const GET_SON_COMBO = "
        SELECT CDGRUPROMOC, CDPRODPROMOCAO, CDPRODUTO, IDPERVALORDES, VRDESPRODPROMOC
          FROM DESGRUPROMOCPR 
         WHERE CDPRODUTO = :CDPRODUTO
           AND CDPRODPROMOCAO = :CDPRODPROMOCAO
           AND CDGRUPROMOC = :CDGRUPROMOC
    ";

  const SQL_GET_COMBO_GROUPS_SUBSIDIARY_DISCOUNT = "
        SELECT G.CDGRUPROMOC, P.NMGRUPROMOC, G.QTPRGRUPPROMFIL AS QTPRGRUPPROMOC, IDAPLICADESCFIL AS IDAPLICADESC
          FROM GRUPROMOCPRFIL G 
          JOIN GRUPROMOC P
            ON G.CDGRUPROMOC = P.CDGRUPROMOC
         WHERE G.CDPRODPROMOCAO = :CDIDENTBUTON
           AND G.CDFILIAL = :CDFILIAL
      ORDER BY G.IDAPLICADESCFIL DESC
    ";

  const SQL_GET_COMBO_GROUPS_PRODUCT_DISCOUNT = "
        SELECT G.CDGRUPROMOC, P.NMGRUPROMOC, G.QTPRGRUPPROMOC, IDAPLICADESC 
          FROM GRUPROMOCPROD G 
          JOIN GRUPROMOC P
            ON G.CDGRUPROMOC = P.CDGRUPROMOC
         WHERE G.CDPRODPROMOCAO = :CDIDENTBUTON
      ORDER BY G.IDAPLICADESC DESC
    ";

  const SQL_POSICAO_PARCIAL = "
        SELECT A.NRLUGARMESA, SUM(A.PRECOTX) AS PRECOTX, SUM(A.PRECONTX) AS PRECONTX
        FROM (
            SELECT I.NRLUGARMESA, SUM((I.VRPRECCOMVEN + I.VRPRECCLCOMVEN) * I.QTPRODCOMVEN + I.VRACRCOMVEN - I.VRDESCCOMVEN) AS PRECOTX, 0 AS PRECONTX
            FROM ITCOMANDAVEN I, PRODUTO P
            WHERE I.CDPRODUTO   = P.CDPRODUTO
                AND I.CDFILIAL    = :CDFILIAL
                AND (CHARINDEX(I.NRVENDAREST, :NRVENDAREST) > 0)
                AND (CHARINDEX(I.NRCOMANDA, :NRCOMANDA) > 0)
                AND I.IDSTPRCOMVEN <> '6'
                AND I.IDSTPRCOMVEN <> '7'
                AND ((I.CDPRODUTO <> :CDPRODUTO) OR (:CDPRODUTO IS NULL))
                AND P.IDCOBTXSERV = 'S'
            GROUP BY I.NRLUGARMESA
            UNION ALL
            SELECT I.NRLUGARMESA, 0 AS PRECOTX, SUM((I.VRPRECCOMVEN + I.VRPRECCLCOMVEN) * I.QTPRODCOMVEN + I.VRACRCOMVEN - I.VRDESCCOMVEN) AS PRECONTX
            FROM ITCOMANDAVEN I, PRODUTO P
            WHERE I.CDPRODUTO   = P.CDPRODUTO
                AND I.CDFILIAL    = :CDFILIAL
                AND (CHARINDEX(I.NRVENDAREST, :NRVENDAREST) > 0)
                AND (CHARINDEX(I.NRCOMANDA, :NRCOMANDA) > 0)
                AND I.IDSTPRCOMVEN <> '6'
                AND I.IDSTPRCOMVEN <> '7'
                AND ((I.CDPRODUTO <> :CDPRODUTO) OR (:CDPRODUTO IS NULL))
                AND P.IDCOBTXSERV = 'N'
            GROUP BY I.NRLUGARMESA
        ) A
        GROUP BY A.NRLUGARMESA
    ";

  const SQL_PRODUTOS_PARCIAL_CDPRODCOUVER = "
        SELECT I.NRLUGARMESA, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, SUM(I.QTPRODCOMVEN) AS QTPRODCOMVEN,
               (I.VRPRECCOMVEN + I.VRPRECCLCOMVEN - I.VRDESCCOMVEN + I.VRACRCOMVEN) AS VRPRECCOMVEN,
               SUM((I.VRPRECCOMVEN + I.VRPRECCLCOMVEN) * I.QTPRODCOMVEN + I.VRACRCOMVEN - I.VRDESCCOMVEN) AS PRECO
          FROM ITCOMANDAVEN I, PRODUTO P
         WHERE I.CDPRODUTO   = P.CDPRODUTO
           AND I.CDFILIAL    = :CDFILIAL
           AND I.NRVENDAREST = :NRVENDAREST
           AND I.NRCOMANDA   = :NRCOMANDA
           AND I.IDSTPRCOMVEN <> '6'
           AND I.IDSTPRCOMVEN <> '7'
           AND I.CDPRODUTO   = :CDPRODUTO
      GROUP BY I.NRLUGARMESA, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
               (I.VRPRECCOMVEN + I.VRPRECCLCOMVEN - I.VRDESCCOMVEN + I.VRACRCOMVEN)
      ORDER BY I.NRLUGARMESA, P.CDARVPROD
    ";

  const GET_CONSUMER_DETAILS = "
        SELECT CO.VRMAXCREDCONS, CO.VRAVICREDCONS, CO.VRLIMCREDCONS
          FROM CONSUMIDOR CO
         WHERE CO.CDCLIENTE    = :CDCLIENTE
           AND CO.CDCONSUMIDOR = :CDCONSUMIDOR
    ";

  const GET_WAITERS = '
        SELECT CDVENDEDOR AS "codigo", NMFANVEN AS "nome"
          FROM VENDEDOR V
          JOIN OPERADOR O
            ON O.CDOPERADOR = V.CDOPERADOR
    ';

  const GET_ORDER = '
            SELECT PR.NMPRODUTO AS "nome", IT.CDPRODUTO AS "codigo", IT.VRPRECCOMVEN AS "preco", SUM(IT.QTPRODCOMVEN) AS "quantidade", 
                   SUM(IT.VRDESCCOMVEN) AS "desconto", SUM(IT.VRACRCOMVEN) AS "acrescimo", 
                   SUM(IT.VRPRECCOMVEN * IT.QTPRODCOMVEN) - SUM(IT.VRDESCCOMVEN) + SUM(IT.VRACRCOMVEN) AS "total", 
                   CONVERT(VARCHAR(12), IT.DTHRINCOMVEN, 103)+\' \'+CONVERT(VARCHAR(12), IT.DTHRINCOMVEN, 108) AS "data"
              FROM ITCOMANDAVEN IT
              JOIN PRODUTO PR
                ON PR.CDPRODUTO = IT.CDPRODUTO
              JOIN VENDAREST VE
                ON VE.NRVENDAREST = IT.NRVENDAREST
               AND VE.CDFILIAL = IT.CDFILIAL
             WHERE (NRCOMANDA = :NRCOMANDA OR ISNULL(:NRCOMANDA, \'T\') = \'T\')
              AND VE.NRMESA = :NRMESA
         GROUP BY PR.NMPRODUTO, IT.CDPRODUTO, IT.VRPRECCOMVEN, CONVERT(VARCHAR(12), IT.DTHRINCOMVEN, 103)+\' \'+CONVERT(VARCHAR(12), IT.DTHRINCOMVEN, 108)
         ORDER BY data DESC
    ';

  const GET_VENDOR_INFO = "
      SELECT V.CDVENDEDOR, L.CDLOJA, V.NMFANVEN, C.CDCAIXA, V.CDOPERADOR,
            L.NRMESAPADRAO AS NRMESA, L.IDPOSOBSPED, L.IDLUGARMESA
        FROM VENDEDOR V
  LEFT JOIN CAIXA C
          ON C.CDCAIXA = V.CDCAIXA
  LEFT JOIN LOJA L
          ON L.CDLOJA = C.CDLOJA
      WHERE V.CDVENDEDOR = :CDVENDEDOR
        AND V.CDOPERADOR IS NOT NULL
    ";

  const GET_COMANDAVEN_DATA = "
        SELECT CV.NRCOMANDA, CV.NRVENDAREST, CV.IDSTCOMANDA, VR.DTHRABERMESA
          FROM COMANDAVEN CV
          JOIN VENDAREST VR
            ON CV.NRVENDAREST = VR.NRVENDAREST
           AND CV.CDFILIAL    = VR.CDFILIAL
         WHERE CV.NRCOMANDA   = :NRCOMANDA
           AND CV.CDFILIAL    = :CDFILIAL
    ";

  const GET_ORDER_DATA_SQL = "               
        SELECT CV.VRACRCOMANDA, CV.CDFILIAL, CV.NRVENDAREST, VE.CDOPERADOR, NRMESA, NRPESMESAVEN, DSCOMANDA, VE.CDVENDEDOR, CDCAIXACOLETOR AS CDCAIXA,
               CO.NMCONSUMIDOR, ISNULL(CO.CDCLIENTE, VE.CDCLIENTE) CDCLIENTE, CO.CDCONSUMIDOR, IT.NRINSCRCONS, CDSENHAPED, IDORGCMDVENDA, VE.CDLOJA,
                CV.IDSTCOMANDA, CV.VRDESCFID, CV.NRCOMANDA, DTHRABERMESA, CV.IDFECHAMENTOAPI, CV.CDLOJA, CV.VRCOMISVENDE, CV.DSCOMANDAPRI, CV.NRORG,
                CO.CDIDCONSUMID, CO.NMCONSUMIDOR, V.NMFANVEN, V.CDVENDEDOR
          FROM COMANDAVEN CV
          JOIN VENDAREST VE
            ON VE.CDFILIAL = CV.CDFILIAL
           AND VE.NRVENDAREST = CV.NRVENDAREST
     LEFT JOIN CONSUMIDOR CO
            ON CO.CDCLIENTE = VE.CDCLIENTE
           AND CO.CDCONSUMIDOR = VE.CDCONSUMIDOR
          JOIN ITCOMANDAVEN IT
            ON IT.CDFILIAL = CV.CDFILIAL
           AND IT.NRCOMANDA = CV.NRCOMANDA
           AND IT.NRVENDAREST = CV.NRVENDAREST
      LEFT JOIN VENDEDOR V
           ON VE.CDOPERADOR = V.CDOPERADOR
           AND VE.CDVENDEDOR = V.CDVENDEDOR
         WHERE CV.NRCOMANDA = :NRCOMANDA
           AND CV.CDFILIAL = :CDFILIAL
      GROUP BY CV.VRACRCOMANDA, CV.CDFILIAL, CV.NRVENDAREST, VE.CDOPERADOR, NRMESA, NRPESMESAVEN, DSCOMANDA, VE.CDVENDEDOR, CDCAIXACOLETOR,
               CO.NMCONSUMIDOR, ISNULL(CO.CDCLIENTE, VE.CDCLIENTE), CO.CDCONSUMIDOR, IT.NRINSCRCONS, CDSENHAPED, IDORGCMDVENDA, VE.CDLOJA,
                CV.IDSTCOMANDA, CV.VRDESCFID, CV.NRCOMANDA, DTHRABERMESA, CV.IDFECHAMENTOAPI, CV.CDLOJA, CV.VRCOMISVENDE, CV.DSCOMANDAPRI, CV.NRORG,
                CO.CDIDCONSUMID, CO.NMCONSUMIDOR, V.NMFANVEN, V.CDVENDEDOR
    ";

  const GET_ORDER_DATA_ORACLE = "               
        SELECT CV.VRACRCOMANDA, CV.CDFILIAL, CV.NRVENDAREST, VE.CDOPERADOR, NRMESA, NRPESMESAVEN, DSCOMANDA, VE.CDVENDEDOR, CDCAIXACOLETOR AS CDCAIXA,
               CO.NMCONSUMIDOR, NVL(CO.CDCLIENTE, VE.CDCLIENTE) CDCLIENTE, CO.CDCONSUMIDOR, IT.NRINSCRCONS, CDSENHAPED, IDORGCMDVENDA, VE.CDLOJA, 
               CV.IDSTCOMANDA, CV.VRDESCFID, CV.NRCOMANDA, DTHRABERMESA, CV.IDFECHAMENTOAPI, CV.CDLOJA, CV.VRCOMISVENDE, CV.DSCOMANDAPRI, CV.NRORG,
               CO.CDIDCONSUMID, CO.NMCONSUMIDOR
          FROM COMANDAVEN CV
          JOIN VENDAREST VE
            ON VE.CDFILIAL = CV.CDFILIAL
           AND VE.NRVENDAREST = CV.NRVENDAREST
     LEFT JOIN CONSUMIDOR CO
            ON CO.CDCLIENTE = VE.CDCLIENTE
           AND CO.CDCONSUMIDOR = VE.CDCONSUMIDOR
          JOIN ITCOMANDAVEN IT
            ON IT.CDFILIAL = CV.CDFILIAL
           AND IT.NRCOMANDA = CV.NRCOMANDA
           AND IT.NRVENDAREST = CV.NRVENDAREST
         WHERE CV.NRCOMANDA = :NRCOMANDA
           AND CV.CDFILIAL = :CDFILIAL
      GROUP BY CV.VRACRCOMANDA, CV.CDFILIAL, CV.NRVENDAREST, VE.CDOPERADOR, NRMESA, NRPESMESAVEN, DSCOMANDA, VE.CDVENDEDOR, CDCAIXACOLETOR,
               CO.NMCONSUMIDOR, NVL(CO.CDCLIENTE, VE.CDCLIENTE), CO.CDCONSUMIDOR, IT.NRINSCRCONS, CDSENHAPED, IDORGCMDVENDA, VE.CDLOJA,
                CV.IDSTCOMANDA, CV.VRDESCFID, CV.NRCOMANDA, DTHRABERMESA, CV.IDFECHAMENTOAPI, CV.CDLOJA, CV.VRCOMISVENDE, CV.DSCOMANDAPRI, CV.NRORG,
                CO.CDIDCONSUMID, CO.NMCONSUMIDOR
    ";

  const GET_ORDER_PAYMENTS = "
        SELECT IDTIPOMOVIVEDLV, M.CDTIPORECE, VRMOVIVENDDLV AS VRMOVIVEND, null AS NRCARTBANCO, M.CDCLIENTE, CDCONSUMIDOR, CDNSUTEFDLV AS CDNSUHOSTTEF, TP.NMTIPORECE, NRAUTORIZATEFDLV AS NRAUTORIZATEF
          FROM MOVCAIXADLV M
          JOIN TIPORECE TP
          ON TP.CDTIPORECE = M.CDTIPORECE
         WHERE CDFILIAL = :CDFILIAL
           AND NRVENDAREST = :NRVENDAREST
    ";

  const GET_CDCAIXA_ITCOMANDAVEN = "
    SELECT CX.IDCOLETOR, CDCAIXACOLETOR, CX.NRORG
    FROM ITCOMANDAVEN IT
    JOIN CAIXA CX
      ON CX.CDCAIXA = IT.CDCAIXACOLETOR
   WHERE IT.CDFILIAL    = :CDFILIAL
     AND IT.NRVENDAREST = :NRVENDAREST
     AND IT.NRCOMANDA   = :NRCOMANDA
GROUP BY IDCOLETOR, CDCAIXACOLETOR, CX.NRORG
    ";

  const GET_CONFTELA = "
        SELECT NRCONFTELA 
          FROM CAIXA 
         WHERE CDCAIXA = :CDCAIXA
           AND CDFILIAL = :CDFILIAL
    ";

  const ORACLE_GET_RECEBIMENTOS_FECHAMENTO = "
        SELECT M.CDTIPORECE, T.NMTIPORECE, SUM(M.VRMOVIVEND) AS VRMOVIVEND,
               SUM(M.VRMOVIVEND) AS LABELVRMOVIVEND, T.IDSANGRIAAUTO
          FROM MOVCAIXA M
          JOIN TIPORECE T ON T.CDTIPORECE = M.CDTIPORECE
         WHERE M.CDFILIAL   = :CDFILIAL
           AND M.CDCAIXA    = :CDCAIXA
           AND M.IDTIPOMOVIVE IN ('E','T','U')
           AND M.DTABERCAIX = TO_DATE(:DTABERCAIX, 'DD/MM/YYYY HH24:MI:SS')
         GROUP BY M.CDTIPORECE, T.NMTIPORECE, T.IDSANGRIAAUTO

    ";

  const SQL_GET_RECEBIMENTOS_FECHAMENTO = "
        SELECT M.CDTIPORECE, T.NMTIPORECE, SUM(M.VRMOVIVEND) AS VRMOVIVEND,
               SUM(M.VRMOVIVEND) AS LABELVRMOVIVEND, T.IDSANGRIAAUTO
          FROM MOVCAIXA M
          JOIN TIPORECE T ON T.CDTIPORECE = M.CDTIPORECE
         WHERE M.CDFILIAL   = :CDFILIAL
           AND M.CDCAIXA    = :CDCAIXA
           AND M.IDTIPOMOVIVE IN ('E','T','U')
           AND M.DTABERCAIX = :DTABERCAIX
         GROUP BY M.CDTIPORECE, T.NMTIPORECE, T.IDSANGRIAAUTO

    ";

  const GET_LUGARMESA = "
        SELECT NRLUGARMESA
          FROM ITCOMANDAVEN
         WHERE CDFILIAL = :CDFILIAL
           AND NRCOMANDA = :NRCOMANDA
           AND NRVENDAREST = :NRVENDAREST
      GROUP BY NRLUGARMESA
    ";

  const GET_CAIXA_RECEBEDOR = "
        SELECT CX.CDCAIXA 
          FROM CAIXA CX
          JOIN TURCAIXA TC
            ON TC.CDCAIXA = CX.CDCAIXA
         WHERE IDCOLETOR <> 'C'
           AND IDTPEMISSAOFOS = 'SAT'
           AND DTABERCAIX IS NOT NULL 
           AND DTFECHCAIX IS NULL 
           AND DTMOVTURCAIX = CONVERT(DATE, GETDATE(), 120)
    ";

  const GET_CAIXA_RECEBEDOR_ORACLE = "
        SELECT CX.CDCAIXA 
          FROM CAIXA CX
          JOIN TURCAIXA TC
            ON TC.CDCAIXA = CX.CDCAIXA
         WHERE IDCOLETOR <> 'C'
           AND IDTPEMISSAOFOS = 'SAT'
           AND DTABERCAIX IS NOT NULL 
           AND DTFECHCAIX IS NULL 
           AND TO_CHAR(DTMOVTURCAIX, 'DD/MM/YY') = TO_CHAR(SYSDATE, 'DD/MM/YY')
    ";

  const GET_CAIXA_INFO = "
        SELECT IDHABCAIXAVENDA, IDSINCCAIXADLV, NRORG
          FROM CAIXA
         WHERE CDFILIAL = :CDFILIAL
           AND CDCAIXA = :CDCAIXA
    ";

  const GET_ITEMS_VALUE = "        
        SELECT SUM((VRPRECCOMVEN * QTPRODCOMVEN) + VRACRCOMVEN - VRDESCCOMVEN) TOTAL
          FROM ITCOMANDAVEN 
         WHERE NRVENDAREST = :NRVENDAREST
           AND NRCOMANDA = :NRCOMANDA
           AND CDFILIAL = :CDFILIAL
    ";

  const GET_SALE_XML = "
        SELECT DSARQXMLNFCE 
          FROM VENDA 
         WHERE CDFILIAL = :CDFILIAL
           AND CDCAIXA = :CDCAIXA
           AND NRCOMANDAVND = :NRCOMANDA
    ";

  const GET_SALE_STATUS = "
      SELECT IDSITUVENDA, CDOPERADOR, IDSTATUSNFCE, CDSUPERVISOR, VRTOTVENDA, DTVENDA, NRSEQVENDA
        FROM VENDA 
      WHERE CDFILIAL = :CDFILIAL
        AND CDCAIXA = :CDCAIXA
        AND NRSEQVENDA = :NRSEQVENDA
    ";

  const GET_ORDER_ITEMS = "
      SELECT (VRPRECCOMVEN * QTPRODCOMVEN) + VRACRCOMVEN - VRDESCCOMVEN TOTAL, VRDESCCOMVEN, VRPRECCLCOMVEN,
             VRPRECCOMVEN, QTPRODCOMVEN, NRPRODCOMVEN, PR.CDPRODUTO, PR.NMPRODUTO, PR.IDCOBTXSERV, 
        TXPRODCOMVEN, IDSTPRCOMVEN, NRLUGARMESA, IDPRODIMPFIS, IT.CDLOJA, VRACRCOMVEN, 
        NRSEQPRODCOM, NRSEQPRODCUP, VRPRECCLCOMVEN, CDCAIXACOLETOR, CDPRODPROMOCAO, CDVENDEDOR, 
        NRINSCRCONS, CDSENHAPED, NRATRAPRODCOVE, IDORIGEMVENDA, DSOBSPEDDIGCMD, IDIMPPRGRPROMO,
        DTHRINCOMVEN, PR.SGUNIDADE, C.VRCOMISVENDE, PR.IDCOBTXSERV,
        ROUND((IT.VRPRECCOMVEN + IT.VRPRECCLCOMVEN) * IT.QTPRODCOMVEN, 2, 1) + IT.VRACRCOMVEN - IT.VRDESCCOMVEN AS PRECO,
         PR.IDTIPOCOMPPROD, PR.IDIMPPRODUTO, FPR.CDFAMILISALD
        FROM ITCOMANDAVEN IT
        JOIN PRODUTO PR
                ON PR.CDPRODUTO = IT.CDPRODUTO 
        JOIN COMANDAVEN C
          ON C.CDFILIAL = IT.CDFILIAL
           AND C.NRCOMANDA = IT.NRCOMANDA
           AND C.NRVENDAREST = IT.NRVENDAREST
        LEFT JOIN FAMSALDOPROD FPR
          ON PR.CDPRODUTO = FPR.CDPRODUTO
          AND C.CDFILIAL = FPR.CDFILIAL
       WHERE IT.NRVENDAREST = :NRVENDAREST
         AND IT.NRCOMANDA = :NRCOMANDA
         AND IT.CDFILIAL = :CDFILIAL
         ORDER BY NRPRODCOMVEN ASC
    ";

  const SAVE_CASHBACK = "
      UPDATE COMANDAVEN 
         SET VRDESCFID = :VRDESCFID
       WHERE CDFILIAL = :CDFILIAL
         AND NRCOMANDA = :NRCOMANDA
         AND NRVENDAREST = :NRVENDAREST
    ";

    const SAVE_CASHBACK_UDS = "
      UPDATE COMANDAVEN 
         SET VRDESCCASHUDS = :VRDESCCASHUDS 
       WHERE CDFILIAL = :CDFILIAL
         AND NRCOMANDA = :NRCOMANDA
         AND NRVENDAREST = :NRVENDAREST
    ";

  const UPDATE_ITEM_DISCOUNT = "
      UPDATE ITCOMANDAVEN 
        SET VRDESCCOMVEN = :VRDESCCOMVEN 
       WHERE CDFILIAL = :CDFILIAL
        AND NRCOMANDA = :NRCOMANDA
        AND NRVENDAREST = :NRVENDAREST 
        AND CDPRODUTO = :CDPRODUTO 
        AND NRPRODCOMVEN = :NRPRODCOMVEN
    ";

  const GET_ORDER_CASHBACK = "
      SELECT VRDESCFID 
       FROM COMANDAVEN 
      WHERE CDFILIAL = :CDFILIAL 
        AND NRCOMANDA = :NRCOMANDA 
        AND NRVENDAREST = :NRVENDAREST
    ";

  const UPDATE_CONSUMER_VENDAREST = "
      UPDATE VENDAREST 
         SET CDCLIENTE = :CDCLIENTE,
             CDCONSUMIDOR = :CDCONSUMIDOR
       WHERE NRVENDAREST = :NRVENDAREST
         AND CDFILIAL = :CDFILIAL
    ";

  const GET_QUANT_ITENS = "
      SELECT COUNT(*) QUANT
        FROM ITCOMANDAVEN
       WHERE CDFILIAL = :CDFILIAL
         AND NRCOMANDA = :NRCOMANDA
         AND NRVENDAREST = :NRVENDAREST
    ";

  const GET_STORE_NAME = "
      SELECT NMCAIXA, NMLOJA, NMFILIAL, IDEXTCONSONLINE
        FROM CAIXA CX
        JOIN LOJA LJ
          ON LJ.CDLOJA = CX.CDLOJA
        JOIN FILIAL FL
          ON FL.CDFILIAL = CX.CDFILIAL
        JOIN PARAVEND PV
          ON PV.CDFILIAL = FL.CDFILIAL
       WHERE CX.CDFILIAL = :CDFILIAL
         AND CX.CDCAIXA = :CDCAIXA
         AND CX.CDLOJA = :CDLOJA
    
    ";

  const GET_ORDERS_TOTAL = "
      SELECT SUM((VRPRECCOMVEN * QTPRODCOMVEN) + VRACRCOMVEN - VRDESCCOMVEN) TOTAL
        FROM ITCOMANDAVEN 
       WHERE NRCOMANDA IN (:NRCOMANDA)
         AND CDFILIAL = :CDFILIAL
    ";

  const GET_ORDER_DISCOUNT = "
      SELECT SUM(VRDESCCOMVEN) DISCOUNT
        FROM ITCOMANDAVEN 
       WHERE NRCOMANDA = :NRCOMANDA
         AND CDFILIAL = :CDFILIAL
    ";

  const GET_WAITING_TIME = "
    SELECT CASE
    WHEN PROD.VRTMPMEDPROD > LJ.VRTMPESPLJ THEN PROD.VRTMPMEDPROD
      ELSE LJ.VRTMPESPLJ
    END AS VRTMPMEDPROD,
     LJ.CDLOJA
        FROM
          (SELECT SUM(KSE.NRTEMPOTOTAL) / COUNT(KSE.NRPEDIDOFOS) / 60 AS VRTMPMEDPROD ,
                  SL.CDLOJA,
                  SL.CDFILIAL
           FROM KDS_TEMP_SETOREST KSE
           JOIN SETORLOJA SL ON (SL.CDSETOR = KSE.CDSETOR)
           JOIN SETOR SE ON (SE.CDSETOR = SL.CDSETOR
                             AND SE.IDTIPOSETOR = 'E')
           JOIN FILIAL FL ON (FL.CDFILIAL = KSE.CDFILIAL)
           WHERE GETDATE() >= DATEADD(MINUTE, FL.NRTEMPOESTMIN * -1, GETDATE())
             AND KSE.CDFILIAL = :CDFILIAL
             AND SL.CDLOJA = :CDLOJA
           GROUP BY SL.CDFILIAL,
                    SL.CDLOJA) AS PROD
        RIGHT JOIN LOJA LJ ON (LJ.CDFILIAL = PROD.CDFILIAL
                               AND LJ.CDLOJA = PROD.CDLOJA)
        
        WHERE LJ.CDFILIAL = :CDFILIAL
    AND LJ.CDLOJA = :CDLOJA
    ";

  const GET_SALE_DETAILS_SQL = "
    SELECT DSARQXMLNFCE, NRSEQVENDA, CDCAIXA, IDSTATUSNFCE, NRACESSONFCE, CONVERT(VARCHAR(10), DTENTRVENDA, 103) AS DTENTRVENDA, NRACESSONFCE, DSQRCODENFCE, NRNOTAFISCALCE 
      FROM VENDA
     WHERE CDFILIAL = :CDFILIAL 
       AND NRVENDAREST = :NRVENDAREST
       AND NRCOMANDAVND = :NRCOMANDA
  ";

  const GET_SALE_DETAILS_ORACLE = "
    SELECT DSARQXMLNFCE, NRSEQVENDA, CDCAIXA, IDSTATUSNFCE, NRACESSONFCE,  TO_CHAR(DTENTRVENDA, 'DD/MM/YYYY HH24:MI:SS') AS DTENTRVENDA, NRACESSONFCE, DSQRCODENFCE, NRNOTAFISCALCE
      FROM VENDA
     WHERE CDFILIAL = :CDFILIAL 
       AND NRVENDAREST = :NRVENDAREST
       AND NRCOMANDAVND = :NRCOMANDA
  ";

  const GET_IDAMBTRABNFCE = "
      SELECT IDAMBTRABNFCE 
        FROM PARAVEND 
       WHERE CDFILIAL = :CDFILIAL
    ";

  const GET_ORDER_DSCOMANDA = "
      SELECT NRCOMANDA, NRVENDAREST
        FROM COMANDAVEN
       WHERE CDFILIAL = :CDFILIAL
         AND DSCOMANDA = :DSCOMANDA
    ";

  const GET_PERSONAL_PAYMENTS = "
      SELECT SUM(MV.VRMOVIVENDDLV) VRMOVIVENDDLV
        FROM MOVCAIXADLV MV
        JOIN VENDAREST VE
          ON VE.CDFILIAL = MV.CDFILIAL
         AND VE.NRVENDAREST = MV.NRVENDAREST
        JOIN COMANDAVEN CV
          ON CV.CDFILIAL = MV.CDFILIAL
         AND CV.NRVENDAREST = MV.NRVENDAREST
        JOIN TIPORECE TP
          ON TP.CDTIPORECE = MV.CDTIPORECE
       WHERE VE.CDCLIENTE = :CDCLIENTE
         AND VE.CDCONSUMIDOR = :CDCONSUMIDOR
         AND CV.IDSTCOMANDA NOT IN('4','X')
         AND TP.IDTIPORECE = '9'
         AND CONVERT(VARCHAR(10), VE.DTHRABERMESA, 103) = CONVERT(VARCHAR(10), GETDATE(), 103)
    ";

  const GET_ORDER_TAA_ID = "
      SELECT CV.NRCOMANDA, VE.DTHRABERMESA, CV.NRCOMANDA, CV.NRCOMANDAEXT
        FROM COMANDAVEN CV
        JOIN VENDAREST VE
          ON VE.CDFILIAL = CV.CDFILIAL
         AND VE.NRVENDAREST = CV.NRVENDAREST
       WHERE NRCOMANDAEXT = :NRCOMANDAEXT
    ";

  const DELETE_MOVCAIXADLV = "
        DELETE FROM MOVCAIXADLV
         WHERE CDFILIAL = :CDFILIAL
           AND NRVENDAREST = :NRVENDAREST
    ";

  const GET_SALE_DATE = "
        SELECT CONVERT(VARCHAR(10), DTENTRVENDA, 103) AS DTENTRVENDA 
          FROM VENDA 
         WHERE CDFILIAL = :CDFILIAL
           AND CDCAIXA = :CDCAIXA
           AND NRCOMANDAVND = :NRCOMANDA
    ";

  const GET_STORE_WAITING_TIME = "
      SELECT VRTMPESPLJ 
        FROM LOJA
      WHERE CDFILIAL = :CDFILIAL
       AND CDLOJA = :CDLOJA
    ";

  const CHECK_FOR_CONFTELA = "	
    SELECT TABLE_NAME	
      FROM INFORMATION_SCHEMA.TABLES	
     WHERE TABLE_NAME = 'CONFTELACAIXA'	
  ";

    const GET_CONFTELA_CAIXA = "	
      SELECT CDFILIAL, NRCONFTELA, MAX(DTINIVIGENCIA) AS DTINIVIGENCIA	
        FROM CONFTELACAIXA	
      WHERE CDFILIAL = :CDFILIAL
        OR  CDFILICAIXA = :CDFILIAL
        AND CDCAIXA = :CDCAIXA	
      GROUP BY CDFILIAL, NRCONFTELA	
    ";


    const GET_CONFTELA_CAIXA_EX = "	
    SELECT CDFILIAL, NRCONFTELA
      FROM CONFTELACAIXA	
     WHERE CDFILICAIXA = :CDFILICAIXA
       AND CDCAIXA = :CDCAIXA
       AND DTINIVIGENCIA IN (SELECT MAX(DTINIVIGENCIA) AS DTINIVIGENCIA FROM CONFTELACAIXA
						                  WHERE CDFILICAIXA = :CDFILICAIXA
							                  AND CDCAIXA = :CDCAIXA
								                AND GETDATE() >= DTINIVIGENCIA)
     GROUP BY CDFILIAL, NRCONFTELA
  ";

  const GET_POS_OPERATOR = "
    SELECT TC.CDOPERADOR, NMOPERADOR
      FROM TURCAIXA TC
        JOIN OPERADOR O
          ON TC.CDOPERADOR = O.CDOPERADOR
      WHERE CDFILIAL = :CDFILIAL
      AND CDCAIXA = :CDCAIXA
      AND DTMOVTURCAIX = CONVERT(DATE, GETDATE(), 120)
  ";

  const INSERT_LOG = "
    INSERT INTO LOGOPERFOS(CDFILIAL, CDCAIXA, IDOPERFOS, CDOPERCAIXA, NMOPERCAIXA, CDOPERRESPOP, 
    NMOPERRESPOP, DTHROPERFOS, IDIMPLOGOPERFOS, NRORG, DSLIVREFOS) 
    VALUES(:CDFILIAL, :CDCAIXA, :IDOPERFOS, :CDOPERCAIXA, :NMOPERCAIXA, :CDOPERRESPOP, 
    :NMOPERRESPOP, SYSDATE, 'N', '1', :DSLIVREFOS)
  ";

  const SQL_INSERT_LOG = "
    INSERT INTO LOGOPERFOS(CDFILIAL, CDCAIXA, IDOPERFOS, CDOPERCAIXA, NMOPERCAIXA, CDOPERRESPOP, 
    NMOPERRESPOP, DTHROPERFOS, IDIMPLOGOPERFOS, NRORG, DSLIVREFOS) 
    VALUES(:CDFILIAL, :CDCAIXA, :IDOPERFOS, :CDOPERCAIXA, :NMOPERCAIXA, :CDOPERRESPOP, 
    :NMOPERRESPOP, SYSDATETIME(), 'N', '1', :DSLIVREFOS)
  ";

  const GET_SALE_ORDER_ID = "
  SELECT NRSEQVENDA, IDSITUVENDA, CDOPERADOR, IDSTATUSNFCE, CDSUPERVISOR, VRTOTVENDA, DTVENDA
    FROM VENDA 
  WHERE CDFILIAL = :CDFILIAL
    AND CDCAIXA = :CDCAIXA
    AND NRCOMANDAVND = :NRCOMANDAVND
  ";

  const CANCEL_COMANDAVEN = "
    UPDATE COMANDAVEN
       SET IDSTCOMANDA  = :IDSTCOMANDA
     WHERE CDFILIAL     = :CDFILIAL
       AND NRVENDAREST  = :NRVENDAREST
       AND NRCOMANDA    = :NRCOMANDA
  ";

  const UPDATE_ORDER_CLOSING_TYPE = "
      UPDATE COMANDAVEN
       SET IDFECHAMENTOAPI = 'N' 
      WHERE CDFILIAL = :CDFILIAL
      AND NRCOMANDA = :NRCOMANDA
      AND NRVENDAREST = :NRVENDAREST
  ";

  const GET_AVAILABLE_PRODUCTS = "
      SELECT DISTINCT PD.CDBARPRODUTO, PD.CDPRODUTO, IT.DSBUTTON, ISNULL(PD.DSPRODVENDA, '') AS DESCRIPTION, ISNULL(IT.DSENDEIMG, PD.DSENDEIMG) DSENDEIMG, PD.IDIMPPRODUTO, PD.IDTIPOPROD, PD.IDIMPPRODUTO, PD.IDTIPOCOMPPROD, GPP.CDPRODPROMOCAO, IT.NRBUTTONAUX, IT.NRPGCONFTAUX
        FROM ITMENUCONFTE IT
        JOIN PRODUTO PD
          ON IT.CDIDENTBUTON = PD.CDPRODUTO
        LEFT JOIN GRUPROMOCPROD GPP
          ON GPP.CDPRODPROMOCAO = PD.CDPRODUTO
       WHERE IT.IDTPBUTTON = '1'
         AND (IT.DSENDEIMG IS NOT NULL OR PD.DSENDEIMG IS NOT NULL)
  ";

  const SQL_GET_AVAILABLE_POS_FROM_SUBSIDIARY = "
      SELECT CDFILIAL, CDLOJA, CDCAIXA 
        FROM CAIXA
    ORDER BY CDFILIAL, CDLOJA, CDCAIXA
  ";

  const GET_PROMOTIONAL_GROUPS_MENU = "
      SELECT GP.CDGRUPROMOC, GP.NMGRUPROMOC, PP.CDPRODPROMOCAO, (PP.QTPRGRUPPROMOC) AS QUANTIDADE,
          ISNULL(PP.NRORDPROMOGRUP,1000) AS NRORDPROMOGRUP, PP.CDGRUPMUTEX AS CDGRUPMUTEX,
          (PP.QTPRGRUPROMIN) AS QUANTMIN, PP.IDAPLICADESC AS IDAPLICADESC, PP.IDIMPGRPROMO,
          PP.NRSEQGRPROMO
        FROM GRUPROMOCPROD PP, GRUPROMOC GP
      WHERE CDPRODPROMOCAO = :CDPRODPROMOCAO
        AND PP.CDGRUPROMOC = GP.CDGRUPROMOC
        AND ((CONVERT(VARCHAR, GETDATE(), 103) BETWEEN PP.DTINIVGGRPROMO AND PP.DTFINVGGRPROMO) OR (PP.DTINIVGGRPROMO IS NULL AND PP.DTFINVGGRPROMO IS NULL))
        AND EXISTS (
            SELECT PG.CDGRUPROMOC
            FROM PRODGRUPROMOC PG
            INNER JOIN PRODUTO PD ON PD.CDPRODUTO=PG.CDPRODUTO
            WHERE PG.CDGRUPROMOC =  GP.CDGRUPROMOC
            GROUP BY PG.CDGRUPROMOC
        )
      ORDER BY ISNULL(PP.NRORDPROMOGRUP,1000), GP.CDGRUPROMOC
  ";

  const GET_PROMOTIONAL_GROUPS_MENU_LOCAL = "
      SELECT GP.CDGRUPROMOC, GP.NMGRUPROMOC, PF.CDPRODPROMOCAO, (PF.QTPRGRUPPROMFIL) AS QUANTIDADE,
      ISNULL(PF.NRORDPROMOGRUPFIL,1000) AS NRORDPROMOGRUPFIL, PF.CDGRUPMUTEXFIL AS CDGRUPMUTEX,
      (PF.QTPRGRUPROMINFIL) AS QUANTMIN, PF.IDAPLICADESCFIL AS IDAPLICADESC, PF.IDIMPGRPROMOFIL AS IDIMPGRPROMO,
      PF.NRSEQGRPROMOFIL AS NRSEQGRPROMO
    FROM GRUPROMOCPRFIL PF, GRUPROMOC GP
    WHERE PF.CDFILIAL = :CDFILIAL
    AND PF.CDPRODPROMOCAO = :CDPRODPROMOCAO
    AND PF.CDGRUPROMOC = GP.CDGRUPROMOC
    AND EXISTS (
    SELECT PG.CDGRUPROMOC
    FROM PRODGRUPROMOC PG
    INNER JOIN PRODUTO PD ON PD.CDPRODUTO=PG.CDPRODUTO
    WHERE PG.CDGRUPROMOC =  GP.CDGRUPROMOC
    GROUP BY PG.CDGRUPROMOC
    )
    ORDER BY ISNULL(PF.NRORDPROMOGRUPFIL,1000), GP.CDGRUPROMOC
  ";

  const GET_PROMOTIONAL_GROUPS_MENU_NO_FILTER = "
  SELECT CDPRODPROMOCAO, GP.CDGRUPROMOC, GP.NMGRUPROMOC, PP.CDPRODPROMOCAO, (PP.QTPRGRUPPROMOC) AS QUANTIDADE,
      ISNULL(PP.NRORDPROMOGRUP,1000) AS NRORDPROMOGRUP, PP.CDGRUPMUTEX AS CDGRUPMUTEX,
      (PP.QTPRGRUPROMIN) AS QUANTMIN, PP.IDAPLICADESC AS IDAPLICADESC, PP.IDIMPGRPROMO,
      PP.NRSEQGRPROMO
    FROM GRUPROMOCPROD PP, GRUPROMOC GP
  WHERE 
  
        PP.CDGRUPROMOC = GP.CDGRUPROMOC
    AND ((CONVERT(VARCHAR, GETDATE(), 103) BETWEEN PP.DTINIVGGRPROMO AND PP.DTFINVGGRPROMO) OR (PP.DTINIVGGRPROMO IS NULL AND PP.DTFINVGGRPROMO IS NULL))
    AND EXISTS (
        SELECT PG.CDGRUPROMOC
        FROM PRODGRUPROMOC PG
        INNER JOIN PRODUTO PD ON PD.CDPRODUTO=PG.CDPRODUTO
        WHERE PG.CDGRUPROMOC =  GP.CDGRUPROMOC
        GROUP BY PG.CDGRUPROMOC
    )
  ORDER BY ISNULL(PP.NRORDPROMOGRUP,1000), GP.CDGRUPROMOC
";

  const GET_PRODUCTS_PROM_GROUPS_MENU = "
  SELECT
  DISTINCT(PD.CDPRODUTO), ISNULL(PD.NMPRODIMPFIS,PD.NMPRODUTO) NMPRODUTO,
  PD.CDARVPROD, PG.CDGRUPROMOC, PD.IDPESAPROD,PD.SGUNIDADE, PD.QTTARAPROD,
  FA.CDFAMILISALD, ISNULL(DP.NRORDPROMOPR,1000) NRORDPROMOPR,
  DP.IDOBRPRODSELEC IDOBRPRODSELEC, IT.CDATAPRODITM, PD.CDBARPRODUTO, PD.IDIMPPRODUTO, 
  DP.IDOBRPRODSELEC AS OBRGRUPR, PD.IDTIPOCOMPPROD, DP.IDPERVALORDES AS IDPERCVALOR, DP.VRDESPRODPROMOC AS VRDESCONTO, DP.IDAPLICADESCPR AS IDAPLICADESCONTO, DP.IDDESCACRPROMO AS IDDESCACR
FROM PRODUTO PD
LEFT JOIN FAMSALDOPROD FA ON PD.CDPRODUTO = FA.CDPRODUTO AND :CDFILIAL = FA.CDFILIAL
  LEFT JOIN ITMENUCONFTE IT ON IT.CDIDENTBUTON = PD.CDPRODUTO AND IT.CDFILIAL = :CDFILIAL
    AND IT.IDTPBUTTON = '1' AND IT.NRCONFTELA = :NRCONFTELA,
PRODGRUPROMOC PG
LEFT JOIN DESGRUPROMOCPR DP 
 ON DP.CDGRUPROMOC = PG.CDGRUPROMOC
  AND DP.CDPRODUTO = PG.CDPRODUTO
  AND DP.CDPRODPROMOCAO = :CDPRODPROMOCAO
  AND DP.NRSEQGRPROMO = :NRSEQGRPROMO
WHERE PG.CDPRODUTO = PD.CDPRODUTO
AND PG.CDGRUPROMOC = :CDGRUPROMOC
ORDER BY ISNULL(DP.NRORDPROMOPR,1000), PD.CDARVPROD
  ";

  const GET_PRODUCTS_PROM_GROUPS_MENU_FILI = "
      SELECT
          DISTINCT(PD.CDPRODUTO), ISNULL(PD.NMPRODIMPFIS,PD.NMPRODUTO) NMPRODUTO,
          PD.CDARVPROD, PG.CDGRUPROMOC, PD.IDPESAPROD,PD.SGUNIDADE, PD.QTTARAPROD,
          FA.CDFAMILISALD, ISNULL(DP.NRORDPROMOPRFIL,1000) NRORDPROMOPRFIL,
          DP.IDOBRPRODSELFIL IDOBRPRODSELEC, IT.CDATAPRODITM, PD.CDBARPRODUTO, PD.IDIMPPRODUTO, 
          DP.IDOBRPRODSELFIL AS OBRGRUPR, PD.IDTIPOCOMPPROD,
          DP.IDPERVALDESFIL AS IDPERCVALOR, DP.VRDESPRPROMOFIL AS VRDESCONTO,
      DP.IDAPLICADESCPRFI AS IDAPLICADESCONTO, DP.IDDESCACRPROFIL AS IDDESCACR
      FROM PRODUTO PD
        LEFT JOIN FAMSALDOPROD FA ON PD.CDPRODUTO = FA.CDPRODUTO AND :CDFILIAL = FA.CDFILIAL
          LEFT JOIN ITMENUCONFTE IT ON IT.CDIDENTBUTON = PD.CDPRODUTO AND IT.CDFILIAL = :CDFILIAL
            AND IT.IDTPBUTTON = '1' AND IT.NRCONFTELA = :NRCONFTELA,
      PRODGRUPROMOC PG
        LEFT JOIN DESGRUPROMPRFIL DP 
         ON DP.CDGRUPROMOC = PG.CDGRUPROMOC
          AND DP.CDPRODUTO = PG.CDPRODUTO
          AND DP.CDPRODPROMOCAO = :CDPRODPROMOCAO
          AND DP.NRSEQGRPROMOFIL = :NRSEQGRPROMO
      WHERE PG.CDPRODUTO = PD.CDPRODUTO
        AND PG.CDGRUPROMOC = :CDGRUPROMOC
      ORDER BY ISNULL(DP.NRORDPROMOPRFIL,1000), PD.CDARVPROD
  ";

  const GET_PRODUCTS_PROM_GROUPS_MENU_NO_PROM_CODE = "
      SELECT
          DISTINCT(PD.CDPRODUTO), ISNULL(PD.NMPRODIMPFIS,PD.NMPRODUTO) NMPRODUTO,
          PD.CDARVPROD, PG.CDGRUPROMOC, PD.IDPESAPROD,PD.SGUNIDADE, PD.QTTARAPROD,
          FA.CDFAMILISALD, ISNULL(DP.NRORDPROMOPR,1000) NRORDPROMOPR,
          DP.IDOBRPRODSELEC IDOBRPRODSELEC, IT.CDATAPRODITM, PD.CDBARPRODUTO, PD.IDIMPPRODUTO, 
          ISNULL(DPPF.IDOBRPRODSELFIL, DP.IDOBRPRODSELEC) AS OBRGRUPR, PD.IDTIPOCOMPPROD 
      FROM PRODUTO PD
        LEFT JOIN FAMSALDOPROD FA ON PD.CDPRODUTO = FA.CDPRODUTO AND :CDFILIAL = FA.CDFILIAL
          LEFT JOIN ITMENUCONFTE IT ON IT.CDIDENTBUTON = PD.CDPRODUTO AND IT.CDFILIAL = :CDFILIAL
            AND IT.IDTPBUTTON = '1' AND IT.NRCONFTELA = :NRCONFTELA,
      PRODGRUPROMOC PG
        LEFT JOIN DESGRUPROMOCPR DP 
         ON DP.CDGRUPROMOC = PG.CDGRUPROMOC
          AND DP.CDPRODUTO = PG.CDPRODUTO
          
          AND DP.NRSEQGRPROMO = :NRSEQGRPROMO
        LEFT JOIN DESGRUPROMPRFIL DPPF
          ON (PG.CDGRUPROMOC = DPPF.CDGRUPROMOC) AND
           (PG.CDPRODUTO = DPPF.CDPRODUTO) 
           
      WHERE PG.CDPRODUTO = PD.CDPRODUTO
        AND PG.CDGRUPROMOC = :CDGRUPROMOC
      ORDER BY ISNULL(DP.NRORDPROMOPR,1000), PD.CDARVPROD
  ";

  const GET_DESC_PROD_FILI = "
    SELECT   IDPERVALDESFIL AS IDPERCVALOR, VRDESPRPROMOFIL AS VRDESCONTO,
      IDAPLICADESCPRFI AS IDAPLICADESCONTO
    FROM DESGRUPROMPRFIL
    WHERE CDFILIAL       = :CDFILIAL
    AND CDPRODPROMOCAO = :CDPRODPROMOCAO
    AND CDGRUPROMOC    = :CDGRUPROMOC
    AND NRSEQGRPROMOFIL= :NRSEQGRPROMO
  ";

  const GET_PRODUCTS_PROM_GROUPS_MENU_NO_FILTER = "
      SELECT
          PD.CDPRODUTO,
           DP.CDPRODPROMOCAO, NRSEQGRPROMO, ISNULL(PD.NMPRODIMPFIS,PD.NMPRODUTO) NMPRODUTO,
          PD.CDARVPROD, PG.CDGRUPROMOC, PD.IDPESAPROD,PD.SGUNIDADE, PD.QTTARAPROD,
          FA.CDFAMILISALD, ISNULL(DP.NRORDPROMOPR,1000) NRORDPROMOPR,
          DP.IDOBRPRODSELEC IDOBRPRODSELEC, IT.CDATAPRODITM, PD.CDBARPRODUTO, PD.IDIMPPRODUTO, 
          ISNULL(DPPF.IDOBRPRODSELFIL, DP.IDOBRPRODSELEC) AS OBRGRUPR, PD.IDTIPOCOMPPROD,
           IT.DSBUTTON, IT.NRPGCONFTAUX, IT.NRBUTTONAUX, IT.NRPGCONFTELA, IT.NRBUTTON
      FROM PRODUTO PD
        LEFT JOIN FAMSALDOPROD FA ON PD.CDPRODUTO = FA.CDPRODUTO AND :CDFILIAL = FA.CDFILIAL
          LEFT JOIN ITMENUCONFTE IT ON IT.CDIDENTBUTON = PD.CDPRODUTO AND IT.CDFILIAL = :CDFILIAL
            AND IT.IDTPBUTTON = '1' AND IT.NRCONFTELA = :NRCONFTELA,
      PRODGRUPROMOC PG
        LEFT JOIN DESGRUPROMOCPR DP 
         ON DP.CDGRUPROMOC = PG.CDGRUPROMOC
          AND DP.CDPRODUTO = PG.CDPRODUTO

        LEFT JOIN DESGRUPROMPRFIL DPPF
          ON (PG.CDGRUPROMOC = DPPF.CDGRUPROMOC) AND
           (PG.CDPRODUTO = DPPF.CDPRODUTO) 

      WHERE PG.CDPRODUTO = PD.CDPRODUTO
      ORDER BY ISNULL(DP.NRORDPROMOPR,1000), PD.CDARVPROD
  ";

  const GET_STORE_PRINTERS = "
    SELECT CDFILIAL, CDLOJA, NRSEQIMPRLOJA, CDIMPRESSORA, NMIMPRLOJA, CDPORTAIMPR, DSIPIMPR, DSIPPONTE
     FROM IMPRLOJA WHERE CDFILIAL = :CDFILIAL AND CDLOJA = :CDLOJA AND DSIPPONTE IS NOT NULL
  ";

  const GET_PRODUCTS_PRINTER_PARAMS = "
    SELECT CDPRODUTO, NRSEQIMPRPROD, NRSEQIMPRPUXA, NRSEQIMPRPROD2
        FROM PRODLOJA
       WHERE CDFILIAL  = :CDFILIAL
         AND CDLOJA    = :CDLOJA
         ";

  const GET_POS_TEF_DATA = "
    SELECT NRCNPJLOJA, DSENDIPSITEF, CDTERTEF, CDLOJATEF, NMCAIXA, CDCAIXA, IDHABCAIXAVENDA FROM CAIXA WHERE
          CDFILIAL = :CDFILIAL
          AND CDLOJA = :CDLOJA
          AND IDATIVO = 'S'
          --AND IDHABCAIXAVENDA IN ('TAA', 'APC')
  ";
  // AND CHARINDEX('TAA', NMCAIXA) > 0

  const GET_PAYMENTS_SHOWABLE = "
    SELECT CDTIPORECE, NMTIPORECE, IDTIPORECE, CDBANCARTCR
      FROM TIPORECE T
    WHERE IDMOSTRARECE = 'S' 
    
    ORDER BY CDTIPORECE
  ";
  // AND CDBANCARTCR IS NOT NULL
 
  const GET_PAYMENTS_LAYOUT_CONFTE = "
    SELECT CDIDENTBUTON, DSBUTTON 
    FROM ITMENUCONFTE IT	
        JOIN CONFTELACAIXA CFTX	
          ON IT.CDFILIAL   = CFTX.CDFILIAL	
         AND IT.NRCONFTELA = CFTX.NRCONFTELA	
         AND CFTX.CDFILICAIXA = :CDFILIAL	
         AND CFTX.CDCAIXA  = :CDCAIXA
         AND IT.IDTPBUTTON = '5'	
         AND IT.NRPGCONFTELA = '1'	
         AND CFTX.DTINIVIGENCIA = CONVERT(DATE, :DTINIVIGENCIA, 120)
    ORDER BY CDIDENTBUTON
  ";

  const GET_PAYMENTS_LAYOT_CAIX = "
    SELECT CDIDENTBUTON, DSBUTTON 
    FROM ITMENUCONFTE IT
    JOIN CAIXA CX
      ON IT.CDFILIAL   = CX.CDFILIAL
      AND IT.NRCONFTELA = CX.NRCONFTELA
      AND CX.CDFILIAL = :CDFILIAL
      AND CX.CDCAIXA  = :CDCAIXA
      AND IT.IDTPBUTTON = '5'
      AND IT.NRPGCONFTELA = '1'	
      ORDER BY CDIDENTBUTON
  ";

  const SQL_GET_SALE_ROUTER = "
     SELECT ENDVENDAROUTER, IDSITUVENDA, IDTPEMISVEND, DTVENDA, IDSTATUSNFCE, NRSEQVENDA, CDOPERADOR, CDSUPERVISOR
       FROM VENDA V
        JOIN CAIXA C
          ON V.CDFILIAL = C.CDFILIAL
           AND V.CDCAIXA = C.CDCAIXA
      WHERE V.CDFILIAL = :CDFILIAL
        AND V.CDCAIXA = :CDCAIXA
         AND (V.NRSEQVENDA = :NRSEQVENDA OR ISNULL(:NRSEQVENDA,'T') = 'T')
         AND V.NRNOTAFISCALCE = :NRNOTAFISCALCE
  ";

  const ORACLE_GET_SALE_ROUTER = "
     SELECT ENDVENDAROUTER, IDSITUVENDA, IDTPEMISVEND, DTVENDA, IDSTATUSNFCE, NRSEQVENDA, CDOPERADOR, CDSUPERVISOR
       FROM VENDA V
        JOIN CAIXA C
          ON V.CDFILIAL = C.CDFILIAL
           AND V.CDCAIXA = C.CDCAIXA
      WHERE V.CDFILIAL = :CDFILIAL
        AND V.CDCAIXA = :CDCAIXA
         AND (V.NRSEQVENDA = :NRSEQVENDA OR OR NVL(:NRSEQVENDA,'T') = 'T')
         AND V.NRNOTAFISCALCE = :NRNOTAFISCALCE
  ";

  const UPDATE_VRCOMISVENDE = "
          UPDATE COMANDAVEN SET VRCOMISVENDE = :VRCOMISVENDE
            WHERE CDFILIAL = :CDFILIAL
              AND NRCOMANDA = :NRCOMANDA
  ";

  const UPDATE_CHILD_ORDER = "
          UPDATE COMANDAVEN 
            SET DSCOMANDAPRI = :DSCOMANDAPRI,
              IDSTCOMANDA = :IDSTCOMANDA
            WHERE CDFILIAL = :CDFILIAL
              AND NRCOMANDA = :NRCOMANDA
  ";

  const GET_CHILD_ORDERS = "
      SELECT DSCOMANDA, NRCOMANDA, NRVENDAREST 
        FROM COMANDAVEN
          WHERE CDFILIAL = :CDFILIAL
           AND DSCOMANDAPRI = :DSCOMANDAPRI
  ";

  const ADD_ITCOMANDAVEN = "
    INSERT INTO ITCOMANDAVEN (
      CDFILIAL, NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, CDPRODUTO, QTPRODCOMVEN, VRPRECCOMVEN, 
      TXPRODCOMVEN, IDSTPRCOMVEN, VRDESCCOMVEN, NRLUGARMESA, IDPRODIMPFIS, CDLOJA, VRACRCOMVEN, 
      NRSEQPRODCOM, NRSEQPRODCUP, VRPRECCLCOMVEN, CDCAIXACOLETOR, CDPRODPROMOCAO, CDVENDEDOR, 
      NRINSCRCONS, CDSENHAPED, NRATRAPRODCOVE, IDORIGEMVENDA, DSOBSPEDDIGCMD, IDIMPPRGRPROMO,
      DTHRINCOMVEN, DSCOMANDAORI, NRCOMANDAORI, NRPRODCOMORI
    )
    VALUES (
      :CDFILIAL, :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :CDPRODUTO, :QTPRODCOMVEN, :VRPRECCOMVEN, 
      :TXPRODCOMVEN, :IDSTPRCOMVEN, :VRDESCCOMVEN, :NRLUGARMESA, :IDPRODIMPFIS, :CDLOJA, :VRACRCOMVEN, 
      :NRSEQPRODCOM, :NRSEQPRODCUP, :VRPRECCLCOMVEN, :CDCAIXACOLETOR, :CDPRODPROMOCAO, :CDVENDEDOR, 
      :NRINSCRCONS, :CDSENHAPED, :NRATRAPRODCOVE, :IDORIGEMVENDA, :DSOBSPEDDIGCMD, :IDIMPPRGRPROMO,
      GETDATE(), :DSCOMANDAORI, :NRCOMANDAORI, :NRPRODCOMORI
    )
  ";

  const DELETE_JOIN_ORDER_ITEMS = "
    DELETE FROM ITCOMANDAVEN 
      WHERE CDFILIAL = :CDFILIAL
        AND NRCOMANDA = :NRCOMANDA
        AND NRVENDAREST = :NRVENDAREST
        AND DSCOMANDAORI = :DSCOMANDAORI
        AND NRCOMANDAORI = :NRCOMANDAORI
  ";

  const BUSCA_ITENS_SUGESTAO = "
        SELECT SV.IDSUGESTAOVENDA, SV.CDPRODUTO, SI.CDSUGESTAOITEM, SI.IDSUGESTAOTIPO, SI.NRORDEMSUG
          FROM SUGESTAOVENDA SV
        JOIN SUGESTAOITEM SI
          ON SI.IDSUGESTAOVENDA = SV.IDSUGESTAOVENDA
        JOIN CONFTELACAIXA CF
			    ON SV.NRCONFTELA = CF.NRCONFTELA
			      AND SV.CDFILIAL = CF.CDFILIAL
        WHERE CF.CDFILICAIXA = :CDFILIAL
          AND CF.CDCAIXA = :CDCAIXA
          AND SV.CDPRODUTO IN (:ARRAYPRODUTOS)
        ORDER BY SI.NRORDEMSUG
  ";

  const CANCEL_PAYMENTS = "
      UPDATE MOVCAIXADLV
         SET IDTIPOMOVIVEDLV = 'C' 
        WHERE CDFILIAL = :CDFILIAL
          AND NRVENDAREST = :NRVENDAREST
  ";

  const GET_USE_EXT_CONS = "
      SELECT IDEXTCONSONLINE, NRORG 
        FROM PARAVEND 
       WHERE CDFILIAL = :CDFILIAL
  ";

  const INSERT_PRODBLOQVNDTAA = "
    INSERT INTO PRODBLOQVNDTAA(CDFILIAL, CDLOJA, CDOPERADOR, CDPRODUTO, NRDIASEMANABLOQ, NRORG)
      VALUES(:CDFILIAL, :CDLOJA, :CDOPERADOR, :CDPRODUTO, 'T', :NRORG)
  ";

  const DELETE_PRODBLOQVNDTAA = "
    DELETE FROM PRODBLOQVNDTAA 
      WHERE CDFILIAL = :CDFILIAL
        AND CDLOJA = :CDLOJA
        AND CDPRODUTO = :CDPRODUTO
  ";

  const GET_JOINED_ORDERS_CONSUMERS = "
    SELECT VR.CDCLIENTE, VR.CDCONSUMIDOR, CDIDCONSUMID, NMCONSUMIDOR 
      FROM COMANDAVEN CV
        JOIN VENDAREST VR
          ON VR.CDFILIAL = CV.CDFILIAL
        AND VR.NRVENDAREST = CV.NRVENDAREST
        LEFT JOIN CONSUMIDOR CO
        ON VR.CDCLIENTE = CO.CDCLIENTE
        AND VR.CDCONSUMIDOR = CO.CDCONSUMIDOR
      WHERE DSCOMANDAPRI = :DSCOMANDA
    ";

  const UPDATE_CONSUMER_ORDER = "
    UPDATE VENDAREST SET CDCLIENTE = :CDCLIENTE, CDCONSUMIDOR = :CDCONSUMIDOR
      WHERE CDFILIAL = :CDFILIAL
        AND NRVENDAREST = :NRVENDAREST
  ";

  const GET_FAMILYS = "
		SELECT IDSALDNEGFAM, FIL.CDFAMILISALD, CDFILIAL, NMFAMILISALD, NRORDAPRSALD, VRCONSDIAFAM
      FROM FAMSALDOFILI FIL
        JOIN FAMILIASALDO FAM ON FIL.CDFAMILISALD = FAM.CDFAMILISALD
    WHERE FIL.CDFILIAL = :CDFILIAL 
  ";

  const GET_CONSUMER_LIMITS = "
        SELECT IDVERSALDCON, VRMAXCREDCONS, VRLIMCREDCONS
          FROM CONSUMIDOR
          WHERE CDCLIENTE = :CDCLIENTE
            AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";
  
  const GET_ITEMS_PRINT_CANCEL = "
      SELECT IT.CDPRODUTO, IT.QTPRODCOMVEN, IT.VRPRECCOMVEN, PR.CDPORIMPPROD,
              PR.IDIMPCANITEM, PT.NMPRODUTO, VE.NRMESA, IT.DSCOMANDAORI,
              IT.NRPRODCOMORI, IT.NRCOMANDAORI, PR.NRSEQIMPRPROD, IT.CDLOJA,
              IT.CDFILIAL, IP1.IDMODEIMPRES, IL1.NRSEQIMPRLOJA, IL1.CDPORTAIMPR,
              MP1.DSENDPORTA, IL1.DSIPIMPR, IL1.DSIPPONTE, PR.NRSEQIMPRPROD2,
              IP2.IDMODEIMPRES AS IDMODEIMPRES2, IL2.NRSEQIMPRLOJA AS NRSEQIMPRLOJA2,
              IL2.CDPORTAIMPR AS CDPORTAIMPR2, MP2.DSENDPORTA AS DSENDPORTA2,
              IL2.DSIPIMPR AS DSIPIMPR2, IL2.DSIPPONTE AS DSIPPONTE2, IL1.NMIMPRLOJA, IL2.NMIMPRLOJA AS NMIMPRLOJA2
            FROM PRODUTO PT, VENDAREST VE,
              ITCOMANDAVEN IT LEFT JOIN PRODLOJA PR
                                    ON IT.CDPRODUTO = PR.CDPRODUTO
                                    AND IT.CDFILIAL  = PR.CDFILIAL
                                    AND IT.CDLOJA    = PR.CDLOJA

                              LEFT JOIN IMPRLOJA IL1
                                    ON PR.CDFILIAL      = IL1.CDFILIAL
                                    AND PR.CDLOJA        = IL1.CDLOJA
                                    AND PR.NRSEQIMPRPROD = IL1.NRSEQIMPRLOJA

                              LEFT JOIN IMPRLOJA IL2
                                    ON PR.CDFILIAL       = IL2.CDFILIAL
                                    AND PR.CDLOJA         = IL2.CDLOJA
                                    AND PR.NRSEQIMPRPROD2 = IL2.NRSEQIMPRLOJA

                              LEFT JOIN IMPRESSORA IP1
                                    ON IL1.CDIMPRESSORA = IP1.CDIMPRESSORA

                              LEFT JOIN IMPRESSORA IP2
                                    ON IL2.CDIMPRESSORA = IP2.CDIMPRESSORA

                              LEFT JOIN MAPIMPRLOJA MP1
                                    ON IL1.CDFILIAL    = MP1.CDFILIAL
                                    AND IL1.CDLOJA      = MP1.CDLOJA
                                    AND IL1.CDPORTAIMPR = MP1.CDPORTAIMPR

                            LEFT JOIN MAPIMPRLOJA MP2
                                    ON IL2.CDFILIAL    = MP2.CDFILIAL
                                    AND IL2.CDLOJA      = MP2.CDLOJA
                                    AND IL2.CDPORTAIMPR = MP2.CDPORTAIMPR
            WHERE IT.CDFILIAL      = :CDFILIAL
            AND IT.NRCOMANDA     = :NRCOMANDA
            AND IT.NRVENDAREST   = :NRVENDAREST
            AND IT.CDPRODUTO     = PT.CDPRODUTO
            AND IT.CDFILIAL      = VE.CDFILIAL
            AND IT.NRVENDAREST   = VE.NRVENDAREST
  ";

  const GET_POS_PRINT_CANCEL = "
      SELECT  CX.IDIMPPEDPRCIGE
      FROM PARAVEND PR, LOJA LJ,
      CAIXA CX LEFT JOIN IMPRLOJA IL
        ON CX.CDFILIAL = IL.CDFILIAL
        AND CX.CDLOJA = IL.CDLOJA
        AND CX.NRSEQIMPRLOJA3 = IL.NRSEQIMPRLOJA
      LEFT JOIN IMPRESSORA IM
        ON IL.CDIMPRESSORA = IM.CDIMPRESSORA
      WHERE CX.CDFILIAL = :CDFILIAL
        AND CX.CDCAIXA  = :CDCAIXA
        AND PR.CDFILIAL = LJ.CDFILIAL
        AND CX.CDFILIAL = LJ.CDFILIAL
        AND CX.CDLOJA   = LJ.CDLOJA
  ";

  const GET_FID_UDS = "
      SELECT IDUTILFIDUDS  FROM PARAVEND WHERE CDFILIAL = :CDFILIAL
  ";

  const GET_AVAILABLE_GROUPS = "
    SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,
    IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, 
    IT.DSENDEIMG, IT.DSENDEIMGAUX, IT.DSITMENUVENDA
      FROM ITMENUCONFTE IT
        WHERE DSENDEIMG IS NOT NULL
        AND IT.IDTPBUTTON = '2'
    ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON
  ";
  const GET_AVAILABLE_SUBGROUPS = "
    SELECT IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA, IT.NRPGCONFTAUX,
    IT.NRBUTTON, IT.NRBUTTONAUX, IT.IDTPBUTTON, IT.IDTPBUTONAUX, 
    IT.DSENDEIMG, IT.DSENDEIMGAUX, IT.DSITMENUVENDA
      FROM ITMENUCONFTE IT
        WHERE DSENDEIMG IS NOT NULL
        AND IT.IDTPBUTTON = 'I'
    ORDER BY IT.NRPGCONFTELA, IT.NRBUTTON
  ";

  const GET_LATEST_SALES = "
    SELECT CDFILIAL, CDCAIXA, NRNOTAFISCALCE, NRSEQVENDA, 
          VRTOTVENDA, DTVENDA, NRCOMANDAVND, CDSENHAPED 
    FROM VENDA
      WHERE DTVENDA BETWEEN  :P_INICIAL  AND  :P_FINAL
    ORDER BY CDFILIAL, CDCAIXA, DTVENDA
    ";

  const GET_PATMENTS_SALES = "
    SELECT MV.CDTIPORECE, TR.NMTIPORECE, MV.VRMOVIVEND, CDNSUHOSTTEF
      FROM MOVCAIXA MV
        JOIN TIPORECE TR
          ON MV.CDTIPORECE = TR.CDTIPORECE
    WHERE MV.CDFILIAL =:CDFILIAL
      AND MV.CDCAIXA = :CDCAIXA
      AND MV.NRSEQVENDA = :NRSEQVENDA
    ";
    
  const CHECK_TABLE = "
    SELECT DISTINCT(VR.NRMESA) FROM VENDAREST VR 
      JOIN COMANDAVEN CV 
        ON VR.NRVENDAREST = CV.NRVENDAREST
          AND VR.CDFILIAL = CV.CDFILIAL
          AND VR.CDLOJA = CV.CDLOJA
      WHERE VR.CDFILIAL = :CDFILIAL
      AND VR.CDLOJA = :CDLOJA
      AND VR.NRMESA = :NRMESA
      AND CV.IDORGCMDVENDA LIKE :IDORGCMDVENDA  
    ";

  const CHECK_COMANDA = "
    SELECT DSCOMANDA FROM COMANDAVEN
      WHERE CDFILIAL = :CDFILIAL
       AND CDLOJA = :CDLOJA
       AND DSCOMANDA = :DSCOMANDA
  ";
}
